/* thr.h */

#ifndef THR_H
#define THR_H

#ifdef USE_SOLAIRS_THREAD

# include <thread.h>
# include <synch.h>

# define pthread_t		thread_t
# define pthread_exit		thr_exit
# define pthread_mutex_t	mutex_t
# define pthread_cond_t		cond_t
# define pthread_mutex_lock	mutex_lock
# define pthread_mutex_unlock	mutex_unlock
# define pthread_cond_wait	cond_wait
# define pthread_cond_signal	cond_signal
# define pthread_cond_broadcast	cond_broadcast

# define pthread_mutex_init(p1, p2)	mutex_init(p1, USYNC_THREAD, NULL)
# define pthread_cond_init(p1, p2)	cond_init(p1, USYNC_THREAD, NULL)
/* : p2  NULL ǤʤȤʤ */

#else

# include <pthread.h>

# if 0
# define thread_t	pthread_t
# define thr_exit	pthread_exit
# define mutex_t	pthread_mutex_t
# define cond_t 	pthread_cond_t
# define mutex_lock	pthread_mutex_lock
# define mutex_unlock	pthread_mutex_unlock
# define cond_wait	pthread_cond_wait
# define cond_signal	pthread_cond_signal
# define cond_broadcast	pthread_cond_broadcast

# define mutex_init(p1, p2, p3) pthread_mutex_init(p1, NULL)
# define cond_init(p1, p2, p3)	pthread_cond_init(p1, NULL)
/* : p2  USYNC_THREAD ǤʤȤʤ */
# endif

#endif

#endif /* THR_H */
