/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  vbuf.h
    ĹХåե
*********************************************************************/

#ifndef VBUF_H
#define VBUF_H

// ĹХåե
// Ȥ:
//   ХåեƬݥ󥿤: void* getbuf();
//   Хåե礭:       int getsize();
//   ХåեκǸɲ:         int append(void* data, int size);
// : ХåեƬݥ󥿤 append Ѥǽ

#include <stdlib.h>
#include <string.h>

#define VBUF_INIT_SIZE 1024

class vbuf {
  private:
    void* buf;  // Хåեμ
    int   size; // Хåե礭
    void* ptr;  // ߤΥݥ (append ˻Ȥ)
    int   used; // ߻ȤƤ礭 (ptr  buf κ)

  public:
    vbuf() {
	size = VBUF_INIT_SIZE;
	buf  = malloc(size);
	ptr  = buf;
	used = 0;
    };
    ~vbuf() {
	if (buf != NULL) free(buf);
    };
    void* getbuf() { return buf; };
    int   getsize() { return used; };

    int   append(void* data, int size_param)
    {
	if (buf == NULL) return -1;
	int need = used + size_param;
	if (need > size) {
	    int newsize = size;
	    while (need > newsize) newsize *= 2;
	    void* newbuf;
	    if ((newbuf = realloc(buf, newsize)) == NULL) {
		return -1;
	    }
	    buf  = newbuf;
	    size = newsize;
	    ptr  = (void*)((char*)buf + used);
	}
	memcpy(ptr, data, size_param);
	ptr = (void*)((char*)ptr + size_param);
	used += size_param;
	return 0;
    }
};

#endif /* VBUF_H */
