/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  G_split.cc
    ʬ䡢
*********************************************************************/

#include "GrayImage.h"

// ʬ䤹

int
GrayImage::split(int xn, int xunit, int yn, int yunit, int ca, Image* divimg[])
// xn:     xʬ
// xunit:  xκǾʬñ
// yn:     yʬ
// yunit:  yκǾʬñ
// ca:     cache礭
// divimg: ʬβ()
{
#ifdef DEBUG
    fprintf(stderr, "GrayImage::split: sprit in\n");
#endif
    // ʬñ̤θĿ
    int xunitn = (width  + xunit - 1) / xunit;
    int yunitn = (height + yunit - 1) / yunit;

    // ʬȹ⤵ ([xy]unit ñ)
    int x_size = xunitn / xn;
    int y_size = yunitn / yn;

    // ޤ ([xy]unit ñ)
    int x_rest = xunitn % xn;
    int y_rest = yunitn % yn;

    // ϲΥѥ᡼
    int xu, yu; // unit ñ
    int x, y;   // ñ
    int w, h;   // ñ
    for (y = 0, yu = 0; yu < yn; yu++, y += h) {
	for (x = 0, xu = 0; xu < xn; xu++, x+= w) {
	    int xs2 = x_size; if (xu < x_rest) xs2++;
	    int ys2 = y_size; if (yu < y_rest) ys2++;
	    w = xs2 * xunit;
	    h = ys2 * yunit;
	    divimg[yu*xn + xu]->setparam(w, h, hot_x + x, hot_y + y, type, ca);
	    divimg[yu*xn + xu]->setorgsize(width, height);
	}
    }

    // 
    int*     iimgf; // int image from ʬ
    int*     iimgt; // int image to   ʬ
    float*   fimgf;
    float*   fimgt;
    complex* cimgf;
    complex* cimgt;

    Image* imgp;

    switch (type) {
      case pt_int:     iimgf = (int*)    this->get_image(); break;
      case pt_real:    fimgf = (float*)  this->get_image(); break;
      case pt_complex: cimgf = (complex*)this->get_image(); break;
      default:
	fprintf(stderr, "GrayImage::split: unknown type %d\n", type);
	return FAIL;
    }

    int i, j;
    for (i = 0; i < yn; i++) {
	for (j = 0; j < xn; j++) {
	    imgp = divimg[i*xn+j];

	    switch (type) {
	      case pt_int:     iimgt = (int*)    imgp->get_image(); break;
	      case pt_real:    fimgt = (float*)  imgp->get_image(); break;
	      case pt_complex: cimgt = (complex*)imgp->get_image(); break;
	      default: break;
	    }

	    int tca = imgp->get_cache();
	    int tw  = imgp->get_width();
	    int th  = imgp->get_height();
	    int thx = imgp->get_hot_x();
	    int thy = imgp->get_hot_y();

	    int org_x, org_y; // κɸ

	    for (y = -tca; y < th+tca; y++) {
		for (x = -tca; x < tw+tca; x++) {
		    org_x = x + thx;
		    org_y = y + thy;

		    // Ϥ߽ФƤ뤫Ĵ٤
		    // ˡ1᤯ͤȤ
		    if (org_x < -cache) org_x = -cache;
		    if (org_x >= width + cache*2) org_x = width + cache*2 - 1;
		    if (org_y < -cache) org_y = -cache;
		    if (org_y >= height+ cache*2) org_y = height+ cache*2 - 1;

		    int tidx = (y+tca)*(tw+tca*2) + (x+tca);
		    int fidx = (org_y+cache)*(width+cache*2) + (org_x+cache);

		    if (org_x < -cache || org_x >= width + cache ||
			org_y < -cache || org_y >= height + cache)
		    {
			// Ϥ߽ФƤ
			// ˡ20ˤ
			if (type == pt_int) {
			    iimgt[tidx] = 0;
			} else if (type == pt_real) {
			    fimgt[tidx] = 0;
			} else {
			    cimgt[tidx] = 0;
			}
		    } else {
			if (type == pt_int) {
			    iimgt[tidx] = iimgf[fidx];
			} else if (type == pt_real) {
			    fimgt[tidx] = fimgf[fidx];
			} else {
			    cimgt[tidx] = cimgf[fidx];
			}
		    }
		}
	    }

#ifdef DEBUG
	    fprintf(stderr, "GrayImage::split: (%d %d) end\n",
		    imgp->get_image_id(), imgp->get_div_id());
#endif
	}
    }

    return OKAY;
}

// 礹
int
GrayImage::join(int n, Image* divimg[])
// n: ʬο, divimg: ʬ
{
    int xmin = divimg[0]->get_hot_x();
    int ymin = divimg[0]->get_hot_y();
    int xmax = xmin + divimg[0]->get_width();   // ɸ + 1
    int ymax = ymin + divimg[0]->get_height();  //

    // β礭η
    int i;
    int x, y, xx, yy;

    for (i = 1; i < n; i++) {
	xx = divimg[i]->get_hot_x();
	yy = divimg[i]->get_hot_y();
	x  = xx + divimg[i]->get_width();
	y  = yy + divimg[i]->get_height();
	if (xx < xmin) xmin = xx;
	if (yy < ymin) ymin = yy;
	if (x  > xmax) xmax = x;
	if (y  > ymax) ymax = y;
    }

#ifdef DEBUG
    fprintf(stderr, "GrayImage::join: join param: (%d, %d) - (%d, %d)\n",
	    xmin, xmax-1, ymin, ymax-1);
#endif

    this->setparam(xmax - xmin, ymax - ymin, xmin, ymin,
		   divimg[0]->get_type(), 0);
    this->setorgsize(xmax - xmin, ymax - ymin);

    // 
    int*     iimgf; // int image from 
    int*     iimgt; // int image to   
    float*   fimgf;
    float*   fimgt;
    complex* cimgf;
    complex* cimgt;

    if (type == pt_int) {
	iimgt = (int*)image;
    } else if (type == pt_real) {
	fimgt = (float*)image;
    } else if (type == pt_complex) {
	cimgt = (complex*)image;
    }

    for (i = 0; i < n; i++) {
	int fx;
	int fy;
	int fw  = divimg[i]->get_width();
	int fh  = divimg[i]->get_height();
	int fhx = divimg[i]->get_hot_x();
	int fhy = divimg[i]->get_hot_y();
	int fca = divimg[i]->get_cache();

	if (type == pt_int) {
	    iimgf = (int*)divimg[i]->get_image();
	} else if (type == pt_real) {
	    fimgf = (float*)divimg[i]->get_image();
	} else if (type == pt_complex) {
	    cimgf = (complex*)divimg[i]->get_image();
	}

	for (fy = 0; fy < fh; fy++) {
	    for (fx = 0; fx < fw; fx++) {
		int tx = fhx + fx;
		int ty = fhy + fy;
		if (tx >= -cache && tx < width+cache &&
		    ty >= -cache && ty < height+cache)
		{
		    int fidx = (fy+fca)*(fw+fca*2) + (fx+fca);
		    int tidx = (ty+cache)*(width+cache*2) + (tx+cache);
		    if (type == pt_int) {
			iimgt[tidx] = iimgf[fidx];
		    } else if (type == pt_real) {
			fimgt[tidx] = fimgf[fidx];
		    } else if (type == pt_complex) {
			cimgt[tidx] = cimgf[fidx];
		    }
		}
	    }
	}
    }

    return OKAY;
}
