/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  GrayImage.h
    ǻø򰷤饹
    Image 饹Υ֥饹
*********************************************************************/

#ifndef GRAYIMAGE_H
#define GRAYIMAGE_H

#include <stdlib.h>
#include "Image.h"

class GrayImage:public Image  // ǻø
{
  private:
    void*	image;

    image_type g_class() { return it_gray; };

  public:
    /**** 󥹥ȥ饯 ****/
    GrayImage(int i_id, int d_id):Image(i_id, d_id) {
	image = NULL;
    };

    /**** ǥȥ饯 ****/
    ~GrayImage() {
	if (image != NULL) {
	    free(image);
	}
    };

    // ꤷѤΰƤ ()
    void setsize(int w, int h, pixel_type ty, int ca);

    // ξ (礭) ֤
    int get_image_info(image_info& i);

    // ᡼Ϥ顢ʬΥ᡼Ϥʤʤ
    Image& operator = (Image& a)
    {
	image_id   = a.get_image_id();
	div_id     = a.get_div_id();
	width      = a.get_width();
	height     = a.get_height();
	org_width  = a.get_org_width();
	org_height = a.get_org_height();
	hot_x      = a.get_hot_x();
	hot_y      = a.get_hot_y();
	type       = a.get_type();
	cache      = a.get_cache();

	if (image != NULL) {
	    free(image);
	}
	image = a.get_image();
	((GrayImage*)&a)->image = NULL;
	return *this;
    };

    // кɸ βǤΰ (x, y) Фɤ߽
    complex	agetpixel(int x, int y, pixel_type& t);
    float	agetpixelr(int x, int y);
    int 	agetpixeli(int x, int y);
    void	asetpixel(int x, int y, complex val);
    void	asetpixel(int x, int y, float val);
    void	asetpixel(int x, int y, int val);

    // ʬǤΰ (x, y) Фɤ߽ ̾ϤȤ
    complex	getpixel(int x, int y, pixel_type& t);
    float	getpixelr(int x, int y);
    int 	getpixeli(int x, int y);
    void	setpixel(int x, int y, complex val);
    void	setpixel(int x, int y, float val);
    void	setpixel(int x, int y, int val);

    // boundary check դɤ߽
    int readint(int job_id, int image_no, boundary_type b,
		int x, int y, int def = 0);
    float readfloat(int job_id, int image_no, boundary_type b,
		    int x, int y, float def = 0);
    complex readcomplex(int job_id, int image_no, boundary_type b,
			int x, int y, complex def = 0);

    // 
    void*   get_image() {
	return image;
    };

    // ɽ
    int display();
    int cdisplay(GrayImage* rgb_image_array[]);

    // ɤ߹ (G_file.cc)
    int load(char* filename); // 쥤
    int cload(char* filename, GrayImage* rgb_img_array[]); // 顼

    // ¸
    // ե
    int save(char* filename, int mode); // mode 0:vios obj, 1:pgm
    int csave(char* filename, int mode, GrayImage* rgb_img_array[]);
    // δؿ
    // save ΤȤϥեءdisp ΤȤϥؽ񤯴ؿꤹ
    int save_through_func(int (*outfunc)(void* buf, int size, void* arg),
			  void* arg, int mode);
    int csave_through_func(int (*outfunc)(void* buf, int size, void* arg),
			   void* arg, int mode, GrayImage* rgb_img_array[]);

    // ʬ䡦 (G_split.cc)
    int split(int xn, int xunit, int yn, int yunit, int cache, Image* out[]);
    int join(int n, Image* na[]);

    // ǥХå
    virtual void print_image() {
	int x, y, i;
	i = 0;
	for (y = 0; y < height + cache*2; y++) {
	    for (x = 0; x < width + cache*2; x++) {
		if (type == pt_int) {
		    fprintf(stderr, "%3d ", ((int*)image)[i]);
		} else if (type == pt_real) {
		    fprintf(stderr, "%6g ", ((float*)image)[i]);
		}
		i++;
	    }
	    printf("\n");
	}
    };
};

#endif /* GRAYIMAGE_H */
