/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  ObjList.cc
    δ
*********************************************************************/

#include "ObjList.h"
#include "Image.h"

// 󥹥ȥ饯 & ǥȥ饯

ObjectList::ObjectList()
{
    next  = NULL;
    image = NULL;
}

ObjectList::ObjectList(Image* img, ObjectList* n)
{
    next  = n;
    image = img;
}

ObjectList::~ObjectList()
{
    delete image;
    delete next;
}

// ᥽å

//  ID i_id, d_id ĥΡɤΰļΥΡɤ֤
ObjectList*
ObjectList::search_prev(int i_id, int d_id)
{
    ObjectList *p;
    for (p = this; p->next != NULL; p = p->next) {
	if (p->next->image != NULL &&
	    p->next->image->have_id(i_id, d_id) == OKAY)
	{
	    return p;
	}
    }
    return NULL;
}

//  ID i_id, d_id ĥΡɤ֤
ObjectList*
ObjectList::search(int i_id, int d_id)
{
    ObjectList* p = search_prev(i_id, d_id);
    if (p != NULL) {
	return p->next;
    }
    return NULL;
}

int
ObjectList::append(Image* img)
{
    if (img == NULL) {
	return FAIL;
    } else {
	next = new ObjectList(img, next);
	return OKAY;
    }
}

int
ObjectList::remove(int i_id, int d_id)
{
    ObjectList* prev = search_prev(i_id, d_id);
    if (prev != NULL) {
	ObjectList* tmp = prev->next;
	prev->next = tmp->next;
	tmp->next = NULL; delete tmp;
	return OKAY;
    } else {
	return FAIL;
    }
}

int
ObjectList::remove(Image* img)
{
    return remove(img->get_image_id(), img->get_div_id());
}

Image*
ObjectList::get(int i_id, int d_id)
{
    ObjectList* p = search(i_id, d_id);
    if (p == NULL) return NULL;
    else 	   return p->image;
}

// for debug
void
ObjectList::print()
{
    ObjectList* p;
    for (p = next; p != NULL; p = p->next) {
	p->image->print();
    }
}
