/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  array.cc
    IPU-p & C++ ˤ⥸塼ǻȤ (Хѿ)
*********************************************************************/

#include <stdlib.h>
#include "array.h"
#include "msgqueue.h"
#include "jobid.h"
#include "waitlist.h"
#include "unify.h"

waitlist array_read_list;
waitlist array_lock_list;
waitlist array_unlock_list;
msgqueue array_id_q;
waitlist global_id_list;
extern msgqueue send_q, trans_q;
extern int my_ipu_no;
unify_list unify_l;

int
array::get_new_array_id()
{
    ipu_ipu msg;
    int id;

    msg.to_om = new ipu_om;

    msg.to_om->type = p_io_array_id_request;
    msg.to_om->size = 0;
    send_q.putmsg(msg);

    array_id_q.getmsg(msg);
    id = msg.a_info->array_id;
    delete msg.a_info;

    return id;
}

// ᥤեƤФ
array::array(array_type t, int s)
{
    data = NULL;
    set_param(t, s);
    sub_id = -1; // ޥ
    pthread_mutex_init(&user_lock, NULL);
}

// ⥸塼⤫ƤФ륰Хѿ
array::array(int job_id_, int no, array_type t, int s)
// no: Υ⥸塼ǤΥХѿֹ
{
    data = NULL;
    set_param(t, s);
    job_id = job_id_;
    ipu_ipu msg;
    pthread_mutex_init(&user_lock, NULL);

    // OM 
    msg.to_om = new ipu_om;
    msg.to_om->type = p_io_create_global_var;
    msg.a_info = new array_id_info;
    msg.a_info->job_id = job_id;
    msg.a_info->sub_id = no;
    send_q.putmsg(msg);

    // ֻԤ
    int aid, sid, sub_num;

#ifdef DEBUG
    fprintf(stderr, "array::array: %d: send id request\n", job_id / 10000);
#endif
    array_id_info* a_info;
    a_info = (array_id_info*)global_id_list.wait(job_id, no);
#ifdef DEBUG
    fprintf(stderr, "array::array: %d: send id return\n", job_id / 10000);
#endif

    aid     = a_info->array_id;
    sid     = jobid_to_ip1no(job_id); //a_info->sub_id;
    sub_num = a_info->job_id;
    delete a_info;

    array_id = aid;
    sub_id   = sid;
    n_subs   = sub_num;

#ifdef DEBUG
    fprintf(stderr, "array::array: %d: get id, (%d, %d)\n",
	    job_id / 10000, aid, sid);
#endif
    AL.append(this);

    if (sub_id == 0) {
	// ޥĤ
	array* arr_org;
	arr_org = new array(type, size);
	arr_org->set_array_id(array_id);
	arr_org->set_sub_id(-1);
	arr_org->set_sub_num(sub_num);
	void* data_org = arr_org->get_ptr();
	memcpy(data_org, data, size * get_width());
	AL.append(arr_org);
    }
}

// 桼ץफΥå׵
int
array::lock()
{
    if (my_ipu_no == 0) {
	//  IPU Τ
	array* arr;
	// IPUˤޥѿõ
	arr = AL.search(array_id, -1);
	arr->lock_prog();
    } else {
	// å׵Ф
	ipu_ipu msg;
	msg.t_msg = new trans_msg;
	msg.t_msg->type   = p_ii_array_lock;
	msg.t_msg->ipu_no = 0;
	msg.a_info = new array_id_info;
	msg.a_info->job_id   = job_id;
	msg.a_info->array_id = array_id;
	msg.a_info->sub_id   = sub_id;
	trans_q.putmsg(msg);

	array_lock_list.wait(job_id);
    }
    return 0;
}

// 桼ץफΥå׵
int
array::unlock()
{
    if (my_ipu_no == 0) {
	// ΤäƤ
	array* arr;
	// IPUˤޥѿõ
	arr = AL.search(array_id, -1);
	if (arr == NULL) {
	}
	arr->unlock_prog();
    } else {
	// å׵Ф
	ipu_ipu msg;
	msg.t_msg = new trans_msg;
	msg.t_msg->type   = p_ii_array_unlock;
	msg.t_msg->ipu_no = 0;
	msg.a_info = new array_id_info;
	msg.a_info->job_id   = job_id;
	msg.a_info->array_id = array_id;
	msg.a_info->sub_id   = sub_id;
	trans_q.putmsg(msg);

	array_unlock_list.wait(job_id);
    }
    return 0;
}

// 桼Υå׵ºݤ˥å
int
array::lock_prog()
{
    return pthread_mutex_lock(&user_lock);
}

int
array::unlock_prog()
{
    return pthread_mutex_unlock(&user_lock);
}

// 桼ץफɤ߹׵
int
array::read()
{
    return read(0, size);
}

int
array::read(int i)
{
    return read(i, 1);
}

int
array::read(int i, int n)
{
    if (my_ipu_no == 0) {
	//  IPU ˥ޥ󤬤
	array* arr = AL.search(array_id, -1);
	if (arr == NULL) {
	    fprintf(stderr, "array::read: AL.serach failed\n");
	    return FAIL;
	}
	int w = get_width();
	int idx = i * w;
	void* from = (char*)arr->get_ptr() + idx;
	void* to   = (char*)data           + idx;
	memcpy(to, from, w*n);
	return 0;
    } else {
	// ޥäƤ IPU ɤ߹׵
	ipu_ipu msg;
	msg.t_msg = new trans_msg;
	msg.t_msg->type   = p_ii_array_read;
	msg.t_msg->ipu_no = 0;
	msg.a_info = new array_id_info;
	msg.a_info->job_id   = job_id;
	msg.a_info->array_id = array_id;
	msg.a_info->sub_id   = sub_id;
	msg.ad_info = new array_data_info;
	msg.ad_info->index  = i;
	msg.ad_info->width  = get_width();
	msg.ad_info->number = n;
	msg.ad_info->need_signal = 1;
	trans_q.putmsg(msg);

	array_read_list.wait(job_id);
    }

    return 0;
}

int
array::write()
{
    return write(0, size);
}

int
array::write(int i)
{
    return write(i, 1);
}

int
array::write(int i, int n)
{
    if (my_ipu_no == 0) {
	//  IPU ˥ޥ󤬤
	array* arr = AL.search(array_id, -1);
	if (arr == NULL) {
	    fprintf(stderr, "array::write: AL.serach failed\n");
	    return FAIL;
	}
	int w = get_width();
	int idx = i * w;
	void* from = (char*)data           + idx;
	void* to   = (char*)arr->get_ptr() + idx;
	memcpy(to, from, w*n);
	return 0;
    } else {
	// ޥäƤ IPU 
	ipu_ipu msg;
	msg.t_msg = new trans_msg;
	msg.t_msg->type   = p_ii_array_write;
	msg.t_msg->ipu_no = 0;
	msg.a_info = new array_id_info;
	msg.a_info->job_id   = job_id;
	msg.a_info->array_id = array_id;
	msg.a_info->sub_id   = -1;
	msg.ad_info = new array_data_info;
	msg.ad_info->index  = i;
	msg.ad_info->width  = get_width();
	msg.ad_info->number = n;
	msg.ad_info->need_signal = 0;
	msg.t_msg->size = get_width() * n;
	msg.buf = (char*)data + i*get_width();
	trans_q.putmsg(msg);
    }

    return 0;
}

int
array::unify(unify_type ut)
{
    if (my_ipu_no == 0) {
	//  IPU ˥ޥ󤬤
	// Ȥ
	int siz = size * get_width();
	char* buf = new char[siz];
	memcpy(buf, data, siz);
	unify_l.append(array_id, buf);
	if (sub_id == 0) {
	    // Ԥ
	    unify_l.unify(array_id, this, ut);
	}
    } else {
	// ޥäƤ IPU 
	ipu_ipu msg;
	msg.t_msg = new trans_msg;
	msg.t_msg->type   = p_ii_array_unify;
	msg.t_msg->ipu_no = 0;
	msg.a_info = new array_id_info;
	msg.a_info->job_id   = job_id;
	msg.a_info->array_id = array_id;
	msg.a_info->sub_id   = 0;
	msg.t_msg->size = size * get_width();
	msg.buf = (char*)data;

	trans_q.putmsg(msg);
    }
    return 0;
}

// ºݤԤʬ
int
array::unify_prog(void** arrs, unify_type ut)
{
    int    arr_no;
    int    i;
    int    ival, ival2;
    float  fval, fval2;
    int*   ito;
    float* fto;
    array* arr;
    int    stick;

    arr = AL.search(array_id, -1);
    if (arr == NULL) {
	// 
	arr = new array(type, size);
	arr->set_sub_id(-1);
    }
    ito = (int*)arr->get_ptr();
    fto = (float*)arr->get_ptr();

    if (ut == uf_dmin || ut == uf_dmax) {
	stick = 0;	
	if (type == at_int) {
	    ival = ((int*)arrs[0])[0];
	    for (arr_no = 1; arr_no < get_sub_num(); arr_no++) {
		ival2 = ((int*)arrs[arr_no])[0];
		if (ut == uf_dmin) {
		    if (ival > ival2) {		
			ival = ival2;
			stick = arr_no;
		    }	
		} else {
		    if (ival < ival2) {
			ival = ival2;
			stick = arr_no;
		    } 
		}
	    }
	    for (i = 0; i < size; i++) {
		ito[i] = ((int*)arrs[stick])[i];
	    }
	} else if (type == at_real) {
	    fval = ((float*)arrs[0])[0];
	    for (arr_no = 1; arr_no < get_sub_num(); arr_no++) {
		fval2 = ((float*)arrs[arr_no])[0];
		if (ut == uf_dmin) {
		    if (fval > fval2) {
			fval = fval2;
			stick = arr_no;
		    }
		} else if (ut == uf_dmax) {
		    if (fval < fval2) {
			fval = fval2;
			stick = arr_no;
		    }
		}
	    }
	    for (i = 0; i < size; i++) {
		fto[i] = ((float*)arrs[stick])[i];
	    }
	}
    } else {
	for (i = 0; i < size; i++) {
	    if (type == at_int) {
		ival = ((int*)arrs[0])[i];
		for (arr_no = 1; arr_no < get_sub_num(); arr_no++) {
		    ival2 = ((int*)arrs[arr_no])[i];
		    if (ut == uf_add) {
			ival += ival2;
		    } else if (ut == uf_min) {
			if (ival > ival2) ival = ival2;
		    } else if (ut == uf_max) {
			if (ival < ival2) ival = ival2;
		    } else {
			fprintf(stderr, "unify: unknown type %d\n", ut);
			return -1;
		    }
		}
		ito[i] = ival;
	    } else if (type == at_real) {
		fval = ((float*)arrs[0])[i];
		for (arr_no = 1; arr_no < get_sub_num(); arr_no++) {
		    fval2 = ((float*)arrs[arr_no])[i];
		    if (ut == uf_add) {
			fval += fval2;
		    } else if (ut == uf_min) {
		    if (fval > fval2) fval = fval2;
		    } else if (ut == uf_max) {
			if (fval < fval2) fval = fval2;
		    } else {
			fprintf(stderr, "unify: unknown unify type %d\n", ut);
			return -1;
		    }
		}
		fto[i] = fval;
	    } else {
		fprintf(stderr, "unify: unknown data type %d\n", type);
		return -1;
	    }
	}
    }
    return 0;
}	

// ¾ IPU 餳 IPU ˤ륰Хѿɤ߹׵
int
array_read(array_id_info* a_info, array_data_info* ad_info, int ipu_no)
{
    array* arr = AL.search(a_info->array_id, -1);
    if (arr == NULL) {
	fprintf(stderr, "array_read: AL.search failed (%d, %d)\n",
		a_info->array_id, -1);
	return FAIL;
    }

    ipu_ipu msg;
    msg.t_msg = new trans_msg;
    msg.t_msg->type   = p_ii_array_write;
    msg.t_msg->ipu_no = ipu_no;
    msg.a_info = new array_id_info;
    msg.a_info->job_id   = a_info->job_id;
    msg.a_info->array_id = a_info->array_id;
    msg.a_info->sub_id   = a_info->sub_id;
    msg.ad_info = new array_data_info;
    msg.ad_info->index       = ad_info->index;
    msg.ad_info->width       = ad_info->width;
    msg.ad_info->number      = ad_info->number;
    msg.ad_info->need_signal = ad_info->need_signal;
    msg.t_msg->size = ad_info->width * ad_info->number;
    msg.buf = (char*)arr->get_ptr() + ad_info->index * ad_info->width;
    trans_q.putmsg(msg);

    return 0;
}

// ¾ IPU 餳 IPU ˤ륰Хѿؤν񤭹
int
array_write(array_id_info* a_info, array_data_info* ad_info, void* buf)
{
#ifdef DEBUG
    fprintf(stderr, "񤭹׵Ǥ, aid %d, sid %d, i=%d, n=%d\n",
	    a_info->array_id, a_info->sub_id,
	    ad_info->index, ad_info->number);
#endif
    array* arr = AL.search(a_info->array_id, a_info->sub_id);
    if (arr == NULL) {
	fprintf(stderr, "array_write: AL.search failed\n");
	return FAIL;
    }

    char* dest = (char*)arr->get_ptr() + ad_info->index * ad_info->width;
    int size = ad_info->width * ad_info->number;
    memcpy(dest, buf, size);
#ifdef DEBUG
    fprintf(stderr, "񤭹ߤޤ,  %d\n", *(int*)dest);
#endif

    if (ad_info->need_signal) {
	array_read_list.signal(NULL, a_info->job_id);
    }

    return OKAY;
}

// IPU å׵
// ̥åɤǼ¹

static void* array_lock_sub(void* arg);
struct array_lock_arg {
    array_id_info a_info;
    int           ipu_no;
};

int
array_lock(array_id_info* a_info, int ipu_no)
{
    array_lock_arg* arg = new array_lock_arg;
    arg->a_info = *a_info;
    arg->ipu_no = ipu_no;
    pthread_t tid;
    pthread_attr_t attr;
    pthread_attr_init(&attr);
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
    pthread_create(&tid, &attr, array_lock_sub, arg);
    pthread_attr_destroy(&attr);

    return OKAY;
}

static void*
array_lock_sub(void* arg_)
{
    array_lock_arg* arg = (array_lock_arg*)arg_;

    array* arr = AL.search(arg->a_info.array_id, -1);
    if (arr == NULL) {
	fprintf(stderr, "array_lock: AL.search failed\n");
	return 0;
    }

    arr->lock_prog();

    // åǤ
    // å׵ᤷƤ IPU ֤

    ipu_ipu msg;
    msg.t_msg = new trans_msg;
    msg.t_msg->type   = p_ii_array_lock_done;
    msg.t_msg->ipu_no = arg->ipu_no;
    msg.a_info = new array_id_info;
    msg.a_info->job_id   = arg->a_info.job_id;
    msg.a_info->array_id = arg->a_info.array_id;
    msg.a_info->sub_id   = arg->a_info.sub_id;
    trans_q.putmsg(msg);

    return 0;
}

int
array_unlock(array_id_info* a_info, int ipu_no)
{
    array* arr = AL.search(a_info->array_id, -1);
    if (arr == NULL) {
	fprintf(stderr, "array_unlock: AL.search failed\n");
	return FAIL;
    }

    arr->unlock_prog();

    // åλ
    // åλ׵ᤷƤ IPU ֤

    ipu_ipu msg;
    msg.t_msg = new trans_msg;
    msg.t_msg->type   = p_ii_array_unlock_done;
    msg.t_msg->ipu_no = ipu_no;
    msg.a_info = new array_id_info;
    msg.a_info->job_id   = a_info->job_id;
    msg.a_info->array_id = a_info->array_id;
    msg.a_info->sub_id   = a_info->sub_id;
    trans_q.putmsg(msg);

    return OKAY;
}

int
array_lock_done(array_id_info* a_info)
{
    array_lock_list.signal(NULL, a_info->job_id);
    return OKAY;
}

int
array_unlock_done(array_id_info* a_info)
{
    array_unlock_list.signal(NULL, a_info->job_id);
    return OKAY;
}
