/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  block.h
    ipu_p_block 饹:
    IPU-p  `{'  '}' ǰϤޤ줿ʬ1ĤˤޤȤ뤿Υ饹
*********************************************************************/

#ifndef BLOCK_H
#define BLOCK_H

#include <stdio.h>
#include "def.h"
#include "etc.h"

enum ipu_p_code_t {
    ic_null, ic_token, ic_block
};

class ipu_p_block_body;

class ipu_p_block
{
  private:
    ipu_p_block_body* body; // ƬؤΥݥ
    ipu_p_block_body* cur;  // ߤΥݥ

  public:
    inline ipu_p_block(ipu_p_block_body* b);
    inline ipu_p_block(ipu_p_block* blk);
    inline ~ipu_p_block();

    // ߤηĴ٤
    inline ipu_p_code_t	checktype();
    // ߤͤäƤ & ݥ󥿤ʤ
    inline int		get(char*& ret);
    inline int		get(ipu_p_block*& ret);

    // ݥ󥿤Ƭ᤹
    inline void		reset() { cur = body; };

    // ɽ
    inline void		print();
};

class ipu_p_block_body
{
friend class ipu_p_block;
  private:
    ipu_p_block_body*	next;
    ipu_p_code_t	type;
    union {
	char*		sval;
	ipu_p_block*	bval;
    };
    ipu_p_block_body*	cur; // ˻Ȥ (ɲäƤΤ
                             // ؤ cur ä)
    int 		link_count; // ƬǤΤͤ

  public:
    // 󥹥ȥ饯
    ipu_p_block_body()
    {
	next = NULL;
	cur  = NULL;
	type = ic_null;
	link_count = 0;
    };

    // ǥȥ饯
    ~ipu_p_block_body()
    {
	delete next;
	switch (type) {
	  case ic_token:
	    delete[] sval;
	    break;
	  case ic_block:
	    delete bval;
	    break;
	  default:
	    // nothing
	    break;
	}
    };

    // ᥽å

    // checktype: ΥΡɤΥפĴ٤
    ipu_p_code_t checktype()
    {
	return type;
    };

    // get: ΥΡɤͤäƤ
    // 줿ͤϻȤΤ߲ǽ
    // 񤭴ƤꤷƤϤʤ
    int	get(char*& ret)
    {
	ret = sval;
	return OKAY;
    };
    int	get(ipu_p_block*& ret)
    {
	ret = bval;
	return OKAY;
    };

    // ͤ1ɲ (ɲä֤ϥꥹȤκǸ)
    // : token ξͤΥԡϿ뤬
    // block ξϤΤΤϿ
    void def(char* s)
    {
	if (cur != NULL) {
	    ipu_p_block_body* bp = new ipu_p_block_body;
	    bp->next = cur->next;  cur->next = bp;  cur = bp;
	} else {
	    cur = this;
	}
	cur->type = ic_token;
	cur->sval = strdup_new(s);
    }
    void def(ipu_p_block* b)
    {
	if (cur != NULL) {
	    ipu_p_block_body* bp = new ipu_p_block_body;
	    bp->next = cur->next;  cur->next = bp;  cur = bp;
	} else {
	    cur = this;
	}
	cur->type = ic_block;
	cur->bval = b;
    }

    // ɽ
    void print()
    {
	switch (type) {
	  case ic_token:
	    printf(" %s", sval);
	    break;
	  case ic_block:
	    printf(" ");
	    bval->print();
	    break;
	  default:
	    break;
	}
	if (next != NULL) {
	    next->print();
	}
    };
};


// ---------------------


ipu_p_block::ipu_p_block(ipu_p_block_body* b)
{
    body = cur = b;
    body->link_count++;
}

ipu_p_block::ipu_p_block(ipu_p_block* blk)
{
    body = cur = blk->body;
    body->link_count++;
}

ipu_p_block::~ipu_p_block()
{
    body->link_count--;
    if (body->link_count <= 0) {
	delete body;
    }
}


// ߤηĴ٤
ipu_p_code_t
ipu_p_block::checktype()
{
    if (cur != NULL) {
	return cur->checktype();
    } else {
	return ic_null;
    }
}
// ߤͤäƤ & ݥ󥿤ʤ
int
ipu_p_block::get(char*& ret)
{
    if (cur != NULL) {
	int st;
	st = cur->get(ret);
	cur = cur->next;
	return st;
    }
    return FAIL;
}
int
ipu_p_block::get(ipu_p_block*& ret)
{
    if (cur != NULL) {
	int st;
	st = cur->get(ret);
	cur = cur->next;
	return st;
    }
    return FAIL;
}

void
ipu_p_block::print()
{
    printf("{");
    body->print();
    printf(" }");
    fflush(stdout);
}

#endif /* BLOCK_H */
