/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  com.cc
    IPU ̿
*********************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <errno.h>
#include <netdb.h>
#include <pthread.h>
#include <unistd.h>
#include <termios.h>
#include "Image.h"
#include "GrayImage.h"
#include "ObjList.h"
#include "def.h"
#include "protocol.h"
#include "trans.h"
#include "msgqueue.h"
#include "etc.h"
#include "vom.h"
#include "com.h"

// ۥ̾:host, ݡֹ:port ³
int
connect_host(char* host, int port)
{
    int 		fd = -1;
    struct sockaddr_in	serv_addr;
    struct hostent	*hp;

#if defined(USE_SOLARIS_GETHOSTBYNAME_R)
    char		buf[1024];  // for gethostbyname_r()
    struct hostent	server;
    int 		err;
    if (gethostbyname_r(host, &server, buf, sizeof(buf), &err) == NULL) {
	fprintf(stderr, "connect_host: gethostbyname faild (hostname:`%s')\n",
		host);
	return -1;
    }
    hp = &server;
#else
    if ((hp = gethostbyname(host)) == NULL) {
	fprintf(stderr, "connect_host: gethostbyname faild (hostname:`%s')\n",
		host);
	return -1;
    }
#endif

    memset(&serv_addr, 0, sizeof(serv_addr));
    serv_addr.sin_family      = AF_INET;
    serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    serv_addr.sin_port        = htons(port);
    memcpy(&serv_addr.sin_addr, hp->h_addr, hp->h_length);

    if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	return -1;
    }
    if (connect(fd, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) < 0) {
	perror("connect");
	return -1;
    }

    return fd;
}

// IPU <--> IPU ̿Υ
// ϵһҡ顼 -1 ֤
int
setup_server(int port)
{
    int 		listen_fd = -1;
    sockaddr_in		addr;

    memset(&addr, 0, sizeof(addr));
    addr.sin_family      = AF_INET;
    addr.sin_addr.s_addr = htonl(INADDR_ANY);
    addr.sin_port        = htons(port);

    if ((listen_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	perror("setup_server: socket failed");
	return -1;
    }

    if (bind(listen_fd, (struct sockaddr*)&addr, sizeof(addr)) < 0) {
	perror("setup_server: bind failed");
	close(listen_fd);
	return -1;
    }

    if (listen(listen_fd, 5) < 0) {
	perror("setup_server: listen failed");
	close(listen_fd);
	return -1;
    }

    int arg = 1;
    setsockopt(listen_fd, SOL_SOCKET, SO_REUSEADDR, (char*)&arg, sizeof(arg));
    struct linger lin;
    lin.l_onoff  = 1;
    lin.l_linger = 3;
    setsockopt(listen_fd, SOL_SOCKET, SO_LINGER, (char*)&lin, sizeof(lin));

    return listen_fd;
}

// ͥåȥɤ߽񤭴ؿ

int
net_read(int fd, void* buf, int size)
{
    int 	wc;
    int 	rest = size;
    char*	rbuf = (char*)buf;

    while (rest > 0) {
	wc = read(fd, rbuf, rest);
	if (wc < 0) {
	    return FAIL;
	}
	rbuf  += wc;
	rest  -= wc;
    }
    //tcflush(fd, TCIFLUSH);
    return OKAY;
}

int
net_write(int fd, void* buf, int size)
{
    int 	wc;
    int 	rest = size;
    char*	wbuf = (char*)buf;

    while (rest > 0) {
	wc = write(fd, wbuf, rest);
	if (wc < 0) {
	    perror("net_write: write failed");
	    return FAIL;
	}
	wbuf += wc;
	rest -= wc;
    }
    //tcflush(fd, TCOFLUSH);
    return OKAY;
}
