/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  command.cc
    IPU-p ޒɒϒ
*********************************************************************/

#include <stdio.h>
#include <unistd.h>
#include "def.h"
#include "keyword.h"
#include "stack.h"
#include "ftable.h"
#include "number.h"
#include "ObjList.h"
#include "lang.h"
#include "protocol.h"
#include "command.h"
#include "msgqueue.h"
#include "dlmodule.h"
#include "control.h"
#include "GrayImage.h"
#include "vom.h"

extern msgqueue trans_q;

static int exec_request(char* token, stack& ST, ftable& FT, keyfunc_t* kfp);

// 쒥ْ0

int
command0(char* token, stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    keyword_t* 	kwp;
    keyfunc_t* 	kfp;
    int 	out_st = OKAY;

    // ɒɒΒÒ
    if	((kwp = check_keyword(token)) != NULL) {
	if ((out_st = kwp->f(ST, TA, FT, OL)) == FAIL) {
	    fprintf(stderr, "keyword %s exec failed\n", token);
	}
    }
    // Ւ󒥯璥 (ĒޒȒߒߒ⒥咡) ޒ
    // Ւ󒥯璥ȒƒВϿ쒤ƒ (Ēޒ꒥⒥咡) ΒÒ
    else if ((kfp = check_keyfunc(token)) != NULL || FT.search(token) != FAIL){
	// OM ˒Ԓ͒
	out_st = exec_request(token, ST, FT, kfp);
    }
    // ђ꒵쒤ƒ뒤ΒÒ
    else if (TA.presearch(token) != FAIL) {
	node_type ty = TA.tatype(token);
	int a;
	float b;
	complex c;
	char* p;
	ipu_p_block* blk;
	Image* i;
	array* ar;
	ipu_p_bool bl;
	switch (ty) {
	  case nt_int:
	    TA.get(token, a);
	    ST.push(a);
	    break;
	  case nt_real:
	    TA.get(token, b);
	    ST.push(b);
	    break;
	  case nt_complex:
	    TA.get(token, c);
	    ST.push(c);
	    break;
	  case nt_name:
	  case nt_string:
	    TA.get(token, p);
	    ST.push(p);
	    delete[] p;
	    break;
	  case nt_block:
	    // ֒풥ÒΒϒԒԒ
	    TA.get(token, blk);
	    langn(blk, ST, TA, FT, OL);
	    delete blk;
	    break;
	  case nt_image:
	    TA.get(token, i);
	    ST.push(i);
	    break;
	  case nt_array:
	    TA.get(token, ar);
	    ST.push(ar);
	    break;
	  case nt_bool:
	    TA.get(token, bl);
	    ST.push(bl);
	    break;
	  default:
	    out_st = FAIL;
	    fprintf(stderr, "command0: unknown var type (name=%s, type=%d)\n",
		    token, (int)ty);
	}
    }
    // ǒʒ쒤
    // ΒÒ̾ÒȒ꒥󒥰ÒԒ
    else {
	int a;
	float b;
	if (conv_int(token, a) == OKAY) {			// 
	    ST.push(a);
	} else if (conv_real(token, b) == OKAY) {		// 
	    ST.push(b);
	} else if (token[0] == '/' || token[0] == '(') {	// ̾ޒ
	    ST.push(token);				        //   ʸ
	} else {
	    fprintf(stderr, "command0: undefined `%s'\n", token);
	    return FAIL;
	}
    }

    return out_st;
}

// command1():
//  쒥ْ1
//   ֒풥Ò(`{'  `}' ǒϒޒ쒤ʬ)ʬΒԒ
int
command1(ipu_p_block* b, stack& ST ,table& TA, ftable& FT, ObjectList& OL)
{
    int 	 out_st;
    ipu_p_code_t c = b->checktype();
    char*	 token;
    ipu_p_block* b2;

    switch (c) {
      case ic_null: // ֒풥Òλ
	out_st = OKAY;
	break;
      case ic_token:
	b->get(token);
	out_st = command0(token, ST, TA, FT, OL);
	break;
      case ic_block:
	b->get(b2);
	ST.push(new ipu_p_block(b2));
	out_st = OKAY;
	break;
      default:
	fprintf(stderr, "command1: unknown code %d\n", (int)c);
	out_st = FAIL;
	break;
    }

    return out_st;
}


// OM ˒⒥咡뒤ΒԒ͒꒤
static int
exec_request(char* token, stack& ST, ftable& FT, keyfunc_t* kfp)
{
    int 	out_st;
    char*	mo_name;
    int 	in, out, param;

    if (kfp != NULL) {
	// Ȓߒߒ⒥咡
	mo_name = kfp->keyfunc;
	in      = kfp->in_num;
	out     = kfp->out_num;
	param   = kfp->param_num;
    } else {
	mo_name = token;
	FT.get(mo_name, in, out, param);
    }

    int st = OKAY;
    int i;

    Image* args[64];
    array* a_args[64];
    char*  str_arg;
    int    is_str_arg;
    if (strcmp(mo_name, "load")  == 0 || strcmp(mo_name, "save")  == 0 ||
	strcmp(mo_name, "cload") == 0 || strcmp(mo_name, "csave") == 0)
    {
	is_str_arg = 1;
    } else {
	is_str_arg = 0;
    }

    for (i = 0; i < param; i++) {
	if (is_str_arg) {
	    if (ST.pop(str_arg) == FAIL) st = FAIL;
	} else {
	    if (ST.pop(a_args[param - i - 1]) == FAIL) st = FAIL;
	}
    }
    for (i = 0; i < out; i++)
	if (ST.pop(args[out + in - i - 1]) == FAIL) st = FAIL;
    for (i = 0; i < in; i++)
	if (ST.pop(args[in - i - 1]) == FAIL) st = FAIL;

    if (st == FAIL) {
	fprintf(stderr, "exec_request: stack pop failed\n");
	return FAIL;
    }

    char tmp[1024];
    tmp[0] = '\0';

    for (i = 0; i < in + out; i++) {
	sprintf(tmp, "%s%d ", tmp, args[i]->get_image_id());
    }
    for (i = 0; i < param; i++) {
	if (is_str_arg) {
	    sprintf(tmp, "%s%s ", tmp, str_arg);
	} else {
	    sprintf(tmp, "%s%d ", tmp, a_args[i]->get_array_id());
	}
    }
    sprintf(tmp, "%s%s", tmp, mo_name);

#ifdef DEBUG
    fprintf(stderr, "exec_request: name: %s, in:%d, out:%d, param:%d\n",
	    mo_name, in, out, param);
    fprintf(stderr,
	  "exec_request: ⒥咡뒼Ԓ OM ˒͒꒤ޒ (: %s)\n", tmp);
#endif

    if (is_str_arg) {
	delete[] str_arg;
    }

    module_exec_request(tmp);

    out_st = OKAY;

    return out_st;
}
