/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  control.cc
    IPU-p  (if, for ʤ)
*********************************************************************/

#include "control.h"
#include "def.h"
#include "stack.h"
#include "ftable.h"
#include "ObjList.h"
#include "GrayImage.h"
#include "lang.h"
#include "protocol.h"
#include "etc.h"
#include "vom.h"

// int get_name(stack& ST, char*& a)
// åƬ̾ȤäƤ
// ̾Ƭ / ϽƤ
int
get_name(stack& ST, char*& a)
{
    if (ST.sttype() != nt_name)	return FAIL;
    if (ST.pop(a) == FAIL)	return FAIL;
    return OKAY;
}

// int f_fdef(stack& ST,table& TA, ftable& FT)
// ⥸塼Ԥ
//   å: : ̾(ʸ) ϲ() ϲ()
//                   ѥ᡼() ⥸塼(ipu_p_block* )
//             : ʤ
//   ؿ:  -> OKAY   -> FAIL
// (OKAY or FAIL) OM 𤹤
int
f_fdef(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)OL;
    int 	 input;		// input num
    int 	 output;	// output num
    int 	 param; 	// param num
    ipu_p_block* blk = NULL;	// { } block
    char*	 nam = NULL;	// name

    int 	 st = OKAY;

    if (ST.pop(blk) == FAIL)		st = FAIL;
    else if (ST.pop(param) == FAIL)	st = FAIL;
    else if (ST.pop(output) == FAIL)	st = FAIL;
    else if (ST.pop(input) == FAIL)	st = FAIL;
    else if (get_name(ST, nam) == FAIL)	st = FAIL;

    if (st == OKAY) {
	FT.def(nam, input, output, param);
	FT.settype(nam, ft_ipu_p);
#ifdef DEBUG
	blk->print();
#endif
    }
    delete[] nam;
    delete blk;

    fdef_donerep(nam, st);

    return st;
}

// ʲ iffor ʤɤ桢¹Ԥ˴ؤ

int
f_exec(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    ipu_p_block* b;
    int 	 status;

    if (ST.pop(b) == FAIL) return FAIL;

    status = langn(b, ST, TA, FT, OL);
    delete b;
    return status;
}

int
f_if(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    ipu_p_block* b = NULL;
    ipu_p_bool	 c;
    int 	 status;

    if (ST.pop(b) == FAIL) { status = FAIL; goto end; }
    if (ST.pop(c) == FAIL) { status = FAIL; goto end; }

    if (c == ib_false) status = OKAY;
    else	       status = langn(b, ST, TA, FT, OL);

  end:
    delete b;
    return status;
}

int
f_ifelse(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    ipu_p_block* b2 = NULL;
    ipu_p_block* b1 = NULL;
    ipu_p_bool	 c;
    int 	 status;

    if (ST.pop(b2) == FAIL) { status = FAIL; goto end; }
    if (ST.pop(b1) == FAIL) { status = FAIL; goto end; }
    if (ST.pop(c) == FAIL)  { status = FAIL; goto end; }

    if (c == ib_false) status = langn(b2, ST, TA, FT, OL);
    else	       status = langn(b1, ST, TA, FT, OL);

  end:
    delete b2;
    delete b1;
    return status;
}

int
f_for(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    ipu_p_block* b = NULL;
    float	 c, ed, in, st;
    int 	 status, st2;

    if (ST.pop(b) == FAIL)  { status = FAIL; goto end; }
    if (ST.pop(ed) == FAIL) { status = FAIL; goto end; }
    if (ST.pop(in) == FAIL) { status = FAIL; goto end; }
    if (ST.pop(st) == FAIL) { status = FAIL; goto end; }

    for (c = st; c < ed; c += in) {
	ST.push(c);
	st2 = langn(b, ST, TA, FT, OL);
	if (st2 == FAIL || st2 == IPUP_QUIT) {
	    status = st2;
	    break;
	} else if (status == IPUP_EXIT) {
	    status = OKAY;
	    break;
	}
    }

  end:
    delete b;
    return status;
}

int
f_repeat(stack& ST,table& TA, ftable& FT, ObjectList& OL)
{
    ipu_p_block* b;
    int 	 a, status, st2;

    if (ST.pop(b) == FAIL) { status = FAIL; goto end; }
    if (ST.pop(a) == FAIL) { status = FAIL; goto end; }

    for (; a > 0; a--)
    {
	st2 = langn(b, ST, TA, FT, OL);
	if (st2 == FAIL || st2 == IPUP_QUIT) {
	    status = st2;
	    break;
	} else if (status == IPUP_EXIT) {
	    status = OKAY;
	    break;
	}
    }
    return OKAY;

  end:
    delete b;
    return status;
}

int
f_loop(stack& ST,table& TA, ftable& FT, ObjectList& OL)
{
    ipu_p_block* b;
    int 	 status, st2;

    if (ST.pop(b) == FAIL) { status = FAIL; goto end; }

    for (;;)
    {
	st2 = langn(b, ST, TA, FT, OL);
	if (st2 == FAIL || st2 == IPUP_QUIT) {
	    status = st2;
	    break;
	} else if (status == IPUP_EXIT) {
	    status = OKAY;
	    break;
	}
    }

  end:
    delete b;
    return status;
}


// def ˤѿ (/var 10 def ʤ)
int
f_def(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)FT; (void)OL;
    char*	 var_name = NULL;
    node_type 	 type = ST.sttype();

    if (ST.exch() == FAIL) return FAIL;
    if (get_name(ST, var_name) == FAIL)	return FAIL;

    switch (type) {
      case nt_int:
	int	a;
	if (ST.pop(a) == FAIL) return FAIL;
	TA.def(var_name, a);
	break;
      case nt_real:
	float	b;
	if (ST.pop(b) == FAIL) return FAIL;
	TA.def(var_name, b);
	break;
      case nt_complex:
	int	c;
	if (ST.pop(c) == FAIL) return FAIL;
	TA.def(var_name, c);
	break;
      case nt_string:
	char*	d;
	if (ST.pop(d) == FAIL) return FAIL;
	TA.def(var_name, d);
	break;
      case nt_block:
	ipu_p_block* blk;
	if (ST.pop(blk) == FAIL) return FAIL;
	TA.def(var_name, blk);
	delete blk;
	break;
      case nt_image:
	Image*	ima;
	if (ST.pop(ima) == FAIL) return FAIL;
	TA.def(var_name, ima);
	break;
      case nt_array:
	array*	arr;
	if (ST.pop(arr) == FAIL) return FAIL;
	TA.def(var_name, arr);
	break;
      default:
	fprintf(stderr, "f_def: unknown type %d\n", type);
	return FAIL;
    }
    delete[] var_name;
    return OKAY;
}


int
f_exit(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)ST; (void)TA; (void)FT; (void)OL;
    return IPUP_EXIT;
}

int
f_quit(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)ST; (void)TA; (void)FT; (void)OL;
    return IPUP_QUIT;
}

int
f_continue(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)ST; (void)TA; (void)FT; (void)OL;
    return IPUP_CONTINUE;
}

int
f_pop(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    return ST.pop();
}

int
f_exch(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    return ST.exch();
}

int
f_dup(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    ST.dup();
    return OKAY;
}

int
f_roll(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    int	a;
    int	b;
    if (ST.pop(a) == FAIL)	return FAIL;
    if (ST.pop(b) == FAIL)	return FAIL;

    return ST.roll(b, a);
}

int
f_pstack(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    ST.print(); printf("\n");
    return OKAY;
}

int
f_equal2(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    if (ST.sttype() == nt_null) {
	return FAIL;
    }
    ST.print_one(); printf("\n");
    ST.pop();
    return OKAY;
}
