/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  dlmodule.cc
    ưŪ⥸塼ɲ & ¹
*********************************************************************/

#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <errno.h>
#include <sys/wait.h>
extern "C" {
#include <dlfcn.h>
}

#include "stack.h"
#include "ftable.h"
#include "ObjList.h"
#include "GrayImage.h"
#include "protocol.h"
#include "msgqueue.h"
#include "etc.h"
#include "vom.h"
#include "sync.h"
#include "dlmodule.h"
#include "vbuf.h"
#include "dmodinc.h"
#include "paralist.h"
#include "keyword.h"
#include "function.h"
#include "jobid.h"
#include "waitlist.h"

#ifdef DEBUG /* for chmod */
#include <sys/types.h>
#include <sys/stat.h>
#endif

extern msgqueue		dmod_q;
extern msgqueue		send_q;
extern int		my_ipu_no;

extern int		get_name(stack&, char*&);

struct mod_exec_arg {
    char* 	name;
    stack*	ST;
    int 	in;
    int 	out;
    int 	param;
    int 	task_id; //  ID
    int 	ip1_no;  // Υ ID Ǥ ip1 ֹ
                         //   ( IPU ֤Ƕֹ̤̤)
                         //   (0,1,2,...,total_ip1_num-1)
                         // jobid = ip1_no * 10000 + task_id
};

// ؿΥץȥ
static int exec_compile(char* ccfile, char* libfile, char** errmsg);
static void f_exec_wrap(mod_exec_arg* arg);

// void complie();
// C++ ǽ񤫤줿⥸塼 dmod_q 
// 򥳥ѥ뤷ơmodule_ʤȤ.soɤ VIOSLIBDIR ǥ쥯ȥ˺
void
compile()
{
    ipu_ipu	msg;	// OM Ƥ C++ Υץ
    prog_info*	p_info;	// C++ Υץξ

    for (;;) {
	dmod_q.getmsg(msg);
	p_info = msg.p_info;

	if (p_info == NULL) {
	    // λå褿
	    break;
	}

	// my_ipu_no  0  IPU ѥԤ
	if (my_ipu_no == 0) {
	    FILE*	fp;
	    int 	err_flag = 0;
	    char	ccfile[512];
	    char	ccfile_fp[1024];  // եѥ
	    char	modfile[512];
	    char	modfile_fp[1024]; // եѥ
	    char*	errmsg = NULL;

	    if (strlen(VIOSLIBDIR) > 256) {
		fprintf(stderr, "compile: too long VIOSLIBDIR\n");
		exit(1);
	    }
	    sprintf(ccfile, "vios_tmp.cc");
	    sprintf(ccfile_fp, "%s/%s", VIOSLIBDIR, ccfile);

	    // ä C++ Υץե˽񤭹
	    if ((fp = fopen(ccfile_fp, "w")) == NULL) {
		fprintf(stderr, "compile: file open error\n");
		perror(ccfile_fp);
		err_flag = 1;
		goto end_of_compile;
	    }
	    fprintf(fp, "%s", msg.buf);
	    fclose(fp);

#ifdef DEBUG
	    chmod(ccfile_fp, 0664);
#endif

	    // ѥ
	    if (strlen(p_info->name) > 256) {
		fprintf(stderr, "compile: too long module name\n");
		exit(1);
	    }
	    sprintf(modfile, "module_%s.so", p_info->name);
	    sprintf(modfile_fp, "%s/%s", VIOSLIBDIR, modfile);

	    if (exec_compile(ccfile, modfile, &errmsg) != 0) {
		// 
#ifdef DEBUG
		fprintf(stderr, "compile: compile failed.\n");
#endif
		remove(modfile_fp);
		err_flag = 1;
		goto end_of_compile;
	    } else {
		// 
#ifdef DEBUG
		fprintf(stderr, "compile: compile succeeded.\n");
#endif

#ifdef DEBUG
		chmod(modfile_fp, 0775);
#endif
	    }

	  end_of_compile:

	    // OM إѥη̤
	    ipu_ipu commsg;
	    commsg.to_om = new ipu_om;
	    commsg.to_om->type = p_io_compile_stat;
	    commsg.p_info = p_info; // dmod_q 褿Τ򤽤Τޤ޻Ȥ
	                            // commsg ¦ delete 
	    if (errmsg != NULL) {
		commsg.to_om->size = strlen(errmsg);
		commsg.buf = errmsg; // errmsg  new char[size] 줿
		                     // commsg ¦ delete[] 
	    } else {
		commsg.to_om->size = 0;
		commsg.buf = NULL;
	    }
	    if (err_flag) {
		commsg.to_om->result = 1; // 
	    } else {
		commsg.to_om->result = 0; // 
	    }
	    send_q.putmsg(commsg);

	    delete msg.buf;
	    // no delete p_info

	} else {
	    // ipu_no != 0
	    delete msg.buf;
	    delete p_info;
	}
    }
}

// fork & exec ǥѥԤ
// errmsg  new char[size] ֤ΤǡƤӽФ¦ delete[] 뤳
#define MAXARGS 256
static int
exec_compile(char* ccfile, char* modfile, char** errmsg)
{
    pid_t	pid;
    int 	pi[2]; /* pipe */
    char	compile_command[4096];
    int 	len;

    len = strlen(MODULECOMPILE) + strlen(ccfile) + strlen(modfile);
    if ((size_t)len + 6 > sizeof(compile_command)) {
	fprintf(stderr, "compile: too long command\n");
	return -1;
    }
    sprintf(compile_command, "%s %s -o %s", MODULECOMPILE, ccfile, modfile);
#ifdef DEBUG
    fprintf(stderr, "compile start\n");
    fprintf(stderr, "cd %s; %s\n", VIOSLIBDIR, compile_command);
#endif

    if (pipe(pi) < 0) {
	perror("exec_compile: pipe");
	return -1;
    }

    if ((pid = fork()) < 0) {
	perror("exec_compile: fork");
	return -1;
    } else if (pid > 0) {
	/* ƥץ */

	pid_t chpid;
	int   st;
	char  buf[256];
	int   n;
	vbuf  vb;

	close(pi[1]);
	for (;;) {
	    n = read(pi[0], buf, sizeof(buf));
	    if (n > 0) {
#ifdef DEBUG
		fwrite(buf, 1, n, stderr);
#endif
		vb.append(buf, n);
	    } else if (n == 0) {
		break;
	    } else {
		if (errno != EINTR) {
		    perror("exec_compile: read");
		    break;
		}
	    }
	}
	chpid = wait(&st);
	vb.append("\0", 1);
	*errmsg = strdup_new((char*)vb.getbuf());
	if ((st & 0xff) == 0) {
	    return st>>8;
	} else {
	    return st;
	}
    } else {
	/* ҥץ */

	char* argv[MAXARGS+1];
	char* p;

	/* ɸϤɸ२顼Ϥѥפڤ괹 */
	close(pi[0]);
	dup2(pi[1], 1);
	dup2(pi[1], 2);

	if (chdir(VIOSLIBDIR) < 0) {
	    perror("exec_compile: chdir");
	    exit(1);
	}

	/* argv  */
	p = compile_command;
	while (*p == ' ' || *p == '\t') {
	    p++;
	}
	int i;
	for (i = 0; i < MAXARGS-1; i++) {
	    argv[i] = p;
	    while (*p != ' ' && *p != '\t' && *p != '\0') {
		p++;
	    }
	    if (*p == '\0') {
		break;
	    }
	    *p = '\0';
	    p++;
	    while (*p == ' ' || *p == '\t') {
		p++;
	    }
	    if (*p == '\0') {
		break;
	    }
	}
	if (i == MAXARGS-1) {
	    fprintf(stderr, "exec_compile: too many args\n");
	    exit(1);
	}
	argv[i+1] = NULL;

	/* ѥ¹ */
	if (execvp(argv[0], argv) < 0) {
	    perror("exec_compile: execvp");
	    exit(1);
	}
	return -1;
    }
}

// f_dsync: ưŪ⥸塼Ʊ
//   : ʤ
//   : ʤ
//   OM  dsync 
int
f_dsync(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)ST; (void)TA; (void)FT; (void)OL;
    ipu_ipu msg;
    msg.to_om = new ipu_om;
    msg.to_om->type   = p_io_dsync;
    msg.to_om->result = OKAY;
    msg.to_om->size = 0;
    send_q.putmsg(msg);
    return OKAY;
}

// f_dfdef: ưŪ⥸塼
//   å,
//     ⥸塼̾, ϲ, ϲ, ѥ᡼
//    pop
//    (: /Add 2 1 0)
//   Ƥ FT Ͽ
int
f_dfdef(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    int 	 input;	// input num
    int 	 output;// output num
    int 	 param;	// param num
    char*	 name;	// ⥸塼̾

    (void)TA; (void)OL;

    int status = OKAY;

    if (ST.pop(param) == FAIL)		status = FAIL;
    else if (ST.pop(output) == FAIL)	status = FAIL;
    else if (ST.pop(input) == FAIL)	status = FAIL;
    else if (get_name(ST,name) == FAIL)	status = FAIL;

    if (status == OKAY) {
	FT.def(name, input, output, param);
	FT.settype(name, ft_cxx);
    }

    return status;
}

// f_dexec: ưŪ⥸塼¹
//   å:
//     ϲ ... ϲ ... ѥ᡼ ... task_id ip1_no ⥸塼̾
int
f_dexec(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)OL;

    char*		mod_name;
    int			st;
    int			in, out, param;
    stack*		ST2 = new stack;
    int 		task_id;
    int 		ip1_no;

#ifdef DEBUG
    time_print("dexec");
#endif

    st = OKAY;
    if (ST.sttype() != nt_name) st = FAIL;
    else if (ST.pop(mod_name) == FAIL) st = FAIL;
    else if (ST.pop(ip1_no) == FAIL) st = FAIL;
    else if (ST.pop(task_id) == FAIL) st = FAIL;

    if (st == FAIL) {
	fprintf(stderr, "f_dexec: syntax error\n");
	return FAIL;
    }

    keyfunc_t* 	kfp;
    if ((kfp = check_keyfunc(mod_name)) != NULL) {
	// Ȥ߹ߥ⥸塼
	if (strcmp(mod_name, "load") == 0 || strcmp(mod_name, "cload") == 0) {
	    st = kfp->f(ST, TA, FT, OL);
	    // module_donerep  f_load Ǥ
	    return st;
	} else {
	    out_info* o_info = new out_info;
	    o_info->out_num = 0;
	    o_info->job_id = taskid_ip1no_to_jobid(task_id, ip1_no);
	    st = kfp->f(ST, TA, FT, OL);
	    module_donerep(mod_name, o_info, NULL, st);
	    return st;
	}
    }


#ifdef DEBUG
    fprintf(stderr, "f_dexec: module `%s'\n", mod_name);
#endif

    if (FT.get(mod_name, in, out, param) != OKAY) {
	fprintf(stderr, "f_dexec: %s not found in FT\n", mod_name);
	return FAIL;
    }

    if (ST.split2stack(*ST2, in+out+param) == FAIL) {
	// stack underflow
	fprintf(stderr, "f_dexec: split2stack failed\n");
	return FAIL;
    }
    if (FT.gettype(mod_name) == ft_cxx) {
	mod_exec_arg* arg = new mod_exec_arg;
	arg->name    = mod_name; // dup ˤΤޤ޻Ȥ
	arg->ST      = ST2;
	arg->in      = in;
	arg->out     = out;
	arg->param   = param;
	arg->task_id = task_id;
	arg->ip1_no  = ip1_no;
	pthread_t tid;
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	if (my_ipu_no > 0) {
	    sched_param s_param;
	    s_param.sched_priority = 10;     //defineΤȤ٤
	    pthread_attr_setschedparam(&attr, &s_param);
	    printf("׻åɤͥ٤夲ޤ\n");
	}
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
	pthread_create(&tid, &attr, (void*(*)(void*))f_exec_wrap, arg);
    } else {
	fprintf(stderr, "f_dexec: only type ft_cxx is supportted\n");
	return FAIL;
    }
    return OKAY;
}


// dlopen Ѥƥ⥸塼ɤ߹ߡ¹Ԥ

typedef int (*module_t)(stack*, int);

static void*
open_module_handle(char* mod_name)
{
    void* handle;
    char modfilename[1024];
    if (strlen(VIOSLIBDIR) > 256 || strlen(mod_name) > 256) {
	fprintf(stderr, "f_exec: too long module filename\n");
	return NULL;
    }
    sprintf(modfilename, "%s/module_%s.so", VIOSLIBDIR, mod_name);
#ifdef DEBUG
    fprintf(stderr, "f_exec: dlopen `%s'\n", modfilename);
#endif
    if ((handle = dlopen(modfilename, RTLD_LAZY)) == NULL) {
	fprintf(stderr, "f_exec: dlopen %s failed\n", modfilename);
	fprintf(stderr, "reason... %s\n", dlerror());
	return NULL;
    }
    return handle;
}

static module_t
get_module_entry_with_handle(char* mod_name, void* handle)
{
    module_t mp;
    char symbolname[1024];
    sprintf(symbolname, "VIOS_module_%s", mod_name);
#ifdef DEBUG
    fprintf(stderr, "f_exec: symbol name = `%s'\n", symbolname);
#endif
    if ((mp = (module_t)dlsym(handle, symbolname)) == NULL) {
	fprintf(stderr,"f_exec: symbol not found\n");
	return NULL;
    }
    return mp;
}

int
f_exec(char* mod_name, stack& ST, int in, int out, int param,
       int task_id, int ip1_no)
{
    int 	status = OKAY;
    stack	ST1;
    int 	jid;
    int       	hs,ms,ss,uss, he,me,se,use, ht,mt,st,ust;

    // 
    //fprintf(stderr,"⥸塼ɤ\n");
    void* handle = open_module_handle(mod_name);
    if (handle == NULL) {
	fprintf(stderr, "f_exec: cannot get module `%s' entry\n", mod_name);
	return FAIL;
    }
    // Υ⥸塼Υɥ쥹֤
    //fprintf(stderr,"ƥɥ쥹򤵤ޤ\n");
    module_t mp = get_module_entry_with_handle(mod_name, handle);
    if (mp == NULL) {
	fprintf(stderr, "f_exec: cannot get module `%s' entry\n", mod_name);
	return FAIL;
    }

    ST.copystack(ST1, in+out+param);
    jid = ip1_no * 10000 + task_id;
    gettime(hs,ms,ss,uss);
#ifdef DEBUG
    fprintf(stderr, " start: %2d:%2d.%2d %6d\n",hs,ms,ss,uss);
#endif

    //fprintf(stderr,"ǡ¹\n");
    (*mp)(&ST, jid);
    /* ǥ⥸塼뽪λ */
    dlclose(handle);

    gettime(he,me,se,use);
    gettimes(hs,ms,ss,uss,he,me,se,use,ht,mt,st,ust);
#ifdef DEBUG
    fprintf(stderr, " done:  %2d:%2d.%2d %6d\n",he,me,se,use);
    fprintf(stderr, " time:  %2d:%2d.%2d %6d\n",ht,mt,st,ust);
#endif

    // OM ˼¹ԤäȤ
    {
	int i;
	for (i = 0; i < param; i++) {
	    ST1.pop();
	}
	out_info*	o_info = new out_info;
	image_info*	img_info;
	if (out == 1) {
	    // delete Ȥ num == 1  [] ʤ delete Τ
	    // new Ȥ [] ʤ new 
	    img_info = new image_info;
	} else {
	    img_info = new image_info[out];
	}
	Image* img;
	for (i = out-1; i >= 0; i--) {
	    ST1.pop(img);
	    /* img->display(); <- for debug */
	    img->get_image_info(img_info[i]);
	}
	o_info->out_num = out;
	o_info->job_id = jid;
	module_donerep(mod_name, o_info, img_info, OKAY);

	for (i = 0; i < in; i++) {
	    ST1.pop();
	}
    }
    // OM ˼¹Ի֤
    {
	ipu_ipu msg;
	msg.to_om = new ipu_om;
	msg.to_om->type   = p_io_module_done;
	msg.to_om->result = OKAY;
	msg.to_om->size = 16;
	msg.buf = new char[16];
	setint(msg.buf,    my_ipu_no);
	setint(msg.buf+4,  jid);
	setint(msg.buf+8,  ht*3600+mt*60+st);
	setint(msg.buf+12, ust);
	send_q.putmsg(msg);
    }

    return status;
}

// ưŪ⥸塼륹åɥȴؿ
static void
f_exec_wrap(mod_exec_arg* arg)
{
    f_exec(arg->name, *arg->ST, arg->in, arg->out, arg->param,
	   arg->task_id, arg->ip1_no);
    delete arg;
}

// ưŪ⥸塼⤫ƤФؿ

void
VIOS_sync(int job_id)
{
    int task_id = jobid_to_taskid(job_id);
    int ip1_no  = jobid_to_ip1no(job_id);
    sync_wait(task_id, ip1_no);
}

int
VIOS_ismain(int job_id)
{
    int ip1_no = jobid_to_ip1no(job_id);
    return ip1_no == 0;
}

paralist p_list;

void
VIOS_signal_para(int job_id, int para_id)
{
    ipu_ipu msg;
    msg.to_om = new ipu_om;
    msg.to_om->type = p_io_signal_para;
    msg.para_info = new para_id_info;
    msg.para_info->job_id = job_id;
    msg.para_info->para_id = para_id;
    send_q.putmsg(msg);
}
int
VIOS_wait_para(int job_id)
{
    return p_list.wait(job_id);
}

static waitlist sync_cache_list;

int
VIOS_sync_cache(int job_id, Image* image)
{
    int task_id = jobid_to_taskid(job_id);
    int image_id = image->get_image_id();
    ipu_ipu msg;
    msg.to_om = new ipu_om;
    msg.to_om->type = p_io_sync_cache;
    msg.sc_info = new sync_cache_info;
    msg.sc_info->task_id = job_id;
    msg.sc_info->image_id = image_id;
#ifdef DEBUG
    fprintf(stderr, "sync_cache start!\n");
#endif
    send_q.putmsg(msg);
    (void)sync_cache_list.wait(task_id, image_id);
#ifdef DEBUG
    fprintf(stderr, "sync_cache done!\n");
#endif
    return 0;
}

int
sync_cache_done(int task_id, int image_id)
{
    sync_cache_list.signal(NULL, task_id, image_id);
    return 0;
}
