/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  f_array.cc
*********************************************************************/

#include "f_array.h"
#include "array.h"
#include "comp.h"
#include "protocol.h"
#include "msgqueue.h"
#include "vom.h"
#include "GrayImage.h"
#include "ipu_list.h"
#include "waitlist.h"

ArrayList AL;

extern msgqueue trans_q, send_q;
       msgqueue array_wait_q, waitarray_q;
extern ipu_list ipus;
       waitlist array_wait_list;

// f_intarray:  (5 intarray ʤɤȤƻȤ)
//  å: : ǿ(int)
//            : 
int
f_intarray(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    array* arr;
    int    num;

    if (ST.pop(num) == FAIL)	return FAIL;
    arr = new array(at_int, num);
    arr->set_new_array_id(); //  ID 
    AL.append(arr);

    ST.push(arr);

    return OKAY;
}

// f_realarray: 
//  å: : ǿ(int)
//            : ¿
int
f_realarray(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    array* arr;
    int    num;

    if (ST.pop(num) == FAIL)	return FAIL;
    arr = new array(at_real, num);
    arr->set_new_array_id(); //  ID 
    AL.append(arr);

    ST.push(arr);

    return OKAY;
}

// f_waitarray: ˥⥸塼뤬񤭹ǤʤԤ
//  å: : 
//            : ʤ
int
f_waitarray(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    array* arr;

    if (ST.pop(arr) == FAIL)	return FAIL;

    ipu_ipu msg;
    msg.to_om = new ipu_om;
    msg.to_om->type = p_io_wait_array;
    msg.a_info = new array_id_info;
    msg.a_info->array_id = arr->get_array_id();
    send_q.putmsg(msg);

    waitarray_q.getmsg(msg);

    return OKAY;
}

// f_getarray: 󤫤ͤФåإץå夹
//  å: :  ź
//            : 
int
f_getarray(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    array*	arr;
    int 	i;

    if (ST.pop(i) == FAIL) return FAIL;
    if (ST.pop(arr) == FAIL) return FAIL;
    int ival;
    float rval;
    complex cval;
    switch (arr->get_type()) {
      case at_int:
	if (arr->get_value(i, ival) == FAIL) return FAIL;
	ST.push(ival);
	break;
      case at_real:
	if (arr->get_value(i, rval) == FAIL) return FAIL;
	ST.push(rval);
	break;
      case at_complex:
	if (arr->get_value(i, cval) == FAIL) return FAIL;
	ST.push(cval);
	break;
    }

    return OKAY;
}

// f_putarray: ͤ򥻥åȤ
//  å: :  ź 
//            : ʤ
int
f_putarray(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    array*	arr;
    int 	i;
    int 	ival;
    float	rval;
    complex	cval;
    node_type	nt;

    nt = ST.sttype();
    switch (nt) {
      case nt_int:     ST.pop(ival); break;
      case nt_real:    ST.pop(rval); break;
      case nt_complex: ST.pop(cval); break;
      default: return FAIL;
    }
    if (ST.pop(i) == FAIL) return FAIL;
    if (ST.pop(arr) == FAIL) return FAIL;
    switch (arr->get_type()) {
      case at_int:
	switch (nt) {
	  case nt_int:
	    if (arr->set_value(i, ival) == FAIL) return FAIL;
	    break;
	  case nt_real:
	    if (arr->set_value(i, (int)rval) == FAIL) return FAIL;
	    break;
	  case nt_complex:
	    return FAIL;
	  default:
	    break;
	}
	break;
      case at_real:
	switch (nt) {
	  case nt_int:
	    if (arr->set_value(i, (float)ival) == FAIL) return FAIL;
	    break;
	  case nt_real:
	    if (arr->set_value(i, rval) == FAIL) return FAIL;
	    break;
	  case nt_complex:
	    return FAIL;
	  default:
	    break;
	}
	break;
      case at_complex:
	switch (nt) {
	  case nt_int:
	    if (arr->set_value(i, (complex)ival) == FAIL) return FAIL;
	    break;
	  case nt_real:
	    if (arr->set_value(i, (complex)rval) == FAIL) return FAIL;
	    break;
	  case nt_complex:
	    if (arr->set_value(i, cval) == FAIL) return FAIL;
	    break;
	  default:
	    break;
	}
	break;
    }

    return OKAY;
}

// f_idtoarray: ID () Ѵ
//  å: : array_id sub_id
//            : 
int
f_idtoarray(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    int    array_id;
    int    sub_id;
    array* arr;

    if (ST.pop(sub_id)   == FAIL) return FAIL;
    if (ST.pop(array_id) == FAIL) return FAIL;
    if ((arr = AL.search(array_id, sub_id)) == NULL) {
	fprintf(stderr, "f_idtoarray: array_id %d, sub_id %d not found\n",
		array_id, sub_id);
	return FAIL;
    }
    ST.push(arr);

    return OKAY;
}

// f_transarray: ž׵Ф
//  å: : array_id sub_id ipu_no (sub_id ž(ʬ) id)
//            : 
int
f_transarray(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    int    array_id;
    int    sub_id;
    int    ipu_no;
    array* arr;

    if (ST.pop(ipu_no) == FAIL) return FAIL;
    if (ST.pop(sub_id) == FAIL) return FAIL;
    if (ST.pop(array_id) == FAIL) return FAIL;

    fprintf(stderr, "f_transarray: array_id:%d, sub_id:%d, ipu_no:%d\n",
	    array_id, sub_id, ipu_no);

    ipu_ipu msg;
    msg.t_msg = new trans_msg;
    msg.a_info = new array_id_info;

    // ȥ󥹥ФؤΥå
    msg.t_msg->type      = p_ii_array_request;
    msg.t_msg->ipu_no    = ipu_no;
    msg.a_info->array_id = array_id;
    msg.a_info->sub_id   = sub_id;

    // 
    trans_q.putmsg(msg);

    array_wait_list.wait(array_id, sub_id);

    if ((arr = AL.search(array_id, sub_id)) == NULL) {
	fprintf(stderr, "f_transarray: AL.search(%d, %d) failed\n",
		array_id, sub_id);
	return FAIL;
    }
    ST.push(arr);

    return OKAY;
}

// f_subarray: sub
//  å: :  sub_id subarrayθĿ
//            : 
int
f_subarray(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    int    sub_id;
    int    n_subs;
    array* arr_org;
    array* arr_sub;

    if (ST.pop(n_subs) == FAIL) return FAIL;
    if (ST.pop(sub_id) == FAIL) return FAIL;
    if (ST.pop(arr_org) == FAIL) return FAIL;
    arr_sub = new array(arr_org->get_type(), arr_org->get_size());
    arr_sub->set_array_id(arr_org->get_array_id());
    arr_sub->set_sub_id(sub_id);
    arr_sub->set_sub_num(n_subs);
    void* data_org = arr_org->get_ptr();
    void* data_sub = arr_sub->get_ptr();
    memcpy(data_sub, data_org, arr_org->get_size() * arr_org->get_width());

    AL.append(arr_sub);
    ST.push(arr_sub);

    return OKAY;
}

// f_arraytoimage: 󤫤
//  å: :  ϲ ϲι⤵
//            : 
int
f_arraytoimage(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    array* arr;
    int    width;
    int    height;

    if (ST.pop(height) == FAIL)	return FAIL;
    if (ST.pop(width) == FAIL)	return FAIL;
    if (ST.pop(arr) == FAIL)	return FAIL;
    if (arr->get_size() != width*height) {
	fprintf(stderr, "f_arraytoimage: size mismatch\n");
	return FAIL;
    }

    // OM  image ID ׵
    int image_id = get_new_image_id();

    pixel_type pt;
    int one_size;
    switch (arr->get_type()) {
      case at_int:     pt = pt_int;     one_size = sizeof(int);     break;
      case at_real:    pt = pt_real;    one_size = sizeof(float);   break;
      case at_complex: pt = pt_complex; one_size = sizeof(complex); break;
    }
    Image* img = new GrayImage(image_id, -1);
    img->setparam(width, height, 0, 0, pt, 0);
    img->setorgsize(width, height);

    int      x, y;
    int*     iimg;
    int*     iarr;
    float*   fimg;
    float*   farr;
    complex* cimg;
    complex* carr;
    if (pt == pt_int) {
	iimg = (int*)img->get_image();
	iarr = (int*)arr->get_ptr();
    } else if (pt == pt_real) {
	fimg = (float*)img->get_image();
	farr = (float*)arr->get_ptr();
    } else if (pt == pt_complex) {
	cimg = (complex*)img->get_image();
	carr = (complex*)arr->get_ptr();
    }
    // ͤ
    // ͤ¤ӤȲǰ㤦
    //  C Ʊ (x0,y0 x0,y1 x0,y2 ...)
    // ϵ (x0,y0 x1,y0 x2,y0 ...)
    //  a[x][y] Ȥʤ褦ˤؤ
    for (y = 0; y < height; y++) {
	for (x = 0; x < width; x++) {
	    if (pt == pt_int) {
		iimg[y*width + x] = iarr[x*height + y];
	    } else if (pt == pt_real) {
		fimg[y*width + x] = farr[x*height + y];
	    } else if (pt == pt_complex) {
		cimg[y*width + x] = carr[x*height + y];
	    }
	}
    }

    OL.append(img);
    ST.push(img);

    // OM 
    out_info*   o_info   = new out_info;
    image_info* img_info = new image_info;
    o_info->out_num = 1;
    o_info->job_id  = -1;
    img->get_image_info(*img_info);
    module_donerep("arraytoimage", o_info, img_info, OKAY);

    return OKAY;
}
