/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  function.cc
*********************************************************************/

#include <stdlib.h>
#include <unistd.h>
#include "Image.h"
#include "GrayImage.h"
#include "ObjList.h"
#include "stack.h"
#include "def.h"
#include "etc.h"
#include "protocol.h"
#include "vom.h"
#include "keyword.h"
#include "function.h"

void gettimes(int,int,int,int,int,int,int,int,int&,int&,int&,int&);

// ɽ
//   å: : 
//             : ʤ
int
f_disp(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image*	img;
    int 	st;
    if (ST.pop(img) == FAIL) st = FAIL;

    if (st == FAIL) {
	fprintf(stderr, "f_disp: syntax error in disp\n");
    } else {
	st = img->display();
    }

    // disp  dlmodule ĤʤΤǤǤ done_report ʤ

    return st;
}

// 顼ɽ
//   å: : r g b
//             : ʤ
int
f_cdisp(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image*	img[3]; // img[0]:r, img[1]:g, img[2]:b

    int 	st = OKAY;

    if (ST.pop(img[2]) == FAIL) 	st = FAIL;
    else if (ST.pop(img[1]) == FAIL)	st = FAIL;
    else if (ST.pop(img[0]) == FAIL)	st = FAIL;

    if (st == FAIL) {
	fprintf(stderr, "f_cdisp: syntax error in disp\n");
    } else {
	st = img[0]->cdisplay((GrayImage**)img);
    }

    // disp  dlmodule ĤʤΤǤǤ done_report ʤ

    return st;
}

// 쥤ɤ߹
//   å: :  ե̾(string)
//             : ʤ
int
f_load(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    char*	filename = NULL;
    Image*	img;

    out_info*	o_info = new out_info;
    image_info*	img_info = new image_info;

    int 	st = OKAY;

    if (ST.sttype() != nt_string)	st = FAIL;
    else if (ST.pop(filename) == FAIL)	st = FAIL;
    else if (ST.pop(img) == FAIL)	st = FAIL;

    if (st == FAIL) {
	fprintf(stderr, "syntax error in load\n");
    } else {
	if (img->load(filename) == FAIL) {
	    st = FAIL;
	    fprintf(stderr, "exec error in load\n");
	} else {
	    img->get_image_info(*img_info);
	}
    }
    o_info->out_num = 1;
    o_info->job_id = -1;
    delete[] filename;

    module_donerep("load", o_info, img_info, st);

    return OKAY;
}

// 顼ɤ߹
//   å: : R G B ե̾(string)
//             : ʤ
int
f_cload(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    char*	filename = NULL;
    Image*	img[3]; // img[0]:r, img[1]:g, img[2]:b

    out_info*	o_info = new out_info;
    image_info*	img_info = new image_info[3];

    int 	st = OKAY;

    if (ST.sttype() != nt_string)	st = FAIL;
    else if (ST.pop(filename) == FAIL)	st = FAIL;
    else if (ST.pop(img[2]) == FAIL)	st = FAIL;
    else if (ST.pop(img[1]) == FAIL)	st = FAIL;
    else if (ST.pop(img[0]) == FAIL)	st = FAIL;

    if (st == FAIL) {
	fprintf(stderr, "syntax error in cload\n");
    } else {
	if (img[0]->cload(filename, (GrayImage**)img) == FAIL) {
	    st = FAIL;
	    fprintf(stderr, "exec error in cload\n");
	} else {
	    int i;
	    for (i = 0; i < 3; i++) {
		img[i]->get_image_info(img_info[i]);
	    }
	}
    }
    o_info->out_num = 3;
    o_info->job_id = -1;
    delete[] filename;

    module_donerep("cload", o_info, img_info, st);

    return OKAY;
}

// 顼¸
//   å: : R G B ե̾(string)
//             : ʤ
int
f_csave(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    char*	filename = NULL;
    int 	st = OKAY;
    Image*	img[3]; // img[0]:r, img[1]:g, img[2]:b

    if (ST.sttype() != nt_string)	st = FAIL;
    else if (ST.pop(filename) == FAIL)	st = FAIL;
    else if (ST.pop(img[2]) == FAIL)	st = FAIL;
    else if (ST.pop(img[1]) == FAIL)	st = FAIL;
    else if (ST.pop(img[0]) == FAIL)	st = FAIL;

    if (st == FAIL) {
	fprintf(stderr, "f_csave: syntax error in csave\n");
    } else {
	char* p = strrchr(filename, '.');
	int mode;
	if (p != NULL && strcmp(p, ".ppm") == 0) {
	    mode = 1;
	} else {
	    mode = 0;
	}
	if ((st = img[0]->csave(filename, mode, (GrayImage**)img)) == FAIL)
	    fprintf(stderr, "f_save: exec error in csave\n");
    }
    delete[] filename;

    // save  dlmodule ĤʤΤǤǤ done_report ʤ

    return OKAY;
}

// ¸
//   :  ե̾(string)
//   : ʤ
int
f_save(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    char*	filename = NULL;
    int 	st = OKAY;
    Image*	img;

    if (ST.sttype() != nt_string)	st = FAIL;
    else if (ST.pop(filename) == FAIL)	st = FAIL;
    else if (ST.pop(img) == FAIL)	st = FAIL;

    if (st == FAIL) {
	fprintf(stderr, "f_save: syntax error in save\n");
    } else {
	char* p = strrchr(filename, '.');
	int mode;
	if (p != NULL && strcmp(p, ".pgm") == 0) {
	    mode = 1;
	} else {
	    mode = 0;
	}
	if ((st = img->save(filename, mode)) == FAIL)
	    fprintf(stderr, "f_save: exec error in save\n");
    }
    delete[] filename;

    // save  dlmodule ĤʤΤǤǤ done_report ʤ

    return OKAY;
}

// -------- ޤȤ߹ߥ⥸塼 --------

// -------- 鲼ϥ --------

// 
//   å: : ʬ1 .. n  ʬ
//             : ʤ
static int
f_join_body(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT;
    int 	num, i;
    Image*	out;
    Image**	divimg = NULL;

    out_info*	o_info = new out_info;
    image_info*	img_info = new image_info;

#ifdef DEBUG
    int h,m,s,us;
    gettime(h,m,s,us);
    fprintf(stderr, " join start:  %2d:%2d.%2d %6d\n", h,m,s,us);
#endif

    int 	st = OKAY;

    if (ST.pop(num) == FAIL)		st = FAIL;
    else if (ST.pop(out) == FAIL)	st = FAIL;

    if (st != FAIL) {
	divimg = new Image*[num];
	for (i = num - 1; i >= 0 && st != FAIL; i--) {
	    if (ST.pop(divimg[i]) == FAIL)	st = FAIL;
	}
    }

    if (st == FAIL) {
	fprintf(stderr, "syntax error in join\n");
    } else {
	if ((st = out->join(num, divimg)) == FAIL) {
	    // out ä
	    fprintf(stderr, "exec error in join\n");
	    OL.remove(out);
	} else {
	    out->get_image_info(*img_info);
	}
    }
    o_info->out_num = 1;
    o_info->job_id = -1;
    delete[] divimg;

    module_donerep("join", o_info, img_info, st);

#ifdef DEBUG
    gettime(h,m,s,us);
    fprintf(stderr, " join done:  %2d:%2d.%2d %6d\n", h,m,s,us);
#endif

    return st;
}

int
f_join(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    stack* ST2 = new stack;
    int in;
    int out = 1;
    int param = 1;
    int st;

    if (ST.pop(in) == FAIL) {
	fprintf(stderr, "pre_join: syntax error\n");
	return FAIL;
    }
    ST.push(in);

    if (ST.split2stack(*ST2, in + out + param) == FAIL) {
	fprintf(stderr, "pre_join: stack underflow\n");
	return FAIL;
    }

    // not thread
    st = f_join_body(*ST2, TA, FT, OL);
    delete ST2;

    return st;
}

// ʬ䤹
//   å: : ϲ ϲ1 .. n xʬ xʬǾñ
//                   yʬ yʬǾñ Ȥ礭 ʬˡ
//             : ʤ
static int
f_split_body(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT;
    int 	i;
    int 	div_type, cache, x_num, x_unit, y_num, y_unit, num;
    Image*	in;
    Image**	divimg = NULL;

    out_info*	o_info = new out_info;
    image_info*	img_info = NULL;

    int 	st = OKAY;

#ifdef DEBUG
    ST.print();
    fprintf(stderr, "\n");
#endif

    if (ST.pop(div_type) == FAIL) st = FAIL;
    else if (ST.pop(cache) == FAIL) st = FAIL;
    else if (ST.pop(y_unit) == FAIL) st = FAIL;
    else if (ST.pop(y_num) == FAIL)  st = FAIL;
    else if (ST.pop(x_unit) == FAIL) st = FAIL;
    else if (ST.pop(x_num) == FAIL)  st = FAIL;

    if (st == FAIL) {
	fprintf(stderr, "split sytax error\n");
    }

#ifdef DEBUG
    fprintf(stderr, "x_num:%d, x_unit:%d, y_num:%d, y_unit:%d, cache:%d\n",
	    x_num, x_unit, y_num, y_unit, cache);
#endif

    if (st != FAIL) {
	num = x_num*y_num;
	divimg = new Image*[num];
	for (i = num-1; i >= 0 && st != FAIL; i--) {
	    if (ST.pop(divimg[i]) == FAIL) {
		fprintf(stderr, "syntax error in split (no output image)\n");
		st = FAIL;
	    }
	}
    }

    if (st != FAIL && ST.pop(in) == FAIL) {
	fprintf(stderr, "syntax error in split (no input image)\n");
	st = FAIL;
    }

#if DEBUG
    printf("in image 0x%08x\n", (int)in);
    for (i = 0; i < num; i++) {
	printf("div image %2d 0x%08x\n", i, (int)divimg[i]);
    }
#endif

    if (st != FAIL) {
	st = in->split(x_num, x_unit, y_num, y_unit, cache, divimg);
	if (st == FAIL) {
	    fprintf(stderr, "exec error in split\n");
	    // divimg ä
	    for (i = 0; i < num; i++) {
		OL.remove(divimg[i]);
	    }
	    o_info->out_num = 0;
	} else {
	    o_info->out_num = num;

	    if (num == 1) {
		// delete Ȥ num == 1  [] ʤ delete Τ
		// new Ȥ [] ʤ new 
		img_info = new image_info;
	    } else {
		img_info = new image_info[num];
	    }
	    for (i = 0; i < num; i++) {
		divimg[i]->get_image_info(img_info[i]);
		img_info[i].div_type = div_type;
	    }
	}
    } else {
	o_info->out_num = 0;
    }
    o_info->job_id = -1;
    module_donerep("split", o_info, img_info, st);
    delete[] divimg;

    return st;
}

int
f_split(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    int x, xu, y, yu, cache, d_type;
    stack* ST2 = new stack;
    int in = 1;
    int out;
    int param = 6; // xn, xuint, yn, yunit, cache, divtype
    int st = OKAY;

    // ϲθĿĴ٤
    if (ST.pop(d_type) == FAIL) st = FAIL;
    else if(ST.pop(cache) == FAIL) st = FAIL;
    else if(ST.pop(yu) == FAIL) st = FAIL;
    else if(ST.pop(y)  == FAIL) st = FAIL;
    else if(ST.pop(xu) == FAIL) st = FAIL;
    else if(ST.pop(x)  == FAIL) st = FAIL;
    if (st == FAIL) {
	fprintf(stderr, "f_split: syntax error\n");
	return FAIL;
    }

    out = x * y;

    ST.push(x);
    ST.push(xu);
    ST.push(y);
    ST.push(yu);
    ST.push(cache);
    ST.push(d_type);

    if (ST.split2stack(*ST2, in + out + param) == FAIL) {
	fprintf(stderr, "f_split: stack underflow\n");
	return FAIL;
    }

    st = f_split_body(*ST2, TA, FT, OL);
    delete ST2;

    return st;
}
