/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  gettoken.cc
    lang_q ץ (IPU-p) ꡢȡʬ䤷
    gettoken() ̤ƥȡ֤
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "def.h"
#include "gettoken.h"
#include "Image.h"
#include "protocol.h"
#include "msgqueue.h"

static char*	get_prog(int& size_ret);
static int	getch();		// ʸäƤ
static int	whitespace(int c);	// ڡɤȽ

extern	msgqueue lang_q;

// lang_q ץäƤ
static char*
get_prog(int& size_ret)
{
    static int	eof_flag = 0;
    ipu_ipu	msg;

    if (eof_flag) return NULL;

    lang_q.getmsg(msg);

    if (msg.i_info == NULL) {
	// λå褿
	eof_flag = 1;
	return NULL;
    }

    size_ret = msg.i_info->size;
    delete msg.i_info;

    return msg.buf;
}

// 1ʸᤷ
static int ungetflag = 0;
static int ungetbuf;

static int
ungetch(int c)
{
    if (ungetflag) {
	fprintf(stderr, "ungetch: internal error\n");
	return EOF;
    }
    ungetflag = 1;
    ungetbuf = c;
    return 0;
}

// OM 褿ץफ1ʸäƤ
static int
getch()
{
    static char* buf = NULL;
    static int   buf_size;
    static int   i;
    int          c;

    if (ungetflag) {
	ungetflag = 0;
	return ungetbuf;
    }

    if (buf == NULL || i > buf_size) { // i >= buf_size ǤϤʤ
	if (buf != NULL) delete[] buf;
	buf = get_prog(buf_size);
	if (buf == NULL) {
	    return EOF;
	}
	i = 0;
    }

    // åȥåδ֤Ǥ ' ' ֤
    c = (i < buf_size) ? buf[i] : ' ';
    i++;

    return c;
}

// c ʸɤĴ٤
// ʤ鿿Ǥʤʤ鵶֤
static inline int
whitespace(int c)
{
    return (c == '\0' || c == '\t' || c == ' ' || c == '\n');
}

// c ̾˻Ȥʤʸ(üʸ)ʤ鿿֤
static inline int
special_char(int c)
{
    return (c == '%' || c == '/' || c == '{' || c == '}' || c == '[' ||
	    c == ']' || c == '(' || c == ')' || c == '<' || c == '>');
}


// Хؿ
//   int gettoken(char* token, int bufsize)
// OM 褿ץफȡڤФ֤
// ΤȤ OM ץबޤԤ
// ؿ:  OKAYEOF  FAIL
int
gettoken(char* token, int bufsize)
{
    int i=0;
    int c;
    int s_level; //  ( Υ٥

    // ڡ & ɤߤȤФ
    for (;;) {
	while (whitespace(c = getch())) ; // ڡɤߤȤФ
	if (c == '%') {
	    while ((c = getch()) != '\n' && c != EOF) ; // ޤɤߤȤФ
	    if (c == EOF) {
		break;
	    }
	} else {
	    break;
	}
    }

    if (c == EOF) {
	fprintf(stderr, "gettoken: EOF\n");
	return FAIL;
    }

#define addch(c) ((void)((i < bufsize) && (token[i++] = (c))))

    // ȡڤФơѰդ줿Хåեإԡ
    switch (c) {
      case '{':
      case '}':
	addch(c);
	break;
      case '(':
	addch(c);
	s_level = 1;
	for (;;) {
	    c = getch();
	    if (c == EOF) {
		fprintf(stderr, "unexpected EOF in string\n");
		break;
	    } else if (c == '(') {
		addch(c);
		s_level++;
	    } else if (c == ')') {
		addch(c);
		s_level--;
		if (s_level <= 0) {
		    break;
		}
	    } else if (c == '\\') {
		c = getch();
		if (c == EOF) {
		    fprintf(stderr, "unexpected EOF in string\n");
		    break;
		} else if (c >= '0' && c <= '7') {
		    int c2, c3;
		    c -= '0';
		    if ((c2 = getch() - '0') >= 0 && c2 <= 7) {
			if ((c3 = getch() - '0') >= 0 && c3 <= 7) {
			    addch((c << 6) | (c2 << 3) | c3);
			} else {
			    addch((c << 3) | c2);
			}
		    } else {
			addch(c);
		    }
		} else {
		    switch (c) {
		      case 'n':  addch('\n'); break;
		      case 'r':  addch('\r'); break;
		      case 't':  addch('\t'); break;
		      case 'b':  addch('\b'); break;
		      case '\\': addch('\\'); break;
		      case '(':  addch('(');  break;
		      case ')':  addch(')');  break;
		      case '\n':              break;
		      default:   addch(c);    break;
		    }
		}
	    } else {
		addch(c);
	    }
	}
	break;
      case '<':
      case '[':
	fprintf(stderr, "%c not implemented\n", c);
	addch(c);
	break;
      case ')':
      case '>':
      case ']':
	fprintf(stderr, "syntax error %c\n", c);
	addch(c);
	break;
      default:
	do {
	    addch(c);
	} while (!whitespace(c = getch()) && c != EOF && !special_char(c));
	if (c != EOF) ungetch(c);
	break;
    }

    if (i < bufsize) {
	addch('\0');
    } else {
	fprintf(stderr, "gettoken: buffer overflow\n");
	if (bufsize > 0) token[bufsize-1] = '\0';
    }

#ifdef DEBUG
    //fprintf(stderr, "gettoken: token `%s'\n", token);
#endif

    return OKAY;
}
