/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  ipu_list.h
    IPUΥۥֹ̾бɽ
*********************************************************************/

#ifndef IPU_LIST_H
#define IPU_LIST_H

#include <string.h>
#include "etc.h"

class ipu_list {
  private:
    ipu_list*	next;
    char*	hostname;
    int 	ipu_no;

    ipu_list* search(int no) {
	ipu_list* p;
	for (p = next; p != NULL; p = p->next) {
	    if (p->ipu_no == no) {
		return p;
	    }
	}
	return NULL;
    }
    ipu_list* search(char* name) {
	ipu_list* p;
	for (p = next; p != NULL; p = p->next) {
	    if (strcmp(p->hostname, name) == 0) {
		return p;
	    }
	}
	return NULL;
    }

  public:
    ipu_list() {
	next = NULL;
    }
    ~ipu_list() {
	delete[] hostname;
	delete   next;
    }

    void append(int no, char* name) {
	if (search(no) != NULL) return;
	ipu_list* new_ipu = new ipu_list;
	new_ipu->next = next;
	new_ipu->ipu_no = no;
	new_ipu->hostname = strdup_new(name);
	next = new_ipu;
    }
    int get_ipu_no(char* name) {
	ipu_list* p = search(name);
	if (p != NULL) return p->ipu_no;
	return -1;
    }
    char* get_hostname(int no) {
	ipu_list* p = search(no);
	if (p != NULL) return p->hostname;
	return NULL;
    }

    // ǥХå
    void print_sub() {
	if (next != NULL) next->print_sub();
	printf("ipus: %d %s\n", ipu_no, hostname);
    }
    void print() {
	if (next != NULL) next->print_sub();
    }
};

#endif /* IPU_LIST_H */
