/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  keyword.cc
    IPU-p Υɤ
*********************************************************************/

#include "def.h"
#include "keyword.h"
#include "calc.h"
#include "relation.h"
#include "conv.h"
#include "control.h"
#include "obj.h"
#include "function.h"
#include "f_array.h"
#include "dlmodule.h"

// ե󥯥 (Ȥ߹ߥ⥸塼)

#define KF_NUM (sizeof(k_func)/sizeof(k_func[0]))

static keyfunc_t k_func[] = {     // 
    // ̾   ؿ in out param
    {"cdisp", &f_cdisp, 3, 0, 0}, // input(r,g,b)
    {"cload", &f_cload, 0, 3, 1}, // output(r,g,b) filename
    {"csave", &f_csave, 3, 0, 1}, // input(r,g,b) filename
    {"disp",  &f_disp,  1, 0, 0}, // input
    {"load",  &f_load,  0, 1, 1}, // output filename
    {"save",  &f_save,  1, 0, 1}, // input filename
//    {"print", &f_print, 0, 0, 1}, // value print
};

// ե󥯥󸡺
// ʬƤ (ȤƤ)
keyfunc_t*
check_keyfunc(char* token)
{
    int t = 0;		// t : top    of search region
    int b = KF_NUM - 1;	// b : botom  of search region
    int l;		// l : search node (center of search region)
    int c;		// c : compare result

    while (t <= b)
    {
	l = (t + b) / 2;
	c = strcmp(token, k_func[l].keyfunc);
	if (c == 0)	return &k_func[l];
	else if (c < 0)	b = l - 1;
	else 		t = l + 1;
    }
    return NULL;
}

// 
//  ȤƤ

static keyword_t k_table[] = {
    { "==",           &f_equal2      },
    { "acos",         &f_acos        }, // num           -> acos(num)
    { "add",          &f_add         }, // num1 num2     -> num1+num2
    { "aget",         &f_aget        }, // Img x y       -> Img[y][x]
    { "and",          &f_and         }, // bool1 bool2   -> bool1 & bool2
    { "aput",         &f_aput        }, // Img x y num   -> - (Img[y][x]=num)
    { "arraytoimage", &f_arraytoimage},
    { "asin",         &f_asin        }, // num           -> asin(num)
    { "atan",         &f_atan        }, // num           -> atan(num)
    { "cache",        &f_cache       },
    { "continue",     &f_continue    },
    { "cos",          &f_cos         }, // num           -> cos(num)
    { "createobj",    &f_createobj   }, // Img w h hx hy -> - (Img param set)
    { "cvc",          &f_cvc         }, // num num	 ->
    { "cvi",          &f_cvi         },
    { "cvr",          &f_cvr         },
    { "def",          &f_def         },
    { "deleteobj",    &f_deleteobj   },
    { "dexec",        &f_dexec       },
    { "dfdef",        &f_dfdef       },
    { "div",          &f_div         },
    { "dsync",        &f_dsync       },
    { "dup",          &f_dup         },
    { "eq",           &f_eq          },
    { "exch",         &f_exch        },
    { "exec",         &f_exec        },
    { "exit",         &f_exit        },
    { "exp",          &f_exp         },
    { "false",        &f_false       },
    { "fdef",         &f_fdef        },
    { "for",          &f_for         },
    { "ge",           &f_ge          },
    { "get",          &f_get         },
    { "getarray",     &f_getarray    },
    { "gt",           &f_gt          },
    { "height",       &f_height      },
    { "hotx",         &f_hotx        },
    { "hoty",         &f_hoty        },
    { "idtoarray",    &f_idtoarray   },
    { "idtoimage",    &f_idtoimage   },
    { "if",           &f_if          },
    { "ifelse",       &f_ifelse      },
    { "intarray",     &f_intarray    },
    { "itype",        &f_itype       },
    { "join",         &f_join        },
    { "le",           &f_le          },
    { "log",          &f_log         },
    { "loop",         &f_loop        },
    { "lt",           &f_lt          },
    { "main",         &langm         },
    { "mod",          &f_mod         },
    { "mul",          &f_mul         },
    { "ne",           &f_ne          },
    { "neg",          &f_neg         },
    { "newidimage",   &f_newidimage  },
    { "newimage",     &f_newimage    },
    { "not",          &f_not         },
    { "obj",          &f_obj         },
    { "or",           &f_or          },
    { "pop",          &f_pop         },
    { "pow",          &f_pow         },
    { "pstack",       &f_pstack      },
    { "put",          &f_put         },
    { "putarray",     &f_putarray    },
    { "quit",         &f_quit        },
    { "realarray",    &f_realarray   },
    { "repeat",       &f_repeat      },
    { "roll",         &f_roll        },
    { "sin",          &f_sin         },
    { "split",        &f_split       },
    { "sqrt",         &f_sqrt        },
    { "sub",          &f_sub         },
    { "subarray",     &f_subarray    },
    { "tan",          &f_tan         },
    { "transarray",   &f_transarray  },
    { "transimage",   &f_transimage  },
    { "true",         &f_true        },
    { "type",         &f_type        },
    { "waitarray",    &f_waitarray   },
    { "width",        &f_width       },
    { "xor",          &f_xor         },
};

#define KT_NUM (sizeof(k_table)/sizeof(k_table[0]))

// ɸ

keyword_t*
check_keyword(char* token)
{
    keyword_t* top    = k_table;
    keyword_t* bottom = k_table + (KT_NUM - 1);
    keyword_t* cur;
    int        c;

    while (top <= bottom) {
	cur = k_table + ((top - k_table) + (bottom - k_table)) / 2;
	c = strcmp(token, cur->keyword);
	if (c == 0)	return cur;
	else if (c < 0)	bottom = cur - 1;
	else 		top    = cur + 1;
    }
    return NULL;
}
