/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  lang.cc
    IPU-p 󥿥ץ꥿ ᥤ
*********************************************************************/

#include <stdio.h>
#include <string.h>
#include <pthread.h>
#include "def.h"
#include "stack.h"
#include "table.h"
#include "ftable.h"
#include "ObjList.h"
#include "command.h"
#include "gettoken.h"
#include "block.h"
#include "lang.h"

#define MAXTOKEN	256	// token ϡ256-1('\0') == 255 ʸ

// lang.cc ΥؿΥץȥ

// langb(): ץǤΥ֥å ("{""}"ǰϤޤ줿ʬ) ɤ߹ؿ
static ipu_p_block* langb(stack&, table&, ftable&, ObjectList&);

// void lang0()
//   IPU-p 󥿥ץ꥿ᥤ
void
lang0()
{
    char	token[MAXTOKEN];
    stack	ST;  // IPU-p å
    table	TA;  // ѿơ֥
    ftable	FT;  // ؿ (⥸塼) ơ֥
    extern ObjectList OL;

    for (;;) {
	if (gettoken(token, MAXTOKEN) != OKAY) {
	    // error or EOF
	    break;
	}
	if (strcmp(token, "{") == 0) {
	    // "{" 褿֥å 	// }
	    ipu_p_block* b;
	    b = langb(ST, TA, FT, OL);
	    // "{"  "}" ޤɤ߹ǥå push!
	    ST.push(b);
	    delete b;
	} else {
	    // "{" Ǥʤʤ command0 Ƥ       // }
	    int st;
	    st = command0(token, ST, TA, FT, OL);
	    if (st == IPUP_QUIT) {
		break;
	    } else if (st == IPUP_EXIT) {
		// exit  C  break
		// { } γ exit ΤϤ
		fprintf(stderr, "lang0: error, bad exit\n");
	    } else if (st == IPUP_CONTINUE) {
		// { } γ continue ΤϤ
		fprintf(stderr, "lang0: error, bad continue\n");
	    } else if (st == FAIL) {
		fprintf(stderr, "lang0: error in `%s'\n", token);
	    }
	}
    }
}

// ץǤΥ֥å ("{""}"ǰϤޤ줿ʬ) ɤ߹ؿ
// ɤ߹֥å򥳡ɲ ipu_p_block* Ȥ֤
static ipu_p_block*
langb(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    char		token[MAXTOKEN];
    int 		st;
    ipu_p_block_body*	bodyp = new ipu_p_block_body;

    for (;;) {
	st = gettoken(token, MAXTOKEN);
	if (strcmp(token, "}") == 0 || st != OKAY) {
	    // "}" 褿Τǥ֥å // {
	    break;
	} else if (strcmp(token, "{") == 0) {
	    // "{" 褿֥åҤˤʤäƤ    // }
	    // langb ƵƤӽФ
	    ipu_p_block* bp;
	    bp = langb(ST, TA, FT, OL);
	    bodyp->def(bp);
	} else {
	    bodyp->def(token);
	}
    }
    return new ipu_p_block(bodyp);
}

// langn: if ʤɤƤФ롢֥åμ¹ԤԤؿ
int
langn(ipu_p_block* b, stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    ipu_p_code_t c;
    int 	 ret_stat;
    int 	 com_stat;

    for (;;) {
	c = b->checktype();
	if (c == ic_null) {
	    // ֥åλ
	    ret_stat = OKAY;
	    break;
	}
	com_stat = command1(b, ST, TA, FT, OL);
	if (com_stat == IPUP_EXIT || com_stat == IPUP_QUIT ||
	    com_stat == IPUP_CONTINUE)
	{
	    ret_stat = com_stat;
	    break;
	}
    }
    return ret_stat;
}

// main μ¹

struct langm_arg {
    stack* ST;
    table* TA;
    ftable* FT;
    ObjectList* OL;
};

static int
langm_body(langm_arg* arg)
{
    int st;
    stack* ST = arg->ST;
    ipu_p_block* b;

    if (ST->pop(b) == FAIL) {
	st = FAIL;
    } else {
	st = langn(b, *ST, *arg->TA, *arg->FT, *arg->OL);
    }

    delete arg;
    delete ST;
    return st;
}

int
langm(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    stack* ST2 = new stack;

    if (ST.split2stack(*ST2, 1) == FAIL) {
	fprintf(stderr, "langm: stack underflow\n");
	return FAIL;
    }

    // ip2 

    langm_arg* arg = new langm_arg;
    arg->ST = ST2; arg->TA = &TA; arg->FT = &FT; arg->OL = &OL;
    pthread_t tid;
    pthread_attr_t attr;
    pthread_attr_init(&attr);
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
    pthread_create(&tid, &attr, (void *(*)(void*))langm_body, (void*)arg);

    return OKAY;
}
