/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  main.cc
    IPU ᥤ
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <signal.h>
#include <unistd.h>
#include "ObjList.h"
#include "protocol.h"
#include "msgqueue.h"
#include "sync.h"
#include "etc.h"
#include "vom.h"
#include "priodef.h"
#include "trans.h"
#include "lang.h"
#include "dlmodule.h"
#include "com.h"
#include "port.h"

ObjectList	OL;

msgqueue	trans_q;
msgqueue	lang_q;
msgqueue	dmod_q;
msgqueue	send_q;

int 		quit_flag = 0;
int             ip1       = 1; // ip1 θĿ

static void	usage(char* program_name);

//
// ᥤؿ
//
int
main(int argc, char** argv)
{
    char*	om_host = "localhost";
    int 	om_port = get_om_port();
    int 	ipu_port = get_ipu_port();
    int 	ipu_server_fd;

#ifdef DEBUG
    // ɸϤɸ२顼ϤΥȥ꡼ΥХåե󥰤ʤ(ǥХå)
    cout.setf(ios::unitbuf);
    cerr.setf(ios::unitbuf);
#endif

    // ñʰ


    int	i;
    for (i = 1; i < argc; i++) {
	if ((strcmp(argv[i], "-host") == 0 ||
	     strcmp(argv[i], "-h"   ) == 0   ) && i+1 < argc)
	{
	    i++;
	    om_host = argv[i];
	} else if ((strcmp(argv[i], "-port") == 0 ||
		    strcmp(argv[i], "-op"   ) == 0   ) && i+1 < argc)
	{
	    i++;
	    om_port = atoi(argv[i]);
	} else if (strcmp(argv[i], "-ip1") == 0 && i+1 < argc) {
	    i++;
	    ip1 = atoi(argv[i]);
	    if (ip1 < 1) {
		usage(argv[0]);
		return 1;
	    }
	} else if (strcmp(argv[i], "-ip") == 0 && i+1 < argc) {
	    i++;
	    ipu_port = atoi(argv[i]);
	} else {
	    usage(argv[0]);
	    return 1;
	}
    }

    // get_hostname 
    get_hostname_first();

    // IPU ̿ФεһҤ
    if ((ipu_server_fd = setup_server(ipu_port)) < 0) {
	fprintf(stderr, "can't setup ipu server (port %d)\n", ipu_port);
	return 1;
    }

    // OM Ȥ ̿ϩݤ IPU ߥå
    if (connect_om(om_host, om_port, ip1) < 0) {
	// 顼
	close(ipu_server_fd);
	return 1;
    }

    quit_set(ipu_server_fd, ipu_port);

    // åɤκ

    int* port_param = new int; // ȥ󥹥
    *port_param = ipu_port;
    int* fd_param   = new int; // 쥷֥
    *fd_param = ipu_server_fd;

    pthread_t		tid;
    pthread_attr_t	attr;
    pthread_attr_init(&attr);
    struct sched_param 	s_param;

    // ȥ󥹥С
    s_param.sched_priority = PRIO_TRANS_SERV;
    pthread_attr_setschedparam(&attr, &s_param);
    pthread_create(&tid, &attr, (void* (*)(void*))trans_server, port_param);

    // 쥷֥С
    s_param.sched_priority = PRIO_RECEIVE_SERV;
    pthread_attr_setschedparam(&attr, &s_param);
    pthread_create(&tid, &attr, (void* (*)(void*))receive_server, fd_param);

    // ơݡ
    s_param.sched_priority = PRIO_STAT_REPORT;
    pthread_attr_setschedparam(&attr, &s_param);
    pthread_create(&tid, &attr, (void* (*)(void*))stat_report, NULL);

    //  OM ̿ (¦)
    s_param.sched_priority = PRIO_VOM;
    pthread_attr_setschedparam(&attr, &s_param);
    pthread_create(&tid, &attr, (void* (*)(void*))om2ipu, NULL);

    //  OM ̿ (¦)
    s_param.sched_priority = PRIO_VOM;
    pthread_attr_setschedparam(&attr, &s_param);
    pthread_create(&tid, &attr, (void* (*)(void*))ipu2om, NULL);

    // 󥲡å
    s_param.sched_priority = PRIO_LANG;
    pthread_attr_setschedparam(&attr, &s_param);
    pthread_create(&tid, &attr, (void* (*)(void*))lang0, NULL);

    //	ѥ
    s_param.sched_priority = PRIO_VOM;
    pthread_attr_setschedparam(&attr, &s_param);
    pthread_create(&tid, &attr, (void* (*)(void*))compile, NULL);

    pthread_exit(0);

    return 0;
}

static void
usage(char* program_name)
{
    fprintf(stderr,"Usage: %s [options]\n", program_name);
    fprintf(stderr,"  options: -host        OM host\n");
    fprintf(stderr,"  options: -port | -op  OM port\n");
    fprintf(stderr,"  options: -ip          IPU port\n");
    fprintf(stderr,"  options: -ip1         number of IP1\n");
}
