/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  msgqueue.h
   å塼饹
   msgqueue::putmsg(ipu_ipu msg)   塼
   msgqueue::getmsg(ipu_ipu &msg)  塼Ф
*********************************************************************/

#ifndef MSGQUEUE_H
#define MSGQUEUE_H

#include <string.h>
#include <pthread.h>
#include "protocol.h"

class msgbox
{
friend class msgqueue;
  private:
    msgbox*	next;
    ipu_ipu	message;

    msgbox(ipu_ipu msg)
    {
	message = msg;
	next = NULL;
    };
};

class msgqueue
{
  private:
    msgbox*		head;
    msgbox*		tail;
    pthread_mutex_t	lock;
    pthread_cond_t	cond;

  public:
    msgqueue()
    {
	head = tail = NULL;
	pthread_mutex_init(&lock, NULL);
	pthread_cond_init(&cond, NULL);
    }
    void putmsg(ipu_ipu msg)
    {
	pthread_mutex_lock(&lock);
	if (tail != NULL) {
	    tail = tail->next = new msgbox(msg);
	} else {
	    head = tail = new msgbox(msg);
	    pthread_cond_broadcast(&cond);
	}
	pthread_mutex_unlock(&lock);
    };
    void getmsg(ipu_ipu& msg)
    {
	pthread_mutex_lock(&lock);
	while (head == NULL) {
	    pthread_cond_wait(&cond, &lock);
	}
	msg = head->message;

	if (head == tail) {
	    delete head;
	    head = NULL;
	    tail = NULL;
	} else {
	    msgbox* tmp = head;
	    head = head->next;
	    delete tmp;
	}
	pthread_mutex_unlock(&lock);
    };
};

#endif /* MSGQUEUE_H */
