/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  node.h
    node ϥåơ֥ǤȤʤ륯饹
*********************************************************************/

#ifndef NODE_H
#define NODE_H

#define AVOID_CC_WARNING

#include <iostream.h>
#include <string.h>
#include "comp.h"
#include "def.h"
#include "Image.h"
#include "array.h"
#include "block.h"
#include "etc.h"

// Ǥη
enum node_type {
    nt_null, nt_value,
    nt_int, nt_real, nt_complex, nt_string, nt_name,
    nt_block, nt_image, nt_array, nt_bool
};

enum ipu_p_bool {
    ib_false, ib_true
};

// node 饹:
//   åʤɤγǤȤʤ륯饹
//   ºݤˤ node Υ֥饹ǤȤʤ
class	node
{
  public:
    inline node() {};
    inline virtual ~node() {};

    inline virtual node* dup() { return NULL; };

    // ΥΡɤηĴ٤᥽å
    inline virtual node_type type() { return nt_null; };

    // ͤ򥻥åȤ᥽å
    inline virtual int	set(int&          i) { (void)i; return FAIL; };
    inline virtual int	set(float&        i) { (void)i; return FAIL; };
    inline virtual int	set(complex&      i) { (void)i; return FAIL; };
    inline virtual int	set(char*&        i) {
	printf("\033[1mnode::set(char*& \"%s\")\033[m", i);
	(void)i; return FAIL; };
    inline virtual int	set(ipu_p_bool&   i) { (void)i; return FAIL; };
    inline virtual int	set(ipu_p_block*& i) { (void)i; return FAIL; };
    inline virtual int	set(Image*&       i) { (void)i; return FAIL; };
    inline virtual int	set(array*&       i) { (void)i; return FAIL; };

    // ͤ᥽å
    inline virtual int	val(int&          i) { i = 0;          return FAIL; };
    inline virtual int	val(float&        i) { i = 0;          return FAIL; };
    inline virtual int	val(complex&      i) { i = complex(0); return FAIL; };
    inline virtual int	val(char*&        i) { i = NULL;       return FAIL; };
    inline virtual int	val(ipu_p_bool&   i) { i = ib_false;   return FAIL; };
    inline virtual int	val(ipu_p_block*& i) { i = NULL;       return FAIL; };
    inline virtual int	val(Image*&       i) { i = NULL;       return FAIL; };
    inline virtual int	val(array*&       i) { i = NULL;       return FAIL; };
    inline virtual int fullval(char*&     i) { i = NULL;       return FAIL; };

    inline virtual void print() { cout << "<<error>>  "; };
};

// imgnode 饹: ݻΡ
class	imgnode:public node
{
  private:
    Image*	img;	// image value

  public:
    inline imgnode(Image* a=NULL):img(a) { };
    inline imgnode(imgnode* a)           { img = a->img; };
    inline ~imgnode()                    { };

    inline node*     dup()          { return new imgnode(this); };
    inline node_type type()         { return nt_image; };
    inline int       set(Image*& i) { img = i; return OKAY; };
    inline int       val(Image*& i) { i = img; return OKAY; };

    inline void      print()        { cout << "-IMAGE(" << img << ")- "; };

#ifdef AVOID_CC_WARNING
    inline int   set(int&          i) { return node::set(i); };
    inline int   set(float&        i) { return node::set(i); };
    inline int   set(complex&      i) { return node::set(i); };
    inline int   set(ipu_p_bool&   i) { return node::set(i); };
    inline int   set(ipu_p_block*& i) { return node::set(i); };
    inline int   set(char*&        i) { return node::set(i); };
    inline int   set(array*&       i) { return node::set(i); };

    inline int   val(int&          i) { return node::val(i); };
    inline int   val(float&        i) { return node::val(i); };
    inline int   val(complex&      i) { return node::val(i); };
    inline int   val(ipu_p_bool&   i) { return node::val(i); };
    inline int   val(ipu_p_block*& i) { return node::val(i); };
    inline int   val(char*&        i) { return node::val(i); };
    inline int   val(array*&       i) { return node::val(i); };
#endif
};

// arraynode 饹: ݻΡ
class	arraynode:public node
{
  private:
    array*	arr;	// array value

  public:
    inline arraynode(array* a = NULL) { arr = a; };
    inline arraynode(arraynode* a)    { arr = a->arr; };
    inline ~arraynode()               { };

    inline node*     dup()          { return new arraynode(this); };
    inline node_type type()         { return nt_array; };
    inline int       set(array*& i) { arr = i; return OKAY; };
    inline int       val(array*& i) { i = arr; return OKAY; };

    inline void      print() { cout << "-ARRAY(" << "arr" << ")- "; };

#ifdef AVOID_CC_WARNING
    inline int   set(int&          i) { return node::set(i); };
    inline int   set(float&        i) { return node::set(i); };
    inline int   set(complex&      i) { return node::set(i); };
    inline int   set(char*&        i) { return node::set(i); };
    inline int   set(ipu_p_bool&   i) { return node::set(i); };
    inline int   set(ipu_p_block*& i) { return node::set(i); };
    inline int   set(Image*&       i) { return node::set(i); };

    inline int   val(int&          i) { return node::val(i); };
    inline int   val(float&        i) { return node::val(i); };
    inline int   val(complex&      i) { return node::val(i); };
    inline int   val(char*&        i) { return node::val(i); };
    inline int   val(ipu_p_bool&   i) { return node::val(i); };
    inline int   val(ipu_p_block*& i) { return node::val(i); };
    inline int   val(Image*&       i) { return node::val(i); };
#endif
};

// snode 饹: ʸݻΡ
//  ̾ or ʸݻ
//  ̾ξ硢ǽ '/' '('  ')' Ǥޤ줿ʸξ
//  '('  ')' ݻ
class	snode: public node
{
  private:
    char*	s;
    node_type	t; // nt_name or nt_string

    void setval(char* a) {
	if (s != NULL) delete[] s; // ʸä
	if (a != NULL) {
	    if (*a == '/') {
		t = nt_name;
		s = strip_name(a);
	    } else if (*a == '(') {
		t = nt_string;
		s = strip_string(a);
	    } else {
		t = nt_string;
		s = strdup_new(a);
	    }
	} else {
	    t = nt_string;
	    s = strdup_new("");
	}
    }

  public:
    inline snode(char* a = NULL)
    {
	s = NULL;
	setval(a);
    };

    inline snode(snode* a)     { s = strdup_new(a->s); t = a->t; };
    inline ~snode()            { if (s != NULL) delete[] s; };

    inline node*     dup()     { return new snode(this); };
    inline node_type type()    { return t; };
    inline int       set(char*& a)
    {
	if (a != NULL) {
	    setval(a);
	    return OKAY;
	} else {
	    return FAIL;
	}
    };
    inline int val(char*& p) { p = strdup_new(s); return OKAY; };
    inline int fullval(char*& p) {
	if (t == nt_name) {
	    p = new char[strlen(s) + 2]; /* +2  '/'  '\0' */
	    sprintf(p, "/%s", s);
	} else { // nt_string
	    p = new char[strlen(s) + 3]; /* +3  '('  ')'  '\0' */
	    sprintf(p, "(%s)", s);
	}
	return OKAY;
    }

    inline void print() {
	switch (t) {
	  case nt_name:
	    cout << "/" << s << " ";
	    break;
	  case nt_string:
	    cout << "(" << s << ") ";
	    break;
	  default:
	    cout << s << " ";
	    break;
	}
    };

#ifdef AVOID_CC_WARNING
    inline int   set(int&          i) { return node::set(i); };
    inline int   set(float&        i) { return node::set(i); };
    inline int   set(complex&      i) { return node::set(i); };
    inline int   set(ipu_p_bool&   i) { return node::set(i); };
    inline int   set(ipu_p_block*& i) { return node::set(i); };
    inline int   set(Image*&       i) { return node::set(i); };
    inline int   set(array*&       i) { return node::set(i); };

    inline int   val(int&          i) { return node::val(i); };
    inline int   val(float&        i) { return node::val(i); };
    inline int   val(complex&      i) { return node::val(i); };
    inline int   val(ipu_p_bool&   i) { return node::val(i); };
    inline int   val(ipu_p_block*& i) { return node::val(i); };
    inline int   val(Image*&       i) { return node::val(i); };
    inline int   val(array*&       i) { return node::val(i); };
#endif
};

// bnode 饹: ֥å (`{'  `}' Ǥޤ줿ʬ) ݻΡ
class	bnode: public node
{
  private:
    ipu_p_block*	blk;	// block value

  public:
    inline bnode()               { blk = NULL; };
    inline bnode(ipu_p_block* a) { blk = new ipu_p_block(a); };
    inline bnode(bnode* a)       { blk = new ipu_p_block(a->blk); };
    inline ~bnode()              { delete blk; };

    inline node*     dup()       { return new bnode(this); };
    inline node_type type()      { return nt_block; };
    inline int       set(ipu_p_block*& p)
	{ delete blk; blk = new ipu_p_block(p); return OKAY; };
    inline int       val(ipu_p_block*& p)
	{ p = new ipu_p_block(blk); return OKAY; };

    inline void print() {
	if (blk != NULL) {
	    blk->print();
	} else {
	    cout << "-BLOCK(NULL)- ";
	}
    };

#ifdef AVOID_CC_WARNING
    inline int   set(int&          i) { return node::set(i); };
    inline int   set(float&        i) { return node::set(i); };
    inline int   set(complex&      i) { return node::set(i); };
    inline int   set(char*&        i) { return node::set(i); };
    inline int   set(ipu_p_bool&   i) { return node::set(i); };
    inline int   set(Image*&       i) { return node::set(i); };
    inline int   set(array*&       i) { return node::set(i); };

    inline int   val(int&          i) { return node::val(i); };
    inline int   val(float&        i) { return node::val(i); };
    inline int   val(complex&      i) { return node::val(i); };
    inline int   val(char*&        i) { return node::val(i); };
    inline int   val(ipu_p_bool&   i) { return node::val(i); };
    inline int   val(Image*&       i) { return node::val(i); };
    inline int   val(array*&       i) { return node::val(i); };
#endif
};

// blnode 饹: bool ͤݻΡ
class	blnode: public node
{
  private:
    ipu_p_bool	bl;	// bool value

  public:
    inline blnode()                     { bl = ib_false; };
    inline blnode(ipu_p_bool a)         { bl = a; };
    inline blnode(blnode* a)            { bl = a->bl; };
    inline ~blnode()                    { };

    inline node*     dup()              { return new blnode(this); };
    inline node_type type()             { return nt_bool; };
    inline int       set(ipu_p_bool& b) { bl = b; return OKAY; };
    inline int       val(ipu_p_bool& b) { b = bl; return OKAY; };

    inline int       set(int& i) { bl = i ? ib_true : ib_false; return OKAY; };
    inline int       val(int& i) { i = bl == ib_true ? 1 : 0; return OKAY; };

    inline void print() {
	if (bl) {
	    cout << "true ";
	} else {
	    cout << "false ";
	}
    };

#ifdef AVOID_CC_WARNING
    inline int   set(float&        i) { return node::set(i); };
    inline int   set(complex&      i) { return node::set(i); };
    inline int   set(char*&        i) { return node::set(i); };
    inline int   set(ipu_p_block*& i) { return node::set(i); };
    inline int   set(Image*&       i) { return node::set(i); };
    inline int   set(array*&       i) { return node::set(i); };

    inline int   val(float&        i) { return node::val(i); };
    inline int   val(complex&      i) { return node::val(i); };
    inline int   val(char*&        i) { return node::val(i); };
    inline int   val(ipu_p_block*& i) { return node::val(i); };
    inline int   val(Image*&       i) { return node::val(i); };
    inline int   val(array*&       i) { return node::val(i); };
#endif
};

// vnode 饹: (¿ʣǿ)ݻΡɤοƥ饹
// Ѵǽ󶡤
class	vnode: public node
{
  public:
    inline vnode() {};
    inline ~vnode() {};

    inline virtual node*     dup()  { return NULL; };

    inline virtual node_type type() { return nt_value; };

    inline virtual int       set(int&      i){ (void)i; return FAIL; };
    inline virtual int       set(float&    i){ (void)i; return FAIL; };
    inline virtual int       set(complex&  i){ (void)i; return FAIL; };

    inline virtual int	val(int& i)
    {
	float  d;
	if (this->val(d) != FAIL) {
	    i = (int)d;
	    return OKAY;
	}
	return FAIL;
    }

    inline virtual int	val(float& i)
    {
	if (this->type() == nt_int) {
	    int d;
	    if (this->val(d) != FAIL) {
		i = (float) d;
		return OKAY;
	    }
	    return FAIL;
	} else if (this->type() == nt_complex) {
	    complex c;
	    if (this->val(c) != FAIL) {
		i = (float)real(c);
		return OKAY;
	    }
	    return FAIL;
	}
	return FAIL;
    }

    inline virtual int	  val(complex& i)
    {
	float  d;
	if (this->val(d) != FAIL) {
	    i = complex(d);
	    return OKAY;
	}
	return FAIL;
    }

    inline virtual void print() { cout << "<<error>>  "; };

#ifdef AVOID_CC_WARNING
    inline int   set(char*&        i) { return node::set(i); };
    inline int   set(ipu_p_bool&   i) { return node::set(i); };
    inline int   set(ipu_p_block*& i) { return node::set(i); };
    inline int   set(Image*&       i) { return node::set(i); };
    inline int   set(array*&       i) { return node::set(i); };

    inline int   val(char*&        i) { return node::val(i); };
    inline int   val(ipu_p_bool&   i) { return node::val(i); };
    inline int   val(ipu_p_block*& i) { return node::val(i); };
    inline int   val(Image*&       i) { return node::val(i); };
    inline int   val(array*&       i) { return node::val(i); };
#endif
};

// inode: Ρ
class	inode:public vnode
{
  private:
    int 	v;
  public:
    inline inode(int a=0)     { v = a; };
    inline inode(inode* a)    { v = a->v; };
    inline ~inode()           { };

    inline node*     dup()       { return new inode(this); };
    inline node_type type()      { return nt_int; };
    inline int       set(int& i) { v = i; return OKAY; };
    inline int       val(int& i) { i = v; return OKAY; };

    inline int  set(ipu_p_bool& i) { v = i == ib_true ? 1 : 0; return OKAY; };
    inline int  val(ipu_p_bool& i) { i = v ? ib_true : ib_false; return OKAY;};

    inline void      print()     { cout << v << " "; };

#ifdef AVOID_CC_WARNING
    inline int   set(float&        i) { return vnode::set(i); };
    inline int   set(complex&      i) { return vnode::set(i); };
    inline int   set(char*&        i) { return node::set(i); };
    inline int   set(ipu_p_block*& i) { return node::set(i); };
    inline int   set(Image*&       i) { return node::set(i); };
    inline int   set(array*&       i) { return node::set(i); };

    inline int   val(float&        i) { return vnode::val(i); };
    inline int   val(complex&      i) { return vnode::val(i); };
    inline int   val(char*&        i) { return node::val(i); };
    inline int   val(ipu_p_block*& i) { return node::val(i); };
    inline int   val(Image*&       i) { return node::val(i); };
    inline int   val(array*&       i) { return node::val(i); };
#endif
};

// dnode: ¿Ρ
class	dnode:public vnode
{
  private:
    float	v;
  public:
    inline dnode(float a=0) { v = a; };
    inline dnode(dnode* a)  { v = a->v; };
    inline ~dnode()         { };

    inline node*     dup()         { return new dnode(this); };
    inline node_type type()        { return nt_real; };
    inline int       set(float& i) { v = i; return OKAY; };
    inline int       val(float& i) { i = v; return OKAY; };

    inline void      print()       { cout << v << " "; };

#ifdef AVOID_CC_WARNING
    inline int   set(int&          i) { return vnode::set(i); };
    inline int   set(complex&      i) { return vnode::set(i); };
    inline int   set(char*&        i) { return node::set(i); };
    inline int   set(ipu_p_bool&   i) { return node::set(i); };
    inline int   set(ipu_p_block*& i) { return node::set(i); };
    inline int   set(Image*&       i) { return node::set(i); };
    inline int   set(array*&       i) { return node::set(i); };

    inline int   val(int&          i) { return vnode::val(i); };
    inline int   val(complex&      i) { return vnode::val(i); };
    inline int   val(char*&        i) { return node::val(i); };
    inline int   val(ipu_p_bool&   i) { return node::val(i); };
    inline int   val(ipu_p_block*& i) { return node::val(i); };
    inline int   val(Image*&       i) { return node::val(i); };
    inline int   val(array*&       i) { return node::val(i); };
#endif
};

// cnode: ʣǿΡ
class	cnode:public vnode
{
  private:
    complex	v;
  public:

    inline cnode(complex a = 0) { v = a; };
    inline cnode(cnode* a)      { v = a->v; };
    inline ~cnode()             { };

    inline node*     dup()           { return new cnode(this); };
    inline node_type type()          { return nt_complex; };
    inline int       set(complex& i) { v = i; return OKAY; };
    inline int       val(complex& i) { i = v; return OKAY; };

    inline void      print() { cout << real(v) << "+" << imag(v) << "i "; };

#ifdef AVOID_CC_WARNING
    inline int   set(int&          i) { return vnode::set(i); };
    inline int   set(float&        i) { return vnode::set(i); };
    inline int   set(char*&        i) { return node::set(i); };
    inline int   set(ipu_p_bool&   i) { return node::set(i); };
    inline int   set(ipu_p_block*& i) { return node::set(i); };
    inline int   set(Image*&       i) { return node::set(i); };
    inline int   set(array*&       i) { return node::set(i); };

    inline int   val(int&          i) { return vnode::val(i); };
    inline int   val(float&        i) { return vnode::val(i); };
    inline int   val(char*&        i) { return node::val(i); };
    inline int   val(ipu_p_bool&   i) { return node::val(i); };
    inline int   val(ipu_p_block*& i) { return node::val(i); };
    inline int   val(Image*&       i) { return node::val(i); };
    inline int   val(array*&       i) { return node::val(i); };
#endif
};

#endif /* NODE_H */
