/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  number.cc
*********************************************************************/

#include <stdio.h>
#include <ctype.h>
#include "def.h"

int
conv_int(char* a, int& num)
{
    char*	p = a;
    int 	tmp = 0;
    int 	minus = 1;

    if (p == NULL)
	return FAIL;
    if (*p == '-'){
	minus = -1;
	p++;
    }

    while (*p != '\0') {
	if (!isdigit(*p))
	    return FAIL;
	tmp *= 10;
	tmp += *p -'0';
	p++;
    }
    num = minus*tmp;

    return OKAY;
}

int
conv_real(char* a, float& num)
{
    char*	p = a;
    float	b = 0;
    float	c = 1;
    int 	minus = 1;

    if (p == NULL)
	return FAIL;
    if (*p == '-') {
	minus = -1;
	p++;
    }

    while (*p != '\0') {
	if (*p == '.')
	    break;
	if (!isdigit(*p))
	    return FAIL;
	b *= 10;
	b += *p - '0';
	p++;
    }

    if (*p == '.') {
	p++;
	while (*p != '\0') {
	    if (!isdigit(*p))
		return FAIL;
	    c /= 10;
	    b += c * (*p - '0');
	    p++;
	}
    }
    num = minus*b;
    return OKAY;
}
