/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  obj.cc
    IPU-p 󥿥ץ꥿ǻȤؿ
    ˴ؤؿ (width, height ʤ)
*********************************************************************/

#include <pthread.h>
#include "obj.h"
#include "Image.h"
#include "GrayImage.h"
#include "stack.h"
#include "table.h"
#include "ObjList.h"
#include "msgqueue.h"
#include "protocol.h"
#include "vom.h"
#include "ipu_list.h"

       msgqueue image_wait_q;
extern msgqueue send_q, trans_q;
extern ipu_list ipus;

//class GrayImage:public Image;

int
f_width(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image* i;
    if (ST.pop(i) == FAIL) return FAIL;

    ST.push(i->get_width());
    return OKAY;
}

int
f_height(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image* i;
    if (ST.pop(i) == FAIL) return FAIL;

    ST.push(i->get_height());
    return OKAY;
}

int
f_hotx(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image* i;
    if (ST.pop(i) == FAIL) return FAIL;

    ST.push(i->get_hot_x());
    return OKAY;
}

int
f_hoty(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image* i;
    if (ST.pop(i) == FAIL) return FAIL;

    ST.push(i->get_hot_y());
    return OKAY;
}

int
f_cache(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image* i;
    if (ST.pop(i) == FAIL) return FAIL;

    ST.push(i->get_cache());
    return OKAY;
}

int
f_type(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image* i;
    if (ST.pop(i) == FAIL) return FAIL;

    ST.push(i->get_width());
    ST.push(i->get_height());
    ST.push(i->get_hot_x());
    ST.push(i->get_hot_y());
    return OKAY;
}

int
f_itype(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    int a;
    if (ST.pop(a) == FAIL) return FAIL;

    Image* i;
    pixel_type ty = (pixel_type)0;
    for (int j = 0; j < a; j++)
    {
	if (ST.pop(i) == FAIL) return FAIL;
	if ((int)ty < (int)(i->get_type())) ty = i->get_type();
    }

    ST.push((int)ty);
    return OKAY;
}

// f_get:
//  å: : image x y
//            : (x,y) β
int
f_get(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image* i;
    int x,y;
    if (ST.pop(y) == FAIL) return FAIL;
    if (ST.pop(x) == FAIL) return FAIL;
    if (ST.pop(i) == FAIL) return FAIL;

    pixel_type t;
    complex c;
    c = i->getpixel(x, y, t);
    switch (t)
    {
      case pt_int:
	ST.push((int)real(c));
	break;
      case pt_real:
	ST.push((float)real(c));
	break;
      case pt_complex:
	ST.push(c);
	break;
      default:
	i->print();
	cout << "okasii " << (int)t << "\n";
    }

    return OKAY;
}

// f_aget: f_get кɸ
int
f_aget(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image* i;
    int x, y;
    if (ST.pop(y) == FAIL) return FAIL;
    if (ST.pop(x) == FAIL) return FAIL;
    if (ST.pop(i) == FAIL) return FAIL;

    pixel_type t;
    complex c;
    c = i->agetpixel(x, y, t);
    switch (t)
    {
      case pt_int:
	ST.push((int)real(c));
	break;
      case pt_real:
	ST.push((float)real(c));
	break;
      case pt_complex:
	ST.push(c);
	break;
      default:
	fprintf(stderr, "f_aget: bad pixel_type %d\n", t);
	break;
    }
    return OKAY;
}

// f_put:
//  å: : image x y 
//            : ʤ
int
f_put(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image*	i;
    int 	x, y;
    complex	c;

    if (ST.pop(c) == FAIL) return FAIL;
    if (ST.pop(y) == FAIL) return FAIL;
    if (ST.pop(x) == FAIL) return FAIL;
    if (ST.pop(i) == FAIL) return FAIL;

    i->setpixel(x, y, c);
    return OKAY;
}

// f_aput: f_put кɸ
int
f_aput(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    Image*	i;
    int 	x, y;
    complex	c;

    if (ST.pop(c) == FAIL) return FAIL;
    if (ST.pop(y) == FAIL) return FAIL;
    if (ST.pop(x) == FAIL) return FAIL;
    if (ST.pop(i) == FAIL) return FAIL;

    i->asetpixel(x, y, c);
    return OKAY;
}

// f_obj: 
//  å: : ˤĤ̾ (ʸ)
//            : 
int
f_obj(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    char* name;
    int   image_id;
    if (ST.sttype() != nt_string) return FAIL;
    if (ST.pop(name) == FAIL) return FAIL;
    delete[] name; // ̾Ϥ⤦ʤ

    // OM  image ID ׵
    image_id = get_new_image_id();

    Image* a = new GrayImage(image_id, -1);
    OL.append(a);
    ST.push(a);
    return OKAY;
}

int
f_createobj(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    int 	w, h, x, y, ca;
    Image*	i;
    int 	t;

    if (ST.pop(t) == FAIL)  return FAIL;
    if (ST.pop(y) == FAIL)  return FAIL;
    if (ST.pop(x) == FAIL)  return FAIL;
    if (ST.pop(h) == FAIL)  return FAIL;
    if (ST.pop(w) == FAIL)  return FAIL;
    if (ST.pop(ca) == FAIL) return FAIL;
    if (ST.pop(i) == FAIL)  return FAIL;

    i->setparam(w, h, x, y, (pixel_type)t, ca);
    return OKAY;
}

// deleteobj
//  å: : 
//            : ʤ
int
f_deleteobj(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT;
    Image* img;
    if (ST.pop(img) == FAIL) return FAIL;
    OL.remove(img);

    return OKAY;
}

// idtoimage:
//  å: : ID ʬID
//            : б
int
f_idtoimage(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT;
    int image_id, div_id;
    if (ST.pop(div_id) == FAIL) return FAIL;
    if (ST.pop(image_id) == FAIL) return FAIL;

    Image* image;
    image = OL.get(image_id, div_id);
    if (image == NULL) return FAIL;
    ST.push(image);

    return OKAY;
}

// newidimage: κ (ID  OM ˿äƤ餦)
//  å: : ʤ
//            : 
int
f_newimage(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    int   image_id;

    // OM  image ID ׵
    image_id = get_new_image_id();

    Image* a = new GrayImage(image_id, -1);
    OL.append(a);
    ST.push(a);
    return OKAY;
}

// newidimage:  ID ǿ
//  å: : ID ʬID
//            : 
int
f_newidimage(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    int image_id, div_id;
    if (ST.pop(div_id) == FAIL) return FAIL;
    if (ST.pop(image_id) == FAIL) return FAIL;

    Image* image = new GrayImage(image_id, div_id);
    ST.push(image);
    OL.append(image);

    return OKAY;
}

// transimage: žƤ餦
//  å: : ID ʬID äƤIPUֹ
//            : β
int
f_transimage(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    (void)TA; (void)FT; (void)OL;
    int image_id, div_id, ipu_no;
    if (ST.pop(ipu_no) == FAIL) return FAIL;
    if (ST.pop(div_id) == FAIL) return FAIL;
    if (ST.pop(image_id) == FAIL) return FAIL;

    ipu_ipu	msg;
    msg.t_msg = new trans_msg;
    msg.img_info = new image_info;

    // ȥ󥹥ФؤΥå
    msg.t_msg->type   = p_ii_image_request;
    msg.t_msg->ipu_no = ipu_no;
    msg.img_info->image_id = image_id;
    msg.img_info->div_id   = div_id;

    //time_print("ž׵");
    // 
    trans_q.putmsg(msg);

    image_wait_q.getmsg(msg);

    //time_print("žλ");
    sched_yield();

    Image* image = OL.get(image_id, div_id);
    if (image == NULL) {
	fprintf(stderr, "f_transimage: get failed\n");
	return FAIL;
    }
    ST.push(image);

    return OKAY;
}
