/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  stack.h
    IPU-p ѤΥå
*********************************************************************/

#ifndef	STACK_H
#define STACK_H

#include "def.h"
#include "node.h"

class stack
{
  private:
    stack*	next;	// 
    node*	v;

    void	del();

  public:
    // ޤϡ󥹥ȥ饯
    // ʤ
    stack():next(NULL),v(NULL) {};
    // 줾ΰ
    stack(stack*  a, stack* n):next(n) { v = a->v->dup(); };

    stack(int          i, stack* n):next(n) { v = new inode(i); };
    stack(float        i, stack* n):next(n) { v = new dnode(i); };
    stack(complex      i, stack* n):next(n) { v = new cnode(i); };
    stack(char*        i, stack* n):next(n) { v = new snode(i); };
    stack(ipu_p_bool   i, stack* n):next(n) { v = new blnode(i); };
    stack(ipu_p_block* i, stack* n):next(n) { v = new bnode(i); };
    stack(Image*       i, stack* n):next(n) { v = new imgnode(i); };
    stack(array*       i, stack* n):next(n) { v = new arraynode(i); };

    // ˥ǥȥ饯
    inline	~stack() {
	if (v    != NULL) delete v;
	if (next != NULL) delete next;
    };

    // 2Ĥʬ뤿Τ
    // Ƭ n Ĥ򿷤åˡĤ򸵤Υåʬ
    // ɬ n ĤϡåˤĤǤʤФʤ
    inline int split2stack(stack& st, int n) {
	stack* tmp = this;

	for (int i = 0; i < n && tmp != NULL; i++)
	    tmp = tmp->next;

	if (tmp != NULL) {
	    st.next = this->next;
	    this->next = tmp->next;
	    tmp->next = NULL;
	} else {
	    return FAIL;
	}

	return OKAY;
    };

    inline int copystack(stack& st, int n) {
	stack* tmp  = this;
	stack* tmp1 = &st;
	stack* tmp2 = st.next;

	for (int i = 0; i < n && tmp != NULL; i++) {
	    tmp1->next = new stack(tmp->next, NULL);
	    tmp1 = tmp1->next;
	    tmp  = tmp->next;
	}
	if (tmp != NULL) {
	    tmp1->next = tmp2;
	} else {
	    return FAIL;
	}

	return OKAY;
    };

    // פĴ٤
    inline node_type	sttype();

    // åѤ
    inline void	push(int);
    inline void	push(float);
    inline void	push(complex);
    inline void	push(char*);
    inline void	push(ipu_p_bool);
    inline void	push(ipu_p_block*);
    inline void	push(Image*);
    inline void	push(array*);

    // åΰ־ȤäƤ
    inline int	pop();		// ʤξ ͤϼΤƤ
    inline int	pop(int&);
    inline int	pop(float&);
    inline int	pop(complex&);
    inline int	pop(char*&);
    inline int	pop(ipu_p_bool&);
    inline int	pop(ipu_p_block*&);
    inline int	pop(Image*&);
    inline int	pop(array*&);

    // åؿ
    inline int dup();
    inline int exch();
    inline int roll(int, int);

    // åȤɽ(ǥХå)
    inline void print() {
	if (next != NULL) {
	    next->print();
	    next->v->print();
	}
    };
    inline void print_one() {
	if (next != NULL) {
	    next->v->print();
	}
    };
};

// åƬǤ
inline void
stack::del()
{
    if (next != NULL) {
	stack* tmp = next;
	next = next->next;
	tmp->next = NULL;
	delete tmp;
    }
};

inline node_type
stack::sttype()
{
    if (next == NULL || next->v == NULL) return nt_null;
    else return next->v->type();
};

// åͤץå夹ؿ

inline void
stack::push(int i)
{
    next = new stack(i, next);
};
inline void
stack::push(float d)
{
    next = new stack(d, next);
};
inline void
stack::push(complex c)
{
    next = new stack(c, next);
};
inline void
stack::push(char* s)
{
    next = new stack(s, next);
};
inline void
stack::push(ipu_p_bool b)
{
    next = new stack(b, next);
};
inline void
stack::push(ipu_p_block* b)
{
    next = new stack(b, next);
};
inline void
stack::push(Image* i)
{
    next = new stack(i, next);
};
inline void
stack::push(array* a)
{
    next = new stack(a, next);
};


// åؿ

// dup: åǾ̤Ǥ򥳥ԡƥץå
inline int
stack::dup()
{
    if (next != NULL) {
	next = new stack(next, next);
	return OKAY;
    } else {
	return FAIL;
    }
}

// exch: åƬ2ĤǤؤ
inline int
stack::exch()
{
    if (next != NULL && next->next != NULL) {
	stack* tmp = next;
	next = next->next;
	tmp->next = tmp->next->next;
	next->next = tmp;
	return OKAY;
    } else {
	return FAIL;
    }
}

// roll:  a, b ˽äƥåž
// Ƭ a  (a > 0)  b  (b > 0) åƬزž
// (ۤȤ b < 0 ʤزžۤ)
inline int
stack::roll(int a, int b)
{
    int    i, j;
    stack* tmp1;
    stack* tmp2;
    tmp1 = this;

    //  a Ĥ뤫Ĵ٤
    for (i = 0; i < a; i++)
	if ((tmp1 = tmp1->next) == NULL)
	    return FAIL;

    // ž
    for (j = 0; j < b; j++) {
	tmp1 = next;
	for (i = 0; i < a-2; i++)
	    tmp1 = tmp1->next;
	tmp2 = tmp1->next;
	tmp1->next = tmp2->next;
	tmp2->next = next;
	next = tmp2;
    }

    return OKAY;
}


// åͤݥåפؿ

inline int
stack::pop()
{
    if (next != NULL) {
	this->del();
	return OKAY;
    } else {
	return FAIL;
    }
};

inline int
stack::pop(int& i)
{
    if (next != NULL) {
	int a = next->v->val(i);
	this->del();
	return a;
    } else {
	return FAIL;
    }
};

inline int
stack::pop(float& d)
{
    if (next != NULL) {
	int a = next->v->val(d);
	this->del();
	return a;
    } else {
	return FAIL;
    }
};

inline int
stack::pop(complex& c)
{
    if (next != NULL) {
	int a = next->v->val(c);
	this->del();
	return a;
    } else {
	return FAIL;
    }
};

inline int
stack::pop(char*& s)
{
    if (next != NULL) {
	int a = next->v->val(s);
	this->del();
	return a;
    } else {
	return FAIL;
    }
};

inline int
stack::pop(ipu_p_bool& b)
{
    if (next != NULL) {
	int a = next->v->val(b);
	this->del();
	return a;
    } else {
	return FAIL;
    }
};

inline int
stack::pop(ipu_p_block*& b)
{
    if (next != NULL) {
	int a = next->v->val(b);
	this->del();
	return a;
    } else {
	return FAIL;
    }
};

inline int
stack::pop(Image*& i)
{
    if (next != NULL) {
	int a = next->v->val(i);
	this->del();
	return a;
    } else {
	return FAIL;
    }
};

inline int
stack::pop(array*& i)
{
    if (next != NULL) {
	int a = next->v->val(i);
	this->del();
	return a;
    } else {
	return FAIL;
    }
};

#endif /* STACK_H */
