/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  table.h
    IPU-p  def ˤ̾ȼΤбɽ
*********************************************************************/

#ifndef TABLE_H
#define TABLE_H

#include "def.h"
#include "node.h"

class table
{
  protected:
    table*	pr;		// 1ľΥơ֥(ҥơ֥¸)
    table*	next;		// ΥΡ
    char*	name;		// ѿ̾
    node*	v;		// 

  public:
    inline	table():pr(NULL),next(NULL),name(NULL),v(NULL){};

    inline	table(table* p):pr(p),next(NULL),name(NULL),v(NULL){};

    inline	table(int     i, char* n, table* p):next(p)
		    { v = new inode(i); name = strdup_new(n); };
    inline	table(float   i, char* n, table* p):next(p)
		    { v = new dnode(i); name = strdup_new(n); };
    inline	table(complex i, char* n, table* p):next(p)
		    { v = new cnode(i); name = strdup_new(n); };
    inline	table(char*   i, char* n, table* p):next(p)
		    { v = new snode(i); name = strdup_new(n); };
    inline	table(ipu_p_block* i, char* n, table* p):next(p)
		    { v = new bnode(i); name = strdup_new(n); };
    inline	table(Image*  i, char* n, table* p):next(p)
		    { v = new imgnode(i); name = strdup_new(n); };
    inline	table(array*  i, char* n, table* p):next(p)
		    { v = new arraynode(i); name = strdup_new(n); };
    inline	table(ipu_p_bool i, char* n, table* p):next(p)
		    { v = new blnode(i); name = strdup_new(n); };

    inline	~table()
    {
	delete next;
	delete[] name;
	delete v;
    };

    inline table*	pre() { return pr; };
    inline node_type	tatype(char*);
    inline int		search(char*);
    table*		ser(char*);
    inline int		presearch(char*);

    inline void	def(char*, int);
    inline void	def(char*, float);
    inline void	def(char*, complex);
    inline void	def(char*, char*);
    inline void	def(char*, ipu_p_block*);
    inline void	def(char*, Image*);
    inline void	def(char*, array*);
    inline void	def(char*, ipu_p_bool);

    inline int	get(char*, int&);
    inline int	get(char*, float&);
    inline int	get(char*, complex&);
    inline int	get(char*, char*&);
    inline int	get(char*, ipu_p_block*&);
    inline int	get(char*, Image*&);
    inline int	get(char*, array*&);
    inline int	get(char*, ipu_p_bool&);

    inline void print()
    {
	table* p = next;
	while (p != NULL) {
	    cout << p->name << "  ";
	    p->v->print();
	    cout << "\n";
	    p = p->next;
	}
    };
};

// table::ser: ơ֥椫̾ n ĤΤõ
// Ĥä餽ǤؤΥݥ(table*)
// Ĥʤä NULL ֤
inline table*
table::ser(char* n)
{
    table*	p = next;
    while (p != NULL) {
	if (strcmp(p->name, n) == 0)	return p;
	p = p->next;
    }
    return NULL;
}

// table::tatype: ơ֥椫̾ n ĤΤõ
// Ĥä餽Ǥη򡢸Ĥʤä nt_null ֤
inline node_type
table::tatype(char* n)
{
    table*	p = this->ser(n);
    if (p != NULL) return p->v->type();
    return nt_null;
}

// table::search: ơ֥椫̾ n ĤΤõ
// Ĥä OKAY 򡢸Ĥʤä FAIL ֤
inline int
table::search(char* n)
{
    if (this->ser(n) != NULL)	return	OKAY;
    else			return	FAIL;
}

// pr  NULL ʤ table::search Ʊ
// pr  NULL Ǥʤʤ table::search ƤߤĤʤʤ pr õ
inline	int
table::presearch(char* n)
{
    if (this->ser(n) != NULL)	return 	OKAY;
    else if (this->pr == NULL)	return	FAIL;
    else			return	pr->presearch(n);
}

// table::def: ѿ

inline void
table::def(char* nam, int i)
{
    table*	p = this->ser(nam);
    if (p != NULL) {
	if (p->v->set(i) == FAIL) {
	    delete p->v;
	    p->v = new inode(i);
	}
    } else {
	next = new table(i, nam, next);
    }
}
inline void
table::def(char* nam, float i)
{
    table*	p = this->ser(nam);
    if (p != NULL) {
	if (p->v->set(i) == FAIL) {
	    delete p->v;
	    p->v = new dnode(i);
	}
    } else {
	next = new table(i, nam, next);
    }
}
inline void
table::def(char* nam, complex i)
{
    table*	p = this->ser(nam);
    if (p != NULL) {
	if (p->v->set(i) == FAIL) {
	    delete p->v;
	    p->v = new cnode(i);
	}
    } else {
	next = new table(i, nam, next);
    }
}
inline void
table::def(char* nam, char* i)
{
    table*	p = this->ser(nam);
    if (p != NULL) {
	if (p->v->set(i) == FAIL) {
	    delete p->v;
	    p->v = new snode(i);
	}
    } else {
	char* tmp = new char[strlen(i) + 3];
	sprintf(tmp, "(%s)", i);
	next = new table(tmp, nam, next);
	delete tmp;
    }
};
inline void
table::def(char* nam, ipu_p_block* i)
{
    table*	p = this->ser(nam);
    if (p != NULL) {
	if (p->v->set(i) == FAIL) {
	    delete p->v;
	    p->v = new bnode(i);
	}
    } else {
	next = new table(i, nam, next);
    }
};
inline void
table::def(char* nam, Image* i)
{
    table*	p = this->ser(nam);
    if (p != NULL) {
	if (p->v->set(i) == FAIL) {
	    delete p->v;
	    p->v = new imgnode(i);
	}
    } else {
	next = new table(i, nam, next);
    }
};
inline void
table::def(char* nam, array* val)
{
    table*	p = this->ser(nam);
    if (p != NULL) {
	if (p->v->set(val) == FAIL) {
	    delete p->v;
	    p->v = new arraynode(val);
	}
    } else {
	next = new table(val, nam, next);
    }
};
inline void
table::def(char* nam, ipu_p_bool val)
{
    table*	p = this->ser(nam);
    if (p != NULL) {
	if (p->v->set(val) == FAIL) {
	    delete p->v;
	    p->v = new blnode(val);
	}
    } else {
	next = new table(val, nam, next);
    }
};

// table::get: ̾Τ򻲾Ȥ

inline int
table::get(char* nam, int& i)
{
    table* p = this->ser(nam);
    if (p != NULL)	return	p->v->val(i);
    else		return	FAIL;
};
inline int
table::get(char* nam, float& i)
{
    table* p = this->ser(nam);
    if (p != NULL)	return	p->v->val(i);
    else		return	FAIL;
};
inline int
table::get(char* nam, complex& i)
{
    table* p = this->ser(nam);
    if (p != NULL)	return	p->v->val(i);
    else		return	FAIL;
};
inline int
table::get(char* nam, char*& i)
{
    table* p = this->ser(nam);
    if (p != NULL)	return	p->v->fullval(i);
    else		return	FAIL;
};
inline int
table::get(char* nam, ipu_p_block*& i)
{
    table* p = this->ser(nam);
    if (p != NULL)	return	p->v->val(i);
    else		return	FAIL;
};
inline int
table::get(char* nam, Image*& i)
{
    table* p = this->ser(nam);
    if (p != NULL)	return	p->v->val(i);
    else		return	FAIL;
};
inline int
table::get(char* nam, array*& i)
{
    table* p = this->ser(nam);
    if (p != NULL)	return	p->v->val(i);
    else		return	FAIL;
};
inline int
table::get(char* nam, ipu_p_bool& i)
{
    table* p = this->ser(nam);
    if (p != NULL)	return	p->v->val(i);
    else		return	FAIL;
};

#endif /* TABLE_H */
