/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  unify.h
    ץޥ֥ѿԤ
*********************************************************************/


#ifndef UNIFY_H
#define UNIFY_H

#include <pthread.h>
#include "array.h"

// ԤХѿ1ĤȤΥꥹ
class unify_box {
  private:
    unify_box* next;
    void*      buf;

  public:
    unify_box() {
	next = NULL;
	buf  = NULL;
    };
    ~unify_box() {
	delete[] buf;
	delete next;
    }

    int append(void* b) {
	unify_box* new_box = new unify_box;
	new_box->buf  = b;
	new_box->next = next;
	next = new_box;
	return 0;
    }
    void* get(int idx) {
	unify_box* p;
	int i;
	for (p = next, i = 0; i < idx && p != NULL; p = p->next, i++) ;
	return p->buf;
    }
};

// ԤХѿΥꥹ
class unify_list {
  private:
    unify_list*     next;
    int             array_id; // ΥХѿ ID
    unify_box       data;     // ΥХѿ
    int             n;        // Ĥä
    pthread_mutex_t lock;
    pthread_cond_t  cond;

    unify_list* prev_search(int a_id) {
	unify_list* prev;
	for (prev = this; prev->next != NULL; prev = prev->next) {
	    if (prev->next->array_id == a_id) {
		return prev;
	    }
	}
	return NULL;
    }
    unify_list* search(int a_id) {
	unify_list* p = prev_search(a_id);
	if (p != NULL) return p->next;
	return NULL;
    }

  public:
    unify_list() {
	next = NULL;
	pthread_mutex_init(&lock, NULL);
	pthread_cond_init(&cond, NULL);
    }
    ~unify_list() {
	delete next;
    }

    // ХѿΥǡɲ
    //  buf  new char[size] 줿
    // delete[] ϤǹԤΤǸƤӽФ¦Ǥ delete[] ʤ
    int append(int a_id, void* buf) {
	pthread_mutex_lock(&lock);
	unify_list* p = search(a_id);
	if (p == NULL) {
	    p = new unify_list;
	    p->next = next;
	    p->array_id = a_id;
	    p->n = 0;
	    next = p;
	}
	p->data.append(buf);
	p->n++;

	pthread_cond_signal(&cond);
	pthread_mutex_unlock(&lock);
	return 0;
    }

    // 礹
    int unify(int a_id, array* arr, unify_type ut) {
	// ٤ƤΥǡޤԤ
	pthread_mutex_lock(&lock);
	unify_list* p;
	for (;;) {
	    p = search(a_id);
	    if (p != NULL && p->n >= arr->get_sub_num()) {
		break; // ä
	    }
	    pthread_cond_wait(&cond, &lock);
	}
	pthread_mutex_unlock(&lock);
	// 礹
	void** arrs = new void*[arr->get_sub_num()];
	int i;
	for (i = 0; i < arr->get_sub_num(); i++) {
	    arrs[i] = p->data.get(i);
	}
	arr->unify_prog(arrs, ut);
	delete[] arrs;

	// 
	pthread_mutex_lock(&lock);
	unify_list* del;
	p = prev_search(a_id);
	del = p->next;
	p->next = del->next;
	del->next = NULL;
	delete del;
	pthread_mutex_unlock(&lock);
	return 0;
    }
};

#endif /* UNIFY_H */
