/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  usercom.cc
*********************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <sched.h>
#include "usercom.h"
#include "protocol.h"
#include "msgqueue.h"

extern msgqueue send_q;
usercom_list ul;

int comq_flag;
int  ip1_flag;

// usercom_list 钥

usercom* 
usercom_list::search(int task_id, int x, int y) {
    usercom_list* p;
    for (p = next; p != NULL; p = p->next) {
	if (p->val->get_taskid() == task_id && p->val->check_have_it(x, y)) {
	    return p->val;
	}		
    }	
    return NULL;
}


// usercom 钥

// ǒ
usercom&
usercom::operator<<(int val)
{
    usercom* ucp;
    ipu_ipu  msg;
    // (cur_x,  cur_y ): ߒΒɸǒǒ꒸ɸ
    // (user_x, user_y): 撡ؒ꒤ɸǒǒ蒺ɸ

    if ((ucp = ul.search(get_taskid(), user_x, user_y)) != NULL) {
      // 蒤ϒ IPU ⒤ ip1
      pthread_mutex_lock(&ul.lock);
      setdata(cur_x, cur_y, user_x, user_y, val);
      pthread_mutex_unlock(&ul.lock);
      pthread_cond_signal(&ul.cond);
    } else {
      // 蒤ϒ̒ IPU ⒤ ip1
      // ɒ IPU ؒ쒤ВϒߒΒǒOMΒߒΒÒƒ뒤ΒOM
      msg.uc_info           = new usercom_info;
      msg.uc_info->task_id  = get_taskid();
      msg.uc_info->image_id = get_imageid();
      msg.uc_info->from_x   = cur_x;
      msg.uc_info->from_y   = cur_y;
      msg.uc_info->to_x     = user_x;
      msg.uc_info->to_y     = user_y;

             msg.buf = new char[sizeof(int)];
      *(int*)msg.buf = val;
	
      msg.to_om = new ipu_om;
      msg.to_om->type       = p_io_usercom;
      msg.to_om->size       = sizeof(int);
      send_q.putmsg(msg);
    }
    return *this;
}

// ǒ蒤
usercom&
usercom::operator>>(int& a)
{
  // (user_x, user_y): 撡ؒ꒤ɸǒǒ꒸Βɸ
  // (cur_x,  cur_y ): ߒΒɸǒǒ蒤꒺ɸ()
  
  pthread_mutex_lock(&ul.lock);
  while (getdata(a) != 0) {
    fprintf(stderr,"%d:%dԒÒƒ뒤蒡%d:%d蒡\n" \
	    ,user_x,user_y,cur_x, cur_y);
    pthread_cond_wait(&ul.cond, &ul.lock);
  }
  pthread_mutex_unlock(&ul.lock);

  return *this;
}

int
usercom::getdata(int& a)
{
    
  // Βؒmutexǒޒ쒤ƒ
  // ג񒤭com̿ᒽ钴ʬ⒡
  int pos = cur_y * com_w + cur_x;
  struct com_data* find = ptr[pos];
  struct com_data* prev = (struct com_data*)0;

  if(find != (struct com_data*)0) {   // ǒ뒻Β
     for(;find != (struct com_data*)0;prev = find,find = find->next) {
      if(find->send_x == user_x && find->send_y == user_y) {
	a = find->data;
	if(prev != (struct com_data*)0){
	  prev->next = find->next;
	  delete find;
	} else {                      // ǒ钤ΒǒΒ쒹
	  if(find->next != (struct com_data*)0) {
	    struct com_data* temp = find->next;
	    find->data   = temp->data;
	    find->send_x = temp->send_x;
	    find->send_y = temp->send_y;
	    find->next   = temp->next;
	    delete temp;
	  } else {
	    delete find;
	    ptr[pos] = (struct com_data*)0;
	  }
	}
	return 0;
      }		
     }
  }
  return 1;
}	

// ǒے˒ޒ
void setdata(int send_x, int send_y, int my_x, int my_y, int val) {
    // ג񒤭

  int pos = my_y * com_w + my_x ;
  struct com_data* temp = new (struct com_data);

  temp->data   = val;
  temp->send_x = send_x;
  temp->send_y = send_y;
  temp->next   = ptr[pos];
  ptr[pos]     = temp;

}
