/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  usercom.h
*********************************************************************/

#ifndef USERCOM_H
#define USERCOM_H

#include <stdio.h>
#include <pthread.h>
#include "jobid.h"
#include "protocol.h"

extern int comq_flag;
extern int  ip1_flag;
extern int ip1;

struct com_data {
  int data;                   //Ƥǡ
  int send_x;                 //äƤȤ
  int send_y;
  struct com_data* next;
};

struct com_data **ptr;
int com_w;		      // comm塼β

class usercom;


// usercom_list: 1ĤIPUˤ usercom (global ul)
// ip1 θĿ usercom 

class usercom_list {
  private:
    usercom_list* next;
    usercom*      val;

    usercom_list* prev_search(usercom* uc) {
	usercom_list* p;
	for (p = this; p->next != NULL; p = p->next) {
	    if (p->next->val == uc) {
		return p;
	    }
	}
	return NULL;
    };

  public:
    pthread_mutex_t	lock, lock2;
    pthread_cond_t	cond;

    usercom_list() {
	next = NULL;
	pthread_mutex_init(&lock, NULL);
	pthread_mutex_init(&lock2, NULL);
	pthread_cond_init(&cond, NULL);
	comq_flag = 0;
	ip1_flag  = 0;
    };
    ~usercom_list() {
	delete next;
    };
    int append(usercom* uc) {
	pthread_mutex_lock(&lock);
	usercom_list* p = new usercom_list;
	p->next = next;
	p->val = uc;
	next = p;
	pthread_mutex_unlock(&lock);
	return 0;
    };
    int remove(usercom* uc) {
	usercom_list* prev = prev_search(uc);
	if (prev != NULL) {
	    pthread_mutex_lock(&lock);
	    usercom_list* tmp;
	    tmp = prev->next;
	    prev->next = tmp->next;
	    tmp->next = NULL;
	    delete tmp;
	    pthread_mutex_unlock(&lock);
	}
	return 0;
    };

    // ꥹ⤫κɸĤΤõ
    // Ĥʤä NULL ֤
    usercom* search(int task_id, int x, int y);

};



// usercom: 桼̿Ԥ饹
// ɲ

extern usercom_list ul;

class usercom {
  private:
    int job_id;
    int image_id;
    int local_x, local_y;      // (0,0)б븵ɸΰ
    int width,   height;       // 󥰥åȤ礭
    int cur_x,   cur_y;        // parallel 롼ǸܤƤɸ
    int user_x,  user_y;       // 桼ꤷɸ

  public:
    usercom(int jid, int iid, int lx, int ly, int w, int h) {
	job_id   = jid;
	image_id = iid;
	local_x  = lx;
	local_y  = ly;
	width    = w;
	height   = h;

	// comm_flagmutexǰϤɬפ
	pthread_mutex_lock(&ul.lock2);
	if(ip1_flag == 0) {
	  ip1_flag++;
	  com_w = lx + w * ip1;
	  pthread_mutex_unlock(&ul.lock2);
	  if(comq_flag == 0) {
	    // ȤꤹǤȤꤢ
	    fprintf(stderr,"comqĤä衣:%d\n",com_w*(ly+h*ip1));
	    if((ptr = (struct com_data**) \
		calloc(com_w*(ly + h * ip1),sizeof(struct com_data*)))==NULL){
	      fprintf(stderr,"com_datacalloc顼\n",\
		      "̿Ūʤǽäɤ衣\n");
	      return;
	    }
	    comq_flag = 1;
	  } else {
	    if(realloc((void *)ptr, \
		       com_w*(ly + h * ip1)*sizeof(struct com_data*))==NULL){
	      fprintf(stderr,"com_datarealloc顼\n",\
		      "̿Ūʤǽäɤ衣\n");
	      return;
	    }
	  }
	} else {
	  pthread_mutex_unlock(&ul.lock2);
	}
	ul.append(this);
    };

    ~usercom() {
	ul.remove(this);
	ip1_flag = 0;
    };

    int get_jobid()   { return job_id; };
    int get_taskid()  { return job_id % 10000; };
    int get_imageid() { return image_id; };
    int set_cur(int x, int y) { cur_x = x; cur_y = y; return 0; };
    // Υ󥰥å˻κɸ뤫Ĵ٤
    int check_have_it(int x, int y) {
	if (y >= local_y && y < local_y + height && \
	    x >= local_x && x < local_x + width)
	{
	    return 1;
	} else {
	    return 0;
	}
    };

    // 桼Ȥ黻
    // com(x, y) << data ʤɤȤƻȤ
    // ߤμǤ com << data ǤȤƤޤϤäƤϤʤ
    usercom& operator<<(int a);
    usercom& operator>>(int& a);
    usercom& operator()(int x, int y) {
	user_x = x;
	user_y = y;
	return *this;
    }
    // ʥ
    int getdata(int& a);
};

// ǡ
void setdata(int send_x, int send_y, int my_x, int my_y, int val);

#endif /* USERCOM_H */
