/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  vom.cc
    IPU OM ̿
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#ifdef USE_POLL
#include <poll.h>
#else
#include <sys/time.h>
#include <sys/types.h>
#endif
#include <unistd.h>
#include "Image.h"
#include "ObjList.h"
#include "def.h"
#include "etc.h"
#include "com.h"
#include "protocol.h"
#include "msgqueue.h"
#include "waitlist.h"
#include "sync.h"
#include "paralist.h"
#include "array.h"
#include "ipu_list.h"
#include "dlmodule.h"
#include "usercom.h"

int		my_ipu_no;	/* ʬ ipu ֹ */

static int	om_fd;

msgqueue image_id_q;
ipu_list ipus;

extern msgqueue	lang_q;
extern msgqueue	dmod_q;
extern msgqueue	trans_q;
extern msgqueue	send_q;

extern msgqueue array_id_q;

extern msgqueue waitarray_q;
extern waitlist global_id_list;
extern waitlist image_boundary_list;
extern paralist p_list;
extern usercom_list ul;
extern int quit_flag;

// OM ³
int
connect_om(char* om_host, int om_port, int ip1_n)
{
    if ((om_fd = connect_host(om_host, om_port)) < 0) {
	fprintf(stderr,"connect_om: failed to connect to om (port %d)\n",
		om_port);
	return -1;
    }

    // OM  IPU ߥå

    ipu_om to_om;
    char*  hostname = get_hostname();

    to_om.type   = p_io_ipu_create;
    to_om.result = ip1_n;
    to_om.r_stat = get_loadav();
    to_om.size   = strlen(hostname);
    net_write(om_fd, "IPU", 4);
    net_write(om_fd, &to_om, sizeof(to_om));
    net_write(om_fd, hostname, strlen(hostname));

    return om_fd;
}

// OM  ⥸塼μ¹Ԥ˴ؤ done report 
void
module_donerep(const char* module_name, out_info* o_info,
	       image_info* img_info, int status)
{
    ipu_ipu	msg;

    msg.to_om = new ipu_om;

    msg.to_om->type   = p_io_module;
    msg.to_om->result = status;
    msg.to_om->size   = sizeof(image_info) * o_info->out_num;
    msg.img_info = img_info;
    msg.to_om->r_stat = get_loadav();

    strcpy(o_info->out_module, module_name);
    msg.o_info = o_info;

    send_q.putmsg(msg);
}

// OM إ⥸塼˴ؤƤ done report 
void
fdef_donerep(char* module_name, int status)
    // module_name:	⥸塼̾
    // status:		OKAY: , FAIL: 
{
    ipu_ipu	msg;

    msg.to_om = new ipu_om;

    msg.to_om->type   = p_io_fdef;
    msg.to_om->result = status;
    msg.to_om->size   = strlen(module_name);
    msg.buf = module_name;
    msg.to_om->r_stat = get_loadav();

    send_q.putmsg(msg);
}

// OM ˥⥸塼μ¹Ԥ
void
module_exec_request(char* command)
// command ˤ "A B C ADD" Τ褦ʤΤϤ
{
    ipu_ipu	msg;

    msg.to_om = new ipu_om;

    msg.to_om->type = p_io_mod_exec;
    msg.to_om->size = strlen(command);
    msg.buf = strdup_new(command);

    send_q.putmsg(msg);
}

// OM  image ID ׵
int
get_new_image_id()
{
    ipu_ipu msg;
    msg.to_om = new ipu_om;
    msg.to_om->type = p_io_image_id_request;
    msg.to_om->size = 0;
    send_q.putmsg(msg);
    image_id_q.getmsg(msg);
    int image_id = msg.img_info->image_id;
    delete msg.img_info;
    return image_id;
}

// done report Ԥؿ
void
do_donerep(ipu_om done)
{
    ipu_ipu	msg;

    msg.to_om = new ipu_om;
    *msg.to_om = done;

    send_q.putmsg(msg);
}

// ơݡȤԤåɤΥȴؿ
// Ū OM إơ
void
stat_report()
{
    ipu_om	done;
    done.type   = p_io_stat;
    done.result = OKAY;

    for (;;) {
#ifndef USE_POLL
	struct timeval quantum;
	quantum.tv_sec =  5;
	quantum.tv_usec = 0;
	select(0, NULL, NULL, NULL, &quantum);
#else
	poll(NULL, 0, 5 * 1000);
#endif
	if (quit_flag) break;
	done.r_stat = get_loadav();
	do_donerep(done);
    }
}

void
module_sync(int jobid)
{
    ipu_ipu	msg;

    msg.to_om = new ipu_om;

    msg.to_om->type   = p_io_mod_sync;
    msg.to_om->result = jobid;

    send_q.putmsg(msg);
}

static void
image_boundary_request(ipu_ipu& msg)
{
    extern ObjectList OL;
    msg.to_om = new ipu_om;
    msg.to_om->type = p_io_image_return;
    // msg.img_info ϤΤޤ޻Ȥ
    // ׵κɸ img_info  hot_x hot_y кɸäƤ
    Image* img;
    img = OL.get(msg.img_info->image_id, msg.img_info->div_id);
    int width, height;
    width = msg.img_info->width;
    height = msg.img_info->height;
    if (img == NULL) {
	msg.to_om->result = FAIL;
    } else {
	msg.to_om->result = OKAY;
	int x, y;
	int i = 0;
	switch (img->get_type()) {
	  case pt_int:
	    msg.to_om->size = width * height * sizeof(int);
	    msg.buf = new char[msg.to_om->size];
	    for (y = 0; y < height; y++) {
		for (x = 0; x < width; x++) {
		    int rel_x = msg.img_info->hot_x + x - img->get_hot_x();
		    int rel_y = msg.img_info->hot_y + y - img->get_hot_y();
		    ((int*)msg.buf)[i++] =
			img->readint(0, 0, bd_complete, rel_x, rel_y, 0);
		}
	    }
	    break;
	  case pt_real:
	    msg.to_om->size = width * height * sizeof(float);
	    msg.buf = new char[msg.to_om->size];
	    for (y = 0; y < height; y++) {
		for (x = 0; x < width; x++) {
		    int rel_x = msg.img_info->hot_x + x - img->get_hot_x();
		    int rel_y = msg.img_info->hot_y + y - img->get_hot_y();
		    ((float*)msg.buf)[i++] =
			img->readfloat(0, 0, bd_complete, rel_x, rel_y, 0);
		}
	    }
	    break;
	  case pt_complex:
	    msg.to_om->size = width * height * sizeof(complex);
	    msg.buf = new char[msg.to_om->size];
	    for (y = 0; y < height; y++) {
		for (x = 0; x < width; x++) {
		    int rel_x = msg.img_info->hot_x + x - img->get_hot_x();
		    int rel_y = msg.img_info->hot_y + y - img->get_hot_y();
		    ((complex*)msg.buf)[i++] =
			img->readcomplex(0, 0, bd_complete, rel_x, rel_y, 0);
		}
	    }
	    break;
	  default:
	    fprintf(stderr, "image_boundary_request: bad type %d\n",
		    img->get_type());
	    break;
	}
    }
    send_q.putmsg(msg);
}

// ΰž

static int
trans_image(image_info* img_info)
{
    extern ObjectList OL;
    int width       = img_info->width;
    int height      = img_info->height;
    int hot_x       = img_info->hot_x;
    int hot_y       = img_info->hot_y;
    int image_id    = img_info->image_id;
    int from_div_id = img_info->div_id;
    int task_id     = img_info->div_type; //
    int to_ipu_no   = img_info->job_id;   // äƤ
    int to_div_id   = img_info->image_no; //

#ifdef DEBUG
    fprintf(stderr, "trans_image! hot:(%d,%d) size:(%dx%d) todiv%d toipu%d\n",
	    hot_x, hot_y, width, height, to_ipu_no, to_div_id);
#endif

    Image* img = OL.get(image_id, from_div_id);
    if (img == NULL) {
	fprintf(stderr, "trans_image: OL.get failed\n");
	return -1;
    }
#ifdef DEBUG
    img->print();
    img->print_image();
#endif

    //  IPU ز
    ipu_ipu msg;
    msg.t_msg = new trans_msg;
    msg.t_msg->type   = p_ii_part_image;
    msg.t_msg->ipu_no = to_ipu_no;
    int size = width * height * img->get_one_width();
    msg.t_msg->size = size;
    msg.img_info = new image_info;
    msg.img_info->width    = width;
    msg.img_info->height   = height;
    msg.img_info->hot_x    = hot_x;
    msg.img_info->hot_y    = hot_y;
    msg.img_info->image_id = image_id;
    msg.img_info->div_id   = to_div_id;
    msg.img_info->div_type = task_id;  // 
    msg.buf = new char[size];

    int x, y;
    int i = 0;
    pixel_type pt = img->get_type();
    for (y = 0; y < height; y++) {
	for (x = 0; x < width; x++) {
	    if (pt == pt_int) {
		((int*)msg.buf)[i] = img->agetpixeli(hot_x + x, hot_y + y);
#ifdef DEBUG
		fprintf(stderr, "(%2d, %2d): %3d ž\n",
			hot_x+x, hot_y+y, ((int*)msg.buf)[i]);
#endif
	    } else if (pt == pt_real) {
		((float*)msg.buf)[i] = img->agetpixelr(hot_x + x, hot_y + y);
	    } else if (pt == pt_complex) {
		pixel_type dummy;
		((complex*)msg.buf)[i] = img->agetpixel(hot_x + x, hot_y + y,
							 dummy);
	    } else {
		fprintf(stderr, "transe_image: bad pixel type %d\n", pt);
		return -1;
	    }
	    i++;
	}
    }

    trans_q.putmsg(msg);

    return 0;
}

#ifdef DEBUG
static char* omipu_type2string(p_oi_t type);
#endif

// OM -> IPU ̿åɤΥȴؿ
void
om2ipu()
{
    ipu_ipu      msg;
    om_ipu       from_om;
    void*        v;
    para_id_info para_info;
    image_info   img_info;


    for (;;) {
	// ǡɤ褦ˤʤޤԤ
	// ʤȽ񤭥åɤ
	wait_for_read(om_fd);
	if (net_read(om_fd, &from_om, sizeof(om_ipu)) == FAIL) {
	    if (quit_flag) {
		// λ
		break;
	    }
	    fprintf(stderr, "om2ipu: net_read failed (OM -> IPU)\n");
	    quit(1);
	}
#ifdef DEBUG
	fprintf(stderr, "---- OM -> IPU: ");

	char* type_name = omipu_type2string(from_om.type);
	if (type_name != NULL) {
	    fprintf(stderr,"%s\n", type_name);
	} else {
	    fprintf(stderr,"unknown(%d)\n", from_om.type);
	}
#endif

	switch (from_om.type) {
	  case p_oi_ipu_create:
	    my_ipu_no = from_om.size;
	    break;
	  case p_oi_quit:
	    exit(0);
	    break;

	  case p_oi_ipu_no:
	    {
		char* buf;
		buf = new char[from_om.size];
		if (net_read(om_fd, buf, from_om.size) == FAIL) {
		    fprintf(stderr,"error in ipu_no read\n");
		}
		int   ipu_no;
		char* hostname;
		ipu_no = getint(buf);
		hostname = buf+4;
		ipus.append(ipu_no, hostname);
#ifdef DEBUG
		ipus.print();
#endif
		break;
	    }

	  case p_oi_ipu_p:
	    // OM  IPU-p Ƥ
	    // lang_q 
	    msg.i_info = new ipu_p_info;
	    msg.i_info->size = from_om.size;
	    msg.buf = new char[from_om.size + 1];
	    if (net_read(om_fd, msg.buf, from_om.size) == FAIL) {
		fprintf(stderr," error in IPU-p read.\n");
	    }
	    msg.buf[from_om.size] = '\0';
	    lang_q.putmsg(msg);

#if defined(DEBUG)
	    fprintf(stderr, "---- IPU-p begin ----\n");
	    fprintf(stderr, "%s", msg.buf);
	    fprintf(stderr, "---- IPU-p end ----\n");
#endif
	    break;
	  case p_oi_cxx_module:
	    // OM  VPE-p  C++ ѴΤƤ
	    // dmod_q 
	    msg.p_info = new prog_info;
	    if (net_read(om_fd, msg.p_info, sizeof(prog_info)) == FAIL)
		fprintf(stderr, "error in prog_info read\n");
	    msg.buf = new char[from_om.size + 1];
	    if (net_read(om_fd, msg.buf, from_om.size) == FAIL)
		fprintf(stderr, "error in C++ read\n");
	    msg.buf[from_om.size] = '\0';
	    dmod_q.putmsg(msg);
	    break;
	  case p_oi_dfdef:
	    {
		prog_info pi;
		if (net_read(om_fd, &pi, sizeof(prog_info)) == FAIL)
		    fprintf(stderr,"om2ipu: error in dfdef prog_info read\n");
		char buf[1024];
		sprintf(buf, "/%s %d %d %d dfdef ",
			pi.name, pi.in_num, pi.out_num, pi.param_num);
		// "/Add 2 1 0 dfdef " η
		msg.i_info = new ipu_p_info;
		msg.i_info->size = strlen(buf);
		msg.buf = strdup_new(buf);
		lang_q.putmsg(msg);
	    }
	    break;
	  case p_oi_sync:
	    sync_info s_info;
	    if (net_read(om_fd, &s_info, sizeof(sync_info)) == FAIL) {
		fprintf(stderr," error in sync_info read\n");
		break;
	    }
	    sync_done(s_info.task_id, s_info.ip1_num);
	    break;
	  case p_oi_array_id_return:
	    // from_om.size  array id
	    msg.a_info = new array_id_info;
	    msg.a_info->array_id = from_om.size;
	    array_id_q.putmsg(msg);
	    break;
	  case p_oi_image_id_return:
	    // from_om.size  image id
	    msg.img_info = new image_info;
	    msg.img_info->image_id = from_om.size;
	    image_id_q.putmsg(msg);
	    break;
	  case p_oi_signal_para:
	    if (net_read(om_fd, &para_info, sizeof(para_id_info)) == FAIL) {
		fprintf(stderr," error in para_info read\n");
		break;
	    }
	    p_list.signal(para_info.job_id, para_info.para_id);
	    break;
	  case p_oi_global_var_id:
	    msg.a_info = new array_id_info;
	    if (net_read(om_fd, msg.a_info, sizeof(array_id_info)) == FAIL) {
		fprintf(stderr," error in a_info read\n");
		break;
	    }
#ifdef DEBUG
    fprintf(stderr, "vom: put global_id_q\n");
#endif
//	    global_id_q.putmsg(msg);
	    {
		int job_id = msg.a_info->width; // ȤꤢäƤ
		int arr_no = msg.a_info->type;
		global_id_list.signal(msg.a_info, job_id, arr_no);
	    }
	    break;
	  case p_oi_wait_array_done:
	    waitarray_q.putmsg(msg);
	    break;

	  case p_oi_image_request:
	    // OM ¾ IPU  boundary β׵
	    msg.img_info = new image_info;
	    if (net_read(om_fd, msg.img_info, sizeof(image_info)) == FAIL) {
		fprintf(stderr,"om2ipu: error in img_info read\n");
		break;
	    }
	    image_boundary_request(msg);
	    break;

	  case p_oi_image_return:
	    // OM  boundary β֤äƤ
	    if (net_read(om_fd, &img_info, sizeof(image_info)) == FAIL) {
		fprintf(stderr,"om2ipu: error in img_info read\n");
		break;
	    }
	    v = new char[from_om.size];
	    if (net_read(om_fd, v, from_om.size) == FAIL) {
		fprintf(stderr,"om2ipu: error in img_info data read\n");
		break;
	    }
	    image_boundary_list.signal(v, img_info.image_id, img_info.job_id);
	    break;

	case p_oi_usercom:
	    // OM  usercom 
	    msg.uc_info = new usercom_info;
	    if (net_read(om_fd,msg.uc_info,sizeof(usercom_info)) == FAIL){
		fprintf(stderr,"om2ipu: error in uc_info read\n");
		break;
	    }
	    msg.buf = new char[from_om.size];
	    if (net_read(om_fd, msg.buf, from_om.size) == FAIL) {
		fprintf(stderr,"om2ipu: error in uc data read\n");
		break;
	    }
	    // ФIPUip1Τ
	    pthread_mutex_lock(&ul.lock);    
	    setdata(msg.uc_info->from_x,msg.uc_info->from_y,\
		    msg.uc_info->to_x,msg.uc_info->to_y,*(int*)msg.buf);
	    pthread_mutex_unlock(&ul.lock);
	    pthread_cond_signal(&ul.cond);
	    delete[] msg.buf;
	    delete   msg.uc_info;
	    break;

	    // sync_cache 
         case p_oi_trans_image:
	    if (net_read(om_fd, &img_info, sizeof(image_info)) == FAIL) {
		fprintf(stderr,"om2ipu: error in img_info read\n");
		break;
	    }
	    trans_image(&img_info);
	    break;

	  case p_oi_sync_cache_done:
	    sync_cache_info sc_info;
	    if (net_read(om_fd, &sc_info, sizeof(sync_cache_info)) == FAIL) {
		fprintf(stderr,"om2ipu: error in sc_info read\n");
		break;
	    }
	    sync_cache_done(sc_info.task_id, sc_info.image_id);
	    break;

	  default:
	    fprintf(stderr, "om2ipu: protocol error, message type: %d\n",
		    from_om.type);
	    break;
	}
    }
}

#ifdef DEBUG
static char*
omipu_type2string(p_oi_t type)
{
    switch (type) {
      case p_oi_quit:			return "quit";
      case p_oi_ipu_create:		return "ipu_create";
      case p_oi_sync:			return "sync";
      case p_oi_cxx_module:		return "cxx_module";
      case p_oi_ipu_p:			return "ipu_p";
      case p_oi_dfdef:			return "dfdef";
      case p_oi_array_id_return:	return "array_id_return";
      case p_oi_image_id_return:	return "image_id_return";
      case p_oi_signal_para:		return "signal_para";
      case p_oi_global_var_id:		return "global_var_id";
      case p_oi_ipu_no:			return "ipu_no";
      case p_oi_wait_array_done:	return "wait_array_done";
      case p_oi_image_request:		return "image_request";
      case p_oi_image_return:		return "image_return";
      case p_oi_usercom:		return "usercom";
      case p_oi_sync_cache_done:	return "sync_cache_done";
      case p_oi_trans_image:		return "trans_image";
      default:				return NULL;
    }
}
#endif

#ifdef DEBUG
static char* ipuom_type2string(p_io_t type);
#endif

// IPU -> OM ̿åɤΥȴؿ
void
ipu2om()
{
    ipu_ipu	msg;
    int 	end_flag = 0;

    while (!end_flag) {
	send_q.getmsg(msg);

#ifdef DEBUG
	char* type_name = ipuom_type2string(msg.to_om->type);
	fprintf(stderr, "---- IPU -> OM: ");
	if (type_name != NULL) {
	    fprintf(stderr, "%s", type_name);
	} else {
	    fprintf(stderr, "unknown(%d)", msg.to_om->type);
	}
	if (msg.to_om->type == p_io_module) {
	    fprintf(stderr, " %s", msg.o_info->out_module);
	}
	fprintf(stderr, ", result = %d\n", msg.to_om->result);
#endif

	if (net_write(om_fd, msg.to_om, sizeof(ipu_om)) == FAIL) {
	    if (quit_flag) {
		break;
	    }
	    fprintf(stderr, "ipu2om: net_write failed (IPU -> OM)\n");
	    quit(1);
	}

	switch (msg.to_om->type) {
	  case p_io_quit:
	    end_flag = 1;
	    break;
	  case p_io_ipu_create:
	    break;
	  case p_io_stat:
	    break;
	  case p_io_fdef:
	    // msg.buf ˤϥ⥸塼̾äƤ
	    if (net_write(om_fd, msg.buf, msg.to_om->size) == FAIL)
		fprintf(stderr," error in fdef write.\n");
	    break;
	  case p_io_module:
	    if (net_write(om_fd, msg.o_info, sizeof(out_info)) == FAIL)
		fprintf(stderr," error in module write.\n");
	    if (msg.to_om->size != 0) {
		if (net_write(om_fd, msg.img_info, msg.to_om->size) == FAIL)
		    fprintf(stderr," error in module write.\n");
	    }
	    if (msg.o_info->out_num > 1) {
		delete[] msg.img_info;
	    } else if (msg.o_info->out_num == 1) {
		delete msg.img_info;
	    }
	    delete msg.o_info;
	    break;
	  case p_io_mod_exec:
	    if (net_write(om_fd, msg.buf, msg.to_om->size) == FAIL)
		fprintf(stderr," error in mod_exec write.\n");
	    delete[] msg.buf;
	    break;
	  case p_io_mod_sync:
	    break;
	  case p_io_compile_stat:
	    if (net_write(om_fd, msg.p_info, sizeof(prog_info)) == FAIL)
		fprintf(stderr, "ipu2om: error in compile_stat\n");
	    delete msg.p_info;
	    if (msg.buf != NULL && msg.to_om->size > 0) {
		if (net_write(om_fd, msg.buf, msg.to_om->size) == FAIL)
		    fprintf(stderr, "ipu2om: error in compile_stat\n");
	    }
	    if (msg.buf != NULL) delete[] msg.buf;
	    break;
	  case p_io_module_done:
	    if (net_write(om_fd, msg.buf, msg.to_om->size) == FAIL)
		fprintf(stderr,"ipu2om: error in p_io_module_done write\n");
	    delete[] msg.buf;
	    break;
	  case p_io_image:
	    if (net_write(om_fd, msg.buf, msg.to_om->size) == FAIL)
		fprintf(stderr,"ipu2om: error in p_io_image write\n");
	    delete[] msg.buf;
	    break;
	  case p_io_dsync:
	    break;
	  case p_io_array_id_request:
	    break;
	  case p_io_image_id_request:
	    break;
	  case p_io_signal_para:
	    if (net_write(om_fd, msg.para_info, sizeof(para_id_info)) == FAIL){
		fprintf(stderr,"ipu2om: error in para_info write\n");
		break;
	    }
	    delete msg.para_info;
	    break;
	  case p_io_create_global_var:
	    if (net_write(om_fd, msg.a_info, sizeof(array_id_info)) == FAIL){
		fprintf(stderr,"ipu2om: error in a_info write\n");
		break;
	    }
	    delete msg.a_info;
	    break;

	  case p_io_wait_array:
	    if (net_write(om_fd, msg.a_info, sizeof(array_id_info)) == FAIL){
		fprintf(stderr,"ipu2om: error in a_info write\n");
		break;
	    }
	    delete msg.a_info;
	    break;

	    // ΰ賰β׵
	  case p_io_image_request:
	    if (net_write(om_fd, msg.img_info, sizeof(image_info)) == FAIL){
		fprintf(stderr,"ipu2om: error in img_info write\n");
		break;
	    }
	    delete msg.img_info;
	    break;

	    // ΰ賰βα
	  case p_io_image_return:
	    if (net_write(om_fd, msg.img_info, sizeof(image_info)) == FAIL) {
		fprintf(stderr,"ipu2om: error in img_info write\n");
	    }
	    if (net_write(om_fd, msg.buf, msg.to_om->size) == FAIL) {
		fprintf(stderr,"ipu2om: error in buf write\n");
	    }
	    delete[] msg.buf;
	    delete msg.img_info;
	    break;

	    // 桼̿
	  case p_io_usercom:
	    if (net_write(om_fd, msg.uc_info, sizeof(usercom_info)) == FAIL) {
		fprintf(stderr,"ipu2om: error in uc_info write\n");
	    }
	    if (net_write(om_fd, msg.buf, msg.to_om->size) == FAIL) {
		fprintf(stderr,"ipu2om: error in buf write\n");
	    }
	    delete msg.uc_info;
	    delete[] msg.buf;
	    delete msg.to_om;
	    break;

	    // sync_cache
	  case p_io_sync_cache:
	    if (net_write(om_fd, msg.sc_info, sizeof(sync_cache_info))==FAIL) {
		fprintf(stderr,"ipu2om: error in sc_info write\n");
	    }
	    delete msg.sc_info;
	    break;
	  case p_io_sync_cache_done:
	    if (net_write(om_fd, msg.sc_info, sizeof(sync_cache_info))==FAIL) {
		fprintf(stderr,"ipu2om: error in sc_info write\n");
	    }
	    delete msg.sc_info;
	    break;

	  default:
	    fprintf(stderr, "ipu2om: protocol error, unknown type %d\n",
		    msg.to_om->type);
	}
    }

    // OM Ȥ³
    close(om_fd);
#ifdef DEBUG2
    fprintf(stderr, "thread ipu2om end\n");
#endif
}

#ifdef DEBUG
static char*
ipuom_type2string(p_io_t type)
{
    switch (type) {
      case p_io_quit:			return "quit";
      case p_io_ipu_create:		return "ipu_create";
      case p_io_module:			return "module";
      case p_io_fdef:			return "fdef";
      case p_io_stat:			return "stat";
      case p_io_mod_sync:		return "mod_sync";
      case p_io_mod_exec:		return "mod_exec";
      case p_io_module_done:		return "module_done";
      case p_io_image:			return "image";
      case p_io_compile_stat:		return "compile_stat";
      case p_io_dsync:			return "dsync";
      case p_io_array_id_request:	return "array_id_request";
      case p_io_image_id_request:	return "image_id_request";
      case p_io_signal_para:		return "signal_para";
      case p_io_create_global_var:	return "create_global_var";
      case p_io_wait_array:		return "wait_array";
      case p_io_image_request:		return "image_request";
      case p_io_image_return:		return "image_return";
      case p_io_usercom:		return "usercom";
      case p_io_sync_cache:		return "sync_cache";
      case p_io_sync_cache_done:	return "sync_cache_done";
      default:				return NULL;
    }
}
#endif
