/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  waitlist.h
*********************************************************************/

#ifndef WAITLIST_H
#define WAITLIST_H

#include <stdio.h>
#include <pthread.h>
#include <sys/time.h>

// Β꒥
// ꒥Ȓ˒ɒÒǒ
class wait_var_list {
  private:
    wait_var_list*	next;
    int			val1, val2, val3, val4, val5;
    void*		ret_val;

    wait_var_list* prev_search(int v1, int v2, int v3, int v4, int v5) {
	wait_var_list* prev;
	for (prev = this; prev->next != NULL; prev = prev->next) {
	    if (prev->next->val1 == v1 && prev->next->val2 == v2 &&
		prev->next->val3 == v3 && prev->next->val4 == v4 &&
		prev->next->val5 == v5)
	    {
		return prev;
	    }
	}
	return NULL;
    }

  public:
    wait_var_list() {
	next = NULL;
    };
    ~wait_var_list() {
	delete next;
    };
    int append(int v1, int v2, int v3, int v4, int v5, void* r_val) {
	wait_var_list* new_var = new wait_var_list;
	new_var->next    = next;
	new_var->val1    = v1;
	new_var->val2    = v2;
	new_var->val3    = v3;
	new_var->val4    = v4;
	new_var->val5    = v5;
	new_var->ret_val = r_val;
	next = new_var;
	return 0;
    }
    // ǒ 0 ǒʒÒ 1 ֒
    int remove(int v1, int v2, int v3, int v4, int v5, void** ret) {
	wait_var_list* p = prev_search(v1, v2, v3, v4, v5);
	if (p != NULL) {
	    *ret = p->next->ret_val;
	    wait_var_list* tmp;
	    tmp = p->next;
	    p->next = tmp->next;
	    tmp->next = NULL;
	    delete tmp;
	    return 0;
	} else {
	    return 1;
	}
    }
};

// 뒾 () ԒĒ꒥
// wait(v1, v2, v3, v4, v5(v2ʒߒϒʒά)) ǒԒ
// Ʊ v1, ...  signal(v1, ...) ǒ
class waitlist {
  private:
    pthread_mutex_t	lock;
    pthread_cond_t	cond;
    wait_var_list	vars;

  public:
    waitlist() {
	pthread_mutex_init(&lock, NULL);
	pthread_cond_init(&cond, NULL);
    };
    ~waitlist() {
    };
    void* wait(int v1, int v2 = 0, int v3 = 0, int v4 = 0, int v5 = 0) {
	void* ret;
	pthread_mutex_lock(&lock);
	while (vars.remove(v1, v2, v3, v4, v5, &ret) != 0) {
	    pthread_cond_wait(&cond, &lock);
	}
	pthread_mutex_unlock(&lock);
	return ret;
    };
    int signal(void* msg, int v1, int v2 = 0, int v3 = 0,
	       int v4 = 0, int v5 = 0)
    {
	pthread_mutex_lock(&lock);
	vars.append(v1, v2, v3, v4, v5, msg);
	pthread_cond_broadcast(&cond);
	pthread_mutex_unlock(&lock);
	return 0;
    };
};

#endif /* WAITLIST_H */
