/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  DivisionList.cc
    ʬ˴ؤ
    ʬʬñ̤ʬݻ
*********************************************************************/

#include <stdio.h>
#include "DivisionList.h"
#include "ObjPartList.h"

DivisionList::DivisionList():mini_img()
{
    next = NULL;
    dividetype = dt_null;
    exist_flag = 1;
}

DivisionList::DivisionList(DivisionList* n, int d_id, div_type d_type,
		int w, int h, int hx, int hy, int ca, int ipu_no):mini_img()
    //  DivisionList ؤΥݥ, ʬ ID, ʬ䥿, 礭,
    // HotPoint, Ȥ礭, IPU ֹ
{
    next = n;
    dividetype = d_type;
    mini_img.append(d_id, w, h, hx, hy, ca, ipu_no);
    if (d_type == dt_all) {
	exist_flag = 2;
    } else {
	exist_flag = 1;
    }
}

DivisionList::~DivisionList()
{
    delete next;
}

//  d_type ĤΤõ
DivisionList*
DivisionList::search(div_type d_type)
{
    DivisionList* p;
    for (p = next; p != NULL; p = p->next) {
	if (d_type == p->dividetype) {
	    return p;
	}
    }
    return NULL;
}

static char*
divtype2string(div_type dt)
{
    switch (dt) {
      case dt_pixel:  return "pixel";
      case dt_column: return "column";
      case dt_row:    return "row";
      case dt_box:    return "box";
      case dt_all:    return "all";
      default:        return "unknown";
    }
}

// -------- ѥ֥å᥽å --------

void
DivisionList::append(int d_id, div_type d_type, int w, int h,
		     int hx, int hy, int ca, int ipu_no)
    // ʬ ID, ʬ䥿, 礭, HotPoint, Ȥ礭, IPU ֹ
{
    DivisionList* p;
    if ((p = search(d_type)) != NULL) {
	p->mini_img.append(d_id, w, h, hx, hy, ca, ipu_no);
    } else {
	next = new DivisionList(next, d_id, d_type, w, h, hx, hy, ca, ipu_no);
    }
}

int
DivisionList::append(int d_id, int ipu_no)
    // ʬ ID, IPU ֹ
{
    DivisionList* p;
    for (p = next; p != NULL; p = p->next) {
	if ((p->mini_img.append(d_id, ipu_no)) == OKAY)
	    return OKAY;
    }
    return FAIL;
}

void
DivisionList::remove_host(div_type d_type, int d_id, int ipu_no)
    // ʬ䥿, ʬ ID, IPU
{
    DivisionList* p = search(d_type);
    if (p != NULL) {
	p->mini_img.remove_host(d_id, ipu_no);
    } else {
	fprintf(stderr, "DivisionList::remove_host: %s not found\n",
		divtype2string(d_type));
    }
}

void
DivisionList::remove_objpart(div_type d_type, int d_id)
    // ʬ䥿, ʬ ID
{
    DivisionList* p = search(d_type);
    if (p != NULL) {
	p->mini_img.remove_objpart(d_id);
    } else {
	fprintf(stderr, "DivisionList::remove_objpart: %s not found\n",
		divtype2string(d_type));
    }
}

void
DivisionList::remove_division(div_type d_type)
    // ʬ䥿
{
    DivisionList* cur;
    DivisionList* pre;

    for (cur = next, pre = this; cur != NULL; pre = cur, cur = cur->next) {
	if (d_type == cur->dividetype) {
	    pre->next = cur->next;
	    cur->next = NULL;
	    delete cur;
	    return;
	}
    }
    fprintf(stderr, "DivisionList::remove_division: %s not found\n",
	    divtype2string(d_type));
}

// ʬΥۥȤˤ뤫ɤ
//  OKAY ʤ FAIL ֤
int
DivisionList::obj_part_exist_this_host(int d_id, int ipu_no)
    // ʬ ID, IPU
{
    DivisionList* p;

    for (p = next; p != NULL; p = p->next) {
	if (p->mini_img.obj_part_exist_this_host(d_id, ipu_no) == OKAY)
	    return OKAY;
    }
    return FAIL;
}

// ʬ䥿פʬäƤۥ֤̾
//  OKAY ʤ FAIL ֤
int
DivisionList::get_part_image_host(div_type d_type, int d_id, int* ipu_no_ret)
    // ʬ䥿, ʬ ID, IPU ֹ ()
{
    DivisionList* p = search(d_type);
    if (p != NULL) {
	return p->mini_img.get_part_image_host(d_id, ipu_no_ret);
    } else {
	return FAIL;
    }
}

// ʬäƤۥ֤̾
//  OKAY ʤ FAIL ֤
int
DivisionList::get_part_image_host(int d_id, int* ipu_no_ret)
    // d_id:       ʬ̾ ()
    // ipu_no_ret: IPU ֹ ()
{
    DivisionList* p;
    for (p = next; p != NULL; p = p->next) {
	if ((p->mini_img.get_part_image_host(d_id, ipu_no_ret)) == OKAY)
	    return OKAY;
    }
    return FAIL;
}

// ʬ䥿פʬäƤۥ֤̾
//  OKAY ʤ FAIL ֤
int
DivisionList::get_part_image_host(div_type d_type, int x, int y,
				  int* ipu_no_ret, int* div_id_ret)
    // ʬ䥿, ʬκɸ, IPU ֹ (), ʬ ID ()
{
    DivisionList* p = search(d_type);
    if (p != NULL) {
	return p->mini_img.get_part_image_host(x, y, ipu_no_ret, div_id_ret);
    } else {
	fprintf(stderr, "DivisionList::get_part_image_host: %s not found\n",
		divtype2string(d_type));
	return FAIL;
    }
}

// ʬ礭֤
int
DivisionList::get_image_size(div_type d_type, int d_id, int* w, int* h)
    // ʬ䥿,  ID
{
    DivisionList* p = search(d_type);
    if (p != NULL) {
	return p->mini_img.get_image_size(d_id, w, h);
    } else {
	/* fprintf(stderr, "DivisionList::get_image_size: %s not found\n",
		divtype2string(d_type)); */
	return FAIL;
    }
}

// ʬΥۥåȥݥȤ֤
int
DivisionList::get_image_hot(div_type d_type, int d_id, int* hx, int* hy)
    // ʬ䥿,  ID
{
    DivisionList* p = search(d_type);
    if (p != NULL) {
	return p->mini_img.get_image_hot(d_id, hx, hy);
    } else {
	fprintf(stderr, "DivisionList::get_image_hot: %s not found\n",
		divtype2string(d_type));
	return FAIL;
    }
}

// ʬ cache ֤
int
DivisionList::get_image_cache(div_type d_type, int d_id, int* ca)
    // ʬ䥿,  ID
{
    DivisionList* p = search(d_type);
    if (p != NULL) {
	return p->mini_img.get_image_cache(d_id, ca);
    } else {
	fprintf(stderr, "DivisionList::get_image_cache: %s not found\n",
		divtype2string(d_type));
	return FAIL;
    }
}

// ʬ䥿פ뤫ɤ
//  OKAY ʤ FAIL ֤
int
DivisionList::DivideTypeExist(div_type d_type)
{
    DivisionList* p = search(d_type);
    if (p != NULL) {
	return OKAY;
    } else {
	return FAIL;
    }
}

// ʬñ̤뤫ɤ֤
// 0:¸ߤʤ 1: 2:¸ߤ
int
DivisionList::get_divide_type_exist(div_type d_type)
{
    DivisionList* p = search(d_type);
    if (p != NULL) {
	return p->exist_flag;
    } else {
	return 0;
    }
}

// ʬñ̤¸ߤ򥻥å
int
DivisionList::set_divide_type_exist(div_type d_type, int exist)
{
    DivisionList* p = search(d_type);
    if (p == NULL) {
	p = new DivisionList();
	p->next = next;
	next = p;
	p->dividetype = d_type;
    }
    p->exist_flag = exist;
    return OKAY;
}

// ǥХå
void
DivisionList::print(int indent_level)
{
    if (next != NULL) next->print_sub(indent_level);
}

void
DivisionList::print_sub(int indent_level)
{
    int i;
    if (next != NULL) next->print_sub(indent_level);
    for (i = 0; i < indent_level; i++) fprintf(stderr, " ");
    fprintf(stderr, "divide type = %s\n", divtype2string(dividetype));
    mini_img.print(indent_level+1);
}
