/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  IpuList.cc
    IPU ꥹ (IPU )
*********************************************************************/

#include <stdio.h>
#include <string.h>
#include "IpuList.h"
#include "etc.h"

// ץ饤١ȥ᥽å

IpuList::IpuList(IpuList* n, int ipu_n, char* h_name, int ip1,
		 int r_load, float perf)
//	 IpuList ؤΥݥ, IPU ֹ, ׻̾, ip1 ο,
//	׻, ׻Υѥեޥ
{
    next          = n;
    ipu_no        = ipu_n;
    hostname      = strdup_new(h_name);
    ip1_num       = ip1;
    ipu_load      = 0;
    ruser_load    = r_load;
    perform       = perf;
    ipu_num       = -1; // Ƭ IpuList ˤΤߵϿ
    total_ip1_num = -1; //
}

IpuList*
IpuList::search(int ipu_n)
{
    IpuList* cur;
    for (cur = next; cur != NULL; cur = cur->next) {
	if (ipu_n == cur->ipu_no) {
	    return cur;
	}
    }
    return NULL;
}

IpuList*
IpuList::search(char* h_name)
{
    IpuList* cur;
    for (cur = next; cur != NULL; cur = cur->next) {
	if (cur->hostname != NULL && strcmp(h_name, cur->hostname) == 0) {
	    return cur;
	}
    }
    return NULL;
}

// ѥ֥å᥽å

IpuList::IpuList()
{
    next = NULL;
    hostname = NULL;
    ruser_load = -1;
    ipu_load = -1;
    ipu_no = -1;
    ipu_num = 0;
    total_ip1_num = 0;
}

IpuList::~IpuList()
{
    delete hostname;
    delete next;
}

// ꥹȤ IPU ɲä
int
IpuList::append(char* h_name, int ip1_n, int r_load, float perf)
{
    IpuList* p;
    int ipu;
    if ((p = search(h_name)) == NULL) {
	ipu = ipu_num++;
	next = new IpuList(next, ipu, h_name, ip1_n, r_load, perf);
	total_ip1_num += ip1_n;
    } else {
	fprintf(stderr, "IpuList::append: %s already exist\n", h_name);
	ipu = p->ipu_no;
	total_ip1_num -= p->ip1_num;
	p->perform    = perf;
	p->ip1_num    = ip1_n;
	p->ruser_load = r_load;
	total_ip1_num += p->ip1_num;
    }
    return ipu;
}

//  IPU ٤1夲 (ۥ̾ IPU )
void
IpuList::add_ipu_load(char* h_name)
{
    IpuList* p;
    if ((p = search(h_name)) != NULL) {
	p->ipu_load++;
#ifdef DEBUG
	fprintf(stderr, "IpuList::add_ipu_load: %s ipu load %d\n",
		p->hostname, p->ipu_load);
#endif
    } else {
	fprintf(stderr, "IpuList::add_ipu_load: %s is not found \n", h_name);
    }
}

//  IPU ٤1夲 (IPU ֹ IPU )
void
IpuList::add_ipu_load(int ipu_n)
{
    IpuList* p;
    if ((p = search(ipu_n)) != NULL) {
	p->ipu_load++;
#ifdef DEBUG
	fprintf(stderr, "IpuList::add_ipu_load: %s ipu load %d\n",
		p->hostname, p->ipu_load);
#endif
    } else {
	fprintf(stderr, "IpuList::add_ipu_load: %d is not found \n", ipu_n);
    }
}

//  IPU ٤1 (ۥ̾ IPU )
void
IpuList::sub_ipu_load(char* h_name)
{
    IpuList* p;
    if ((p = search(h_name)) != NULL) {
	p->ipu_load--;
#ifdef DEBUG
	fprintf(stderr, "IpuList::sub_ipu_load: %s ipu load %d\n",
		p->hostname, p->ipu_load);
#endif
    } else {
	fprintf(stderr, "IpuList::sub_ipu_load: %s is not found \n", h_name);
    }
}

//  IPU ٤1 (IPU ֹ IPU )
void
IpuList::sub_ipu_load(int ipu_n)
{
    IpuList* p;
    if ((p = search(ipu_n)) != NULL) {
	p->ipu_load--;
#ifdef DEBUG
	fprintf(stderr, "IpuList::sub_ipu_load: %s ipu load %d\n",
		p->hostname, p->ipu_load);
#endif
    } else {
	fprintf(stderr, "IpuList::sub_ipu_load: %d is not found \n", ipu_n);
    }
}

//  IPU  ip1 ο (ۥ̾ IPU )
int
IpuList::get_ip1_num(char* h_name)
{
    IpuList* p;
    if ((p = search(h_name)) != NULL) {
	return p->ip1_num;
    } else {
	fprintf(stderr, "IpuList::get_ip1_num: %s is not found \n", h_name);
	return -1;
    }
}

//  IPU  ip1 ο (IPU ֹ IPU )
int
IpuList::get_ip1_num(int ipu_n)
{
    IpuList* p;
    if ((p = search(ipu_n)) != NULL) {
	return p->ip1_num;
    } else {
	fprintf(stderr, "IpuList::get_ip1_num: %d is not found \n", ipu_n);
	return -1;
    }
}

// ip1 οιפ
int
IpuList::get_total_ip1_num()
{
    return total_ip1_num;
}

// IPU ˤΰʳ٤񤭴
void
IpuList::set_ruser_load(char* h_name, int r_load)
{
    IpuList* p;
    if ((p = search(h_name)) != NULL) {
	p->ruser_load = r_load;
    } else {
	fprintf(stderr, "IpuList::set_ruser_load: %s is not found \n", h_name);
    }
}
void
IpuList::set_ruser_load(int ipu, int r_load)
{
    IpuList* p;
    if ((p = search(ipu)) != NULL) {
	p->ruser_load = r_load;
    } else {
	fprintf(stderr, "IpuList::set_ruser_load: %d is not found \n", ipu);
    }
}

// IPU ˤΰʳ٤
int
IpuList::get_ruser_load(char* h_name)
{
    IpuList* p;
    if ((p = search(h_name)) != NULL) {
	return p->ruser_load;
    } else {
	fprintf(stderr, "IpuList::get_ruesr_load: %s is not found \n", h_name);
	return 0;
    }
}
int
IpuList::get_ruser_load(int ipu)
{
    IpuList* p;
    if ((p = search(ipu)) != NULL) {
	return p->ruser_load;
    } else {
	fprintf(stderr, "IpuList::get_ruesr_load: %d is not found \n", ipu);
	return 0;
    }
}

// ޥΥѥեޥ󥹤񤭴
void
IpuList::set_perform(char* h_name, float perf)
{
    IpuList* p;
    if ((p = search(h_name)) != NULL) {
	p->perform = perf;
    } else {
	fprintf(stderr, "IpuList::set_perform: %s is not found \n", h_name);
    }
}
void
IpuList::set_perform(int ipu, float perf)
{
    IpuList* p;
    if ((p = search(ipu)) != NULL) {
	p->perform = perf;
    } else {
	fprintf(stderr, "IpuList::set_perform: %d is not found \n", ipu);
    }
}

// ַڤ IPU ֹ֤
int
IpuList::get_light_weight_ipu_no()
{
    int l_ipu = -1;
    float cost = 10000.0;
    float m_cost = 0;
    int exist = 1;
    int size = 1;
    int time = 60;

    IpuList* cur;
    for (cur = next; cur != NULL; cur = cur->next) {
	m_cost = (cur->ruser_load/(float)256+1) * (cur->ipu_load+1) *
	    time/(cur->perform)*10 + exist*(5/2*size+0.1);
	if (cost > m_cost) {
	    l_ipu = cur->ipu_no;
	    cost = m_cost;
	}
    }
    return l_ipu;
}

// IPU ֹ椫ۥ֤̾
char*
IpuList::get_hostname(int ipu_n)
{
    IpuList* p;
    if ((p = search(ipu_n)) != NULL) {
	return p->hostname;
    } else {
	fprintf(stderr,
		"IpuList::get_hostname_from_ipu_no: %d is not found \n",
		ipu_n);
	return NULL;
    }
}

// ۥ̾ IPU ֹ֤
int
IpuList::get_ipu_no(char* h_name)
{
    IpuList* p;
    if ((p = search(h_name)) != NULL) {
	return p->ipu_no;
    } else {
	fprintf(stderr, "IpuList::get_ipu_no: %s is not found \n", h_name);
	return -1;
    }
}
