/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  MachineList.cc
    äƤ IPU Υꥹ
*********************************************************************/

#include <stdio.h>
#include <string.h>
#include "MachineList.h"
#include "etc.h"

MachineList::MachineList()
{
    next = NULL;
    ipu_no = -1;
}

MachineList::MachineList(MachineList* n, int ipu)
{
    next = n;
    ipu_no = ipu;
}

MachineList::~MachineList()
{
    delete next;
}

MachineList*
MachineList::search(int ipu)
{
    MachineList* p;
    for (p = next; p != NULL; p = p->next) {
	if (p->ipu_no == ipu) {
	    return p;
	}
    }
    return NULL;
}

// ꥹȤɲ
void
MachineList::append(int ipu)
{
    // ʣϿ򤱤
    MachineList* p = search(ipu);
    if (p == NULL) {
	// ʤʤϿ
	next = new MachineList(next, ipu);
    }
}

void
MachineList::remove(int ipu)
{
    MachineList* cur = next;
    MachineList* pre = this;

    while (cur != NULL) {
	if (cur->ipu_no == ipu) {
	    pre->next = cur->next;
	    cur->next = NULL;
	    delete cur;
	    return;
	}
	pre = cur;
	cur = cur->next;
    }
    fprintf(stderr, "MachineList::remove: ipu %d not found\n", ipu);
}

// ΥۥȤ¸ߤ뤫
//  OKAY ʤ FAIL ֤
int
MachineList::is_exist(int ipu)
{
    MachineList* p = search(ipu);
    if (p != NULL) {
	return OKAY;
    } else {
	return FAIL;
    }
}

// Ŭ IPU ֤̾
// ΰϸƤӽФ¦Ѱ
int
MachineList::get_one(int* ipu_no_ret)
{
    if (next != NULL) {
	*ipu_no_ret = next->ipu_no;
	return OKAY;
    } else {
	*ipu_no_ret = -1;
	return FAIL;
    }
}

// ǥХå
#include "IpuList.h"
extern IpuList ip;

void
MachineList::print(int indent_level)
{
    if (next != NULL) next->print_sub(indent_level);
}

void
MachineList::print_sub(int indent_level)
{
    int i;
    if (next != NULL) next->print_sub(indent_level);
    for (i = 0; i < indent_level; i++) fprintf(stderr, " ");
    char* ipu_name = ip.get_hostname(ipu_no);
    fprintf(stderr, "ipu no = %d (%s)\n",
	    ipu_no, ipu_name == NULL ? "(null)" : ipu_name);
}
