/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  ModuleList.h
    ⥸塼ꥹ (⥸塼)
*********************************************************************/

#ifndef MODULELIST_H
#define MODULELIST_H

#include <stdio.h>
#include "vios.h"
#include "div.h"

#define	MODULE_NOW	0
#define	COMPILED	1

class ModuleList
{
  private:
    ModuleList*	next;
    char* 	name;			// ⥸塼̾
    int 	in_num;			// ϲο
    int 	out_num;		// ϲο
    int 	param_num;		// ѥ᡼ο
    div_type* 	divtype;		// ʬñ
    int*	boxsize;		// ʬñ̤ box ΤȤ礭
    int* 	cache;			// Ȥ礭
    int 	rundivtype;		// ¹Իʬˡ
    int 	etime;			// ¹Ի
    int 	compile;		// ѥ뤷Ƥ뤫ɤ
    int 	internal_flag;		// ⥸塼뤫ɤ

    ModuleList(ModuleList* n, char* name, int in_num, int out_num, int param_n,
	       div_type* dt, int* boxsize, int* cahce, int rtype,
	       int etime, int comp, int is_internal);

    ModuleList* search(char* name);

    // ⥸塼ǡեɤ߽񤭤᥽å
    int         read_file();
    int         write_file();
    int         read_module_data_line(FILE* fp); // read_file ƤФ

    // ⥸塼ꥹȤ˥⥸塼ä(ե񤭹ߤʤ)
    void        append_no_write(char* name, int in_n, int out_n, int param_n,
			div_type* dt, int* boxsize, int* cache, int rtype,
			int etime, int comp, int is_internal);

    // IPU Τ餻
    void        ModuleList::ipu_dfdef(int ipu_no, ModuleList* mp);
    void        ModuleList::ipu_dfdef(ModuleList* mp);

  public:
    ModuleList();
    ~ModuleList();

    // IPU Τ餻
    void     ModuleList::ipu_dfdef_all(int ipu_no);
    // ⥸塼ꥹȤ˥⥸塼ä(եؤ)
    void     append(char* name, int in_num, int out_num, int param_num,
		div_type* dt, int* boxsize, int* cache, int rtype,
		int etime, int comp);
    // ٤ƤΥ⥸塼
    void     remove_all();
    // Υ⥸塼
    void     remove(char* name);
    // ⥸塼뤬¸ߤ뤫ɤ
    int      exist(char* name);

    // Υ⥸塼ϲʬñ̤֤
    int      get_in_divide_types(char* name, div_type* dt);
    // Υ⥸塼λϲʬñ̤֤
    div_type get_in_divide_type(char* name, int i);
    // Υ⥸塼λϲ box 礭֤
    int      get_in_box_size(char* name, int i, int* width, int* height);
    // Υ⥸塼λϲȤ礭֤
    int      get_in_cache(char* name, int i);

    // Υ⥸塼νϲʬñ̤֤
    int      get_out_divide_types(char* name, div_type* dt);
    // Υ⥸塼λνϲʬñ̤֤
    div_type get_out_divide_type(char* name, int i);
    // Υ⥸塼λνϲ box 礭֤
    int      get_out_box_size(char* name, int i, int* width, int* height);
    // Υ⥸塼λνϲȤ礭֤
    int      get_out_cache(char* name, int i);

    // Υ⥸塼 rtype (¹Իʬˡ) ֤
    int      get_rtype(char* name);

    // Υ⥸塼ϲο֤
    int      get_in_num(char* name);
    // Υ⥸塼νϲο֤
    int      get_out_num(char* name);
    // Υ⥸塼Υѥ᡼ο֤
    int      get_param_num(char* name);
    // Υ⥸塼μ¹Ի֤֤
    int      get_exec_time(char* name);
    // Υ⥸塼Υѥ֤򥻥åȤ
    int      set_compile(char* name, int comp);
};

#endif /* MODULELIST_H */
