/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  ObjPartList.cc
    ֥ȥѡ ()
    ʬ
*********************************************************************/

#include <stdio.h>
#include <string.h>
#include "ObjPartList.h"
#include "etc.h"

ObjPartList::ObjPartList():ipus()
{
    next = NULL;
    width = height = -1;
    hot_x = hot_y = -1;
}

ObjPartList::ObjPartList(ObjPartList* n, int d_id, int w, int h,
			 int hx, int hy, int ca, int ipu_no):ipus()
{
    next   = n;
    div_id = d_id;
    width  = w;
    height = h;
    hot_x  = hx;
    hot_y  = hy;
    cache  = ca;
    ipus.append(ipu_no);
}

ObjPartList::~ObjPartList()
{
    delete next;
}

ObjPartList*
ObjPartList::search(int d_id)
{
    ObjPartList* p;
    for (p = next; p != NULL; p = p->next) {
	if (p->div_id == d_id) {
	    return p;
	}
    }
    return NULL;
}

// -------- ѥ֥å᥽å --------

void
ObjPartList::append(int d_id, int w, int h, int hx, int hy, int ca, int ipu_no)
{
    if (append(d_id, ipu_no) == FAIL) {
	next = new ObjPartList(next, d_id, w, h, hx, hy, ca, ipu_no);
    }
}

int
ObjPartList::append(int d_id, int ipu_no)
{
    ObjPartList* p = search(d_id);
    if (p != NULL) {
	p->ipus.append(ipu_no);
	return OKAY;
    }
    return FAIL;
}

void
ObjPartList::remove_host(int d_id, int ipu_no)
{
    ObjPartList* p;
    if ((p = search(d_id)) != NULL) {
	p->ipus.remove(ipu_no);
    }
    fprintf(stderr, "ObjPartList::remove_host: d_id %d not found\n", d_id);
}

void
ObjPartList::remove_objpart(int d_id)
{
    ObjPartList* p;
    ObjPartList* prev;
    for (prev = this, p = next; p != NULL; prev = p, p = p->next) {
	if (p->div_id == d_id) {
	    prev->next = p->next;
	    p->next = NULL;
	    delete p;
	    return;
	}
    }
    fprintf(stderr, "ObjPartList::remove_objpart: d_id %d not found\n", d_id);
}

// ʬΥۥȤˤ뤫ɤ
//  OKAY ʤ FAIL ֤
int
ObjPartList::obj_part_exist_this_host(int d_id, int ipu_no)
{
    ObjPartList* p;
    if ((p = search(d_id)) != NULL) {
	return p->ipus.is_exist(ipu_no);
    }
    return FAIL;
}

// ʬäƤۥ֤̾
//  OKAY ʤ FAIL ֤
int
ObjPartList::get_part_image_host(int d_id, int* ipu_no_ret)
    // d_id:       ʬ ID ()
    // ipu_no_ret: IPU ֹ ()
{
    ObjPartList* p;
    if ((p = search(d_id)) != NULL) {
	p->ipus.get_one(ipu_no_ret);
	return OKAY;
    }
    return FAIL;
}

// ʬäƤۥ֤̾
//  OKAY ʤ FAIL ֤
int
ObjPartList::get_part_image_host(int x, int y, int* ipu_no_ret,
				 int* div_id_ret)
    // x, y:       ʬκɸ
    // ipu_no_ret: IPU ֹ ()
{
    ObjPartList* p;
    for (p = next; p != NULL; p = p->next) {
	if (p->hot_x <= x && x < p->hot_x + p->width &&
	    p->hot_y <= y && y < p->hot_y + p->height)
	{
	    p->ipus.get_one(ipu_no_ret);
	    *div_id_ret = p->div_id;
	    return OKAY;
	}
    }
    return FAIL;
}

// ʬ礭֤
int
ObjPartList::get_image_size(int d_id, int* w, int* h)
{
    ObjPartList* p;
    if ((p = search(d_id)) != NULL) {
	*w = p->width;
	*h = p->height;
	return OKAY;
    }/*
    fprintf(stderr, "ObjPartList::get_image_size: d_id %d not found\n", d_id);
    */ return FAIL;
}

// ʬΥۥåȥݥȤ֤
int
ObjPartList::get_image_hot(int d_id, int* hx, int* hy)
{
    ObjPartList* p;
    if ((p = search(d_id)) != NULL) {
	*hx = p->hot_x;
	*hy = p->hot_y;
	return OKAY;
    }
    fprintf(stderr, "ObjPartList::get_image_hot: d_id %d not found\n", d_id);
    return FAIL;
}

// ʬ cache ֤
int
ObjPartList::get_image_cache(int d_id, int* ca)
{
    ObjPartList* p;
    if ((p = search(d_id)) != NULL) {
	*ca = p->cache;
	return OKAY;
    }
    fprintf(stderr, "ObjPartList::get_image_cache: d_id %d not found\n", d_id);
    return FAIL;
}

// ǥХå
void
ObjPartList::print(int indent_level)
{
    if (next != NULL) next->print_sub(indent_level);
}

void
ObjPartList::print_sub(int indent_level)
{
    int i;
    if (next != NULL) next->print_sub(indent_level);
    for (i = 0; i < indent_level; i++) fprintf(stderr, " ");
    fprintf(stderr, "div id = %d\n", div_id);
    for (i = 0; i < indent_level; i++) fprintf(stderr, " ");
    fprintf(stderr, "size: (%d x %d), hot: (%d, %d), cache: %d\n",
	    width, height, hot_x, hot_y, cache);
    ipus.print(indent_level+1);
}
