/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  ObjectList.h
    δ
*********************************************************************/

#ifndef OBJECTLIST_H
#define OBJECTLIST_H

#include <stream.h>
#include <pthread.h>
#include "DivisionList.h"
#include "div.h"
#include "vios.h"

class ObjectList
{
  private:
    ObjectList*		next;
    int 		image_id;   //  ID
    int 		wait_count; // = 0 λ
                                    // > 0 Ȥ
                                    // < 0 ȤĤϤ狼ʤɺ
    DivisionList	div_img;    // ʬ
    pthread_mutex_t	lock;

    ObjectList(int i_id, int wait_count, ObjectList* n);
    ObjectList* ObjectList::search(int i_id);

  public:
    ObjectList();
    ~ObjectList();

    // 
    void new_image(int i_id, int wait_count);
    // ֥ȥꥹȤ˥֥Ȥä
    void append(int i_id, int d_id, div_type d_type, int width, int height,
		int hot_x, int hot_y, int ca, int ipu_no);
    // ֥ȥѡ̾ǥ֥Ȥä
    void append(int i_id, int d_id, int ipu_no);

    // wait_count 1餹
    void decr_wait_count(int i_id);
    // wait_count 
    int  get_wait_count(int i_id);

    // ٤ƤΥ֥Ȥ
    void remove_all_object();

    // Υۥ̾
    void remove_host(int i_id, div_type d_type, int d_id, int ipu_no);
    // Υ֥ȥѡȤ
    void remove_objpart(int i_id, div_type d_type, int d_id);
    // Υ֥Ȥ
    void remove_object(int i_id);
    // ʬˡΥ֥Ȥ
    void remove_division(int i_id, div_type d_type);

    // ʬΥۥȤˤ뤫ɤ
    //  OKAY ʤ FAIL ֤
    int obj_part_exist_this_host(int i_id, int d_id, int ipu_no);

    // ʬäƤۥ֤̾
    //  OKAY ʤ FAIL ֤
    int get_part_image_host(int i_id, div_type d_type,
			    int d_id, int* ipu_no_ret);
    // ʬäƤۥ֤̾
    //  OKAY ʤ FAIL ֤
    int get_part_image_host(int i_id, int d_id, int* ipu_no_ret);
    // ʬäƤۥ֤̾
    //  OKAY ʤ FAIL ֤
    int get_part_image_host(int i_id, div_type d_type,
			    int x, int y, int* ipu_no_ret, int* div_id_ret);

    // β礭֤
    int get_image_size(int i_id, div_type d_type, int d_id, int* w, int* h);
    // βΥۥåȥݥȤ֤
    int get_image_hot(int i_id, div_type d_type, int d_id, int* hx, int* hy);
    // β cache ֤
    int get_image_cache(int i_id, div_type d_type, int d_id, int* ca);

    // βλʬñ̤뤫ɤ
    //  OKAY ʤ FAIL ֤
    int DivideTypeExist(int i_id, div_type d_type);

    // β뤫ɤ  OKAY ʤ FAIL
    int ObjExist(int i_id);

    // βλʬñ̤뤫ɤ֤
    // 0:¸ߤʤ 1: 2:¸ߤ
    int get_divide_type_exist(int i_id, div_type d_type);
    // βλʬñ̤¸ߤ򥻥åȤ
    int set_divide_type_exist(int i_id, div_type d_type, int exist);

    // ǥХå
  private:
    void print_sub(int indent_level = 0);
  public:
    void print(int indent_level = 0);
};

#endif /* OBJECTLIST_H */
