/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  TaskData.cc
    δ
*********************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "ObjectList.h"
#include "ModuleList.h"
#include "IpuList.h"
#include "TaskData.h"
#include "etc.h"

extern ModuleList mo;
extern ObjectList ob;
extern IpuList ip;

// **********************************************************************
//	ǡδʥץ饤١
// **********************************************************************

// ⥸塼뤬 row * colmun -> pixel Ĵ٤
// ʤʬ colmun  all Ȥߤʤ褦ˤ
static void
conv_d_type(int inimg_number,  div_type* inimg_d_type,
	    int outimg_number, div_type* outimg_d_type)
{
    int i;
    int in_row_flag = 0;
    int in_column_flag = 0;
    int out_pixel_flag = 0;
    for (i = 0; i < inimg_number; i++) {
	if (inimg_d_type[i] == dt_row) in_row_flag = 1;
	if (inimg_d_type[i] == dt_column) in_column_flag = 1;
    }
    for (i = 0; i < outimg_number; i++) {
	if (outimg_d_type[i] == dt_pixel) out_pixel_flag = 1;
    }
    if (in_row_flag && in_column_flag && out_pixel_flag) {
	for (i = 0; i < inimg_number; i++) {
	    if (inimg_d_type[i] == dt_column) inimg_d_type[i] = dt_all;
	}
    }
}

TaskData::TaskData(TaskData* n, char* mod_name, int tid,
		   int* in, int* out, int* prm, char* str_param)
// in, out, prm  new []줿ΡΤޤ޻Ȥ
// ƤӽФ¦Ǥ delete[] ʤ
{
    int i;
    next = n;
    module_name = strdup_new(mod_name);
    taskid = tid;
    task_state = ts_not_ready;
    inimg_id  = in;
    outimg_id = out;
    param_id  = prm;
    inimg_number  = mo.get_in_num(mod_name);
    outimg_number = mo.get_out_num(mod_name);
    param_number  = mo.get_param_num(mod_name);
    if (inimg_number > 0) {
	inimg_d_type = new div_type[inimg_number];
	inimg_state  = new split_stat_t[inimg_number];
    } else {
	inimg_d_type = NULL;
	inimg_state  = NULL;
    }
    mo.get_in_divide_types(mod_name, inimg_d_type);
    for (i = 0; i < inimg_number; i++) {
	inimg_state[i] = ss_inimg_yet;
    }
    if (outimg_number > 0) {
	outimg_d_type = new div_type[outimg_number];
    } else {
	outimg_d_type = NULL;
    }
    mo.get_out_divide_types(mod_name, outimg_d_type);

    conv_d_type(inimg_number, inimg_d_type, outimg_number, outimg_d_type);

    string_param = (str_param != NULL) ? strdup_new(str_param) : NULL;
    running_number = 0;
    pthread_mutex_init(&lock, NULL);
#ifdef DEBUG
    fprintf(stderr, "TaskData::TaskData: ⥸塼 %s Ͽޤ\n",
	    mod_name);
#endif
}

TaskData*
TaskData::search(const int tid)
{
    pthread_mutex_lock(&lock);

    TaskData* cur;
    for (cur = next; cur != NULL; cur = cur->next) {
	if (tid == cur->taskid) {
	    pthread_mutex_unlock(&lock);
	    return cur;
	}
    }
    return NULL;
}

// **********************************************************************
//	ǡδʥѥ֥å
// **********************************************************************

TaskData::TaskData()
{
    next = NULL;
    module_name = NULL;
    taskid = -1;
    inimg_id = NULL;
    outimg_id = NULL;
    param_id = NULL;
    string_param = NULL;
    inimg_d_type = NULL;
    inimg_state  = NULL;
    outimg_d_type = NULL;
    pthread_mutex_init(&lock, NULL);
}

TaskData::~TaskData()
{
    delete[] module_name;
    delete[] param_id;
    delete[] outimg_id;
    delete[] inimg_id;
    delete[] outimg_d_type;
    delete[] inimg_d_type;
    delete[] inimg_state;
    delete[] string_param;
    delete next;
}

// ɽ (ǥХå) 
static char*
ts2name(task_stat_t st)
{
    switch (st) {
      case ts_not_ready:  return "not_ready";
      case ts_executable: return "executable";
      case ts_executing:  return "executing";
      default: return "unknown";
    }
}

void
TaskData::print(int tid)
{
    TaskData*	p = search(tid);
    if (p == NULL) {
	fprintf(stderr, "TaskData::print: no such task (tid = %d)\n", tid);
	pthread_mutex_unlock(&lock);
	return;
    }

    pthread_mutex_lock(&p->lock);
    fprintf(stderr, "taskid = %d, ", p->taskid);
    fprintf(stderr, "module_name = `%s', ", p->module_name);
    fprintf(stderr, "task_state = %s\n", ts2name(p->task_state));
    int i;
    for (i = 0; i < p->inimg_number; i++) {
	if (p->inimg_id != NULL) {
	    fprintf(stderr, " in  %d: image_id=%d, div=%s\n",
		    i, p->inimg_id[i], dt2string(p->inimg_d_type[i]));
	}
    }
    for (i = 0; i < p->outimg_number; i++) {
	if (p->outimg_id != NULL) {
	    fprintf(stderr, " out %d: image_id=%d, div=%s\n",
		    i, p->outimg_id[i], dt2string(p->outimg_d_type[i]));
	}
    }
    if (p->string_param != NULL) {
	fprintf(stderr, "string_param = `%s'\n", p->string_param);
    }
    pthread_mutex_unlock(&p->lock);
}

// ΥϿƤΥ tid (0ʾ) ֤
// 顼 -1 ֤
// prog ؤϽ񤭴 (δؿԹˤ)
// ⤷ƤӽФ prog ѤȤ (ʤȻפ) դ뤳
int
TaskData::add_entry(char* prog)
{
    static int	tid = 0; //  ID

#ifdef DEBUG
    fprintf(stderr, "TaskData::add_entry: `%s' Ͽޤ\n", prog);
#endif

    // "0 1 2 Add" Τ褦ʸϤ

    char* prog_p = prog;

    // ǽ˥⥸塼̾Ĵ٤
    // (⥸塼̾狼ʤȰο狼ʤ)

    char* mod_name;
    if (strlen(prog) <= 0) {
	fprintf(stderr, "TaskData::add_entry: bad prog\n");
	return -1;
    }
    prog_p = prog + strlen(prog) - 1;
    while (isspace(*prog_p) && prog_p > prog) prog_p--;
    *(prog_p + 1) = '\0';
    while (!isspace(*prog_p) && prog_p > prog) prog_p--;
    mod_name = prog_p + 1;

#ifdef DEBUG
    fprintf(stderr, "TaskData::add_entry: module name = `%s'\n", mod_name);
#endif

    // Ĵ٤

    int       iop; // 0:in, 1:out, 2:param
    int*      ids[3];
    int       n[3]; // in, out, param 줾ΰο
    char*     name_p;
    int       i;
    char*     str_param = NULL;

    n[0] = mo.get_in_num(mod_name);
    n[1] = mo.get_out_num(mod_name);
    n[2] = mo.get_param_num(mod_name);
    ids[0] = ids[1] = ids[2] = NULL;

#ifdef DEBUG
    fprintf(stderr, "TaskData::add_entry: in: %d, out: %d, param: %d\n",
	    n[0], n[1], n[2]);
#endif

    prog_p = prog;

    for (iop = 0; iop < 3; iop++) {
	if (n[iop] > 0) {
	    ids[iop] = new int[n[iop]];
	}
	for (i = 0; i < n[iop]; i++) {
	    while (isspace(*prog_p)) prog_p++;
	    name_p = prog_p;
	    while (!isspace(*prog_p) && *prog_p != '\0') prog_p++;
	    if (*prog_p == '\0') {
		fprintf(stderr, "TaskData::add_entry: too few args for %s\n",
			mod_name);
		delete[] ids[2]; delete[] ids[1]; delete[] ids[0];
		return -1;
	    }
	    *prog_p++ = '\0';
	    int id = atoi(name_p);
	    if (iop < 2) {
		// image
		ids[iop][i] = id;
	    } else {
		// parameter
		if (strcmp(mod_name, "load") == 0 ||
		    strcmp(mod_name, "cload") == 0 ||
		    strcmp(mod_name, "save") == 0 ||
		    strcmp(mod_name, "csave") == 0)
		{
		    str_param = name_p;
		} else {
		    ids[iop][i] = id;
		}
	    }
	}
    }

    // Ǹϥ⥸塼̾ (ǽĴ٤Ƥ)
    // 顼å (¿ȺǽĴ٤⥸塼̾Ȱפʤ)
    while (isspace(*prog_p)) prog_p++;
    if (prog_p != mod_name) {
	fprintf(stderr, "TaskData::add_entry: too many args for %s\n",
		mod_name);
	delete[] ids[2]; delete[] ids[1]; delete[] ids[0];
	return -1;
    }

    //  ID Ͽ
    pthread_mutex_lock(&lock);
    int t = tid++;
    next = new TaskData(next, mod_name, t, ids[0], ids[1], ids[2], str_param);
    // no delete ids[i]
    pthread_mutex_unlock(&lock);

    return t;
}

// ΥΥ⥸塼֤̾
// ƤӽФͤؤƤΰ򿨤äƤϤʤ
// (ΰؤƤΤ)
char*
TaskData::get_module_name(int tid)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr, "TaskData::get_module_name: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return NULL;
    }

    return p->module_name;
}

int
TaskData::get_inimg_number(int tid)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr,"TaskData::get_inimg_number: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return -1;
    }

    return p->inimg_number;
}

int
TaskData::get_outimg_number(int tid)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr,"TaskData::get_outimg_number: no such task (tid = %d)\n"
		,tid);
	pthread_mutex_unlock(&lock);
	return -1;
    }

    return p->outimg_number;
}

int
TaskData::get_inimg_id(int tid, int n)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr, "TaskData::get_inimg_id: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return -1;
    }
    if (p->inimg_id == NULL) {
	fprintf(stderr, "TaskData::get_inimg_id: internal error\n");
	return -1;
    }
    return p->inimg_id[n];
}

int
TaskData::get_outimg_id(int tid, int n)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr, "TaskData::get_outimg_id: no such task (tid =%d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return -1;
    }
    if (p->outimg_id == NULL) {
	fprintf(stderr, "TaskData::get_outimg_id: internal error\n");
	return -1;
    }
    return p->outimg_id[n];
}

int
TaskData::get_param_id(int tid, int n)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr, "TaskData::get_param_id: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return -1;
    }
    if (p->param_id == NULL) {
	fprintf(stderr, "TaskData::get_param_id: internal error\n");
	return -1;
    }

    return p->param_id[n];
}

char*
TaskData::get_string_param(int tid)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr, "TaskData::get_string_param: no such task (tid = %d)\n"
		,tid);
	pthread_mutex_unlock(&lock);
	return NULL;
    }
    return p->string_param;
}

// ɽ (ǥХå) 
#ifdef DEBUG
static char*
ss2string(split_stat_t ss)
{
    switch (ss) {
      case ss_inimg_yet:   return "inimg_yet";
      case ss_wait:        return "wait";
      case ss_need_join:   return "need_join";
      case ss_joining:     return "joining";
      case ss_need_split:  return "need_split";
      case ss_splitting:   return "splitting";
      case ss_split_done:  return "split_done";
      default: return "unknown";
    }
}
#endif

// ΥϲΥνϲˤʤäƤ뤫Ĵ٤
int
TaskData::CheckDepend(TaskData* p, int img_id)
{
    int i;
    for (p = p->next; p != NULL; p = p->next) {
	for (i = 0; i < p->outimg_number; i++) {
	    if (img_id == p->outimg_id[i]) {
		return 1; // ¸Ƥ
	    }
	}
    }
    return 0;
}

// ΥϲΥƱʬϲˤʤäƤ뤫Ĵ٤
split_stat_t
TaskData::CheckPrevState(TaskData* p, int img_id, div_type dt)
{
    int i;
    for (p = p->next; p != NULL; p = p->next) {
	for (i = 0; i < p->inimg_number; i++) {
	    if (img_id == p->inimg_id[i]) {
		// TaskData  inimg_d_type ѤƤǽΤ
		// mo ΤȤ
		div_type prev_dt = mo.get_in_divide_type(p->module_name, i);
		if (prev_dt == dt) {
		    return p->inimg_state[i]; // Ʊ
		}
	    }
	}
    }
    return ss_null;
}

split_stat_t
TaskData::get_inimg_state(int tid, int n)
{
    TaskData*	cur;

    if ((cur = search(tid)) == NULL) {
	fprintf(stderr, "TaskData::get_inimg_state: no such task (tid = %d)\n"
		,tid);
	pthread_mutex_unlock(&lock);
	return ss_null;
    }

    pthread_mutex_lock(&cur->lock);
    int img_id;
    if ((img_id = cur->inimg_id[n]) < 0) {
	fprintf(stderr, "TaskData::get_inimg_state: no such inimg\n");
	pthread_mutex_unlock(&cur->lock);
	return ss_null;
    }

#ifdef DEBUG
    fprintf(stderr, "tid %d, img %d, state = %s\n",
	    tid, n, ss2string(cur->inimg_state[n]));
#endif

    div_type d_type = cur->inimg_d_type[n];
    int exist;
    exist = ob.get_divide_type_exist(img_id, d_type);
    if (exist == 0) {
	// ʬñ̤¸ߤʤ
	int master_exist = ob.get_divide_type_exist(img_id, dt_all);
	if (master_exist == 0) {
	    // ¸ߤʤ
	    cur->inimg_state[n] = ss_need_join;
	} else if (master_exist == 1) {
	    // 
	    cur->inimg_state[n] = ss_joining;
	} else if (master_exist == 2) {
	    // Ϥ
	    if (d_type == dt_all) {
		cur->inimg_state[n] = ss_split_done;
	    } else {
		cur->inimg_state[n] = ss_need_split;
	    }
	} else {
	    // 顼
	    fprintf(stderr, "TaskData::get_inimg_state: bad master_exist\n");
	}
    } else if (exist == 1) {
	// ʬñ̤Ϻ
	cur->inimg_state[n] = ss_splitting;
    } else if (exist == 2) {
	// ʬñ̤¸ߤ
	cur->inimg_state[n] = ss_split_done;
    } else {
	// 顼
	fprintf(stderr, "TaskData::get_inimg_state: bad exist\n");
    }

#ifdef DEBUG
    fprintf(stderr, "tid %d, img %d, state = %s\n",
	    tid, n, ss2string(cur->inimg_state[n]));
#endif

    pthread_mutex_unlock(&cur->lock);
    return cur->inimg_state[n];
}

void
TaskData::set_inimg_state(int tid, int n, split_stat_t state)
{
    TaskData*	cur;

    if ((cur = search(tid)) == NULL) {
	fprintf(stderr, "TaskData::set_inimg_satate: no such task (tid = %d)\n"
		,tid);
	pthread_mutex_unlock(&lock);
	return;
    }

    cur->inimg_state[n] = state;
}

int
TaskData::get_running_number(int tid)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr,
		"TaskData::get_runnging_number: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return 0;
    }

    return p->running_number;
}

int
TaskData::set_running_number(int tid, int n)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr,
		"TaskData::set_runnging_number: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return FAIL;
    }

    p->running_number = n;
    return OKAY;
}

int
TaskData::decr_running_number(int tid)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr,
		"TaskData::decr_runnging_number: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return FAIL;
    }

    p->running_number--;
    return OKAY;
}

void
TaskData::set_task_state(int tid, task_stat_t state)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr, "TaskData::set_task_state: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return;
    }

    p->task_state = state;
    if (state == ts_executing) {
#ifdef DEBUG
	fprintf(stderr, "TaskData::set_task_state: start %d!\n", tid);
	void time_print(char*);
	time_print("task start");
#endif
	gettimeofday(&p->start_time, NULL);
    }
}

// ΥΥѥ᡼ΥΥѥ᡼ˤʤäƤ뤫Ĵ٤
int
TaskData::check_depend_param(TaskData* p, int prm_id)
{
    int i;
    for (p = p->next; p != NULL; p = p->next) {
	for (i = 0; i < p->param_number; i++) {
	    if (prm_id == p->param_id[i]) {
		return 1; // ¸Ƥ
	    }
	}
    }
    return 0;
}

// Υμ¹Ծ֤֤
// (٤Ƥϲ split_done ˤʤäơ٤ƤΥѥ᡼ ps_ok 
//  ʤä¹Բǽ)
task_stat_t
TaskData::get_task_state(int tid)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr, "TaskData::get_task_state: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return ts_null;
    }
    if (p->task_state == ts_not_ready) {
	// ⤷ޤ¹ԲǽǤʤʤ¹ԲǽˤʤäĴ٤
	p->task_state = ts_executable;
	int i;
	// ϲΥå
	// ϲΥ뤫Ʊ˥å
	int w_tmp, h_tmp;
	for (i = 0; i < p->inimg_number; i++) {
	    if (p->inimg_state[i] != ss_split_done) {
		p->task_state = ts_not_ready;
		break;
	    }
	}
	// ѥ᡼Υå
	for (i = 0; i < p->param_number; i++) {
	    if (check_depend_param(p, p->param_id[i])) {
		// Υ⥸塼뤬ѥ᡼˽񤤤Ƥ
		p->task_state = ts_not_ready;
	    }
	}
    }

    return p->task_state;
}

int
TaskData::remove(int tid)
{
    pthread_mutex_lock(&lock);

    TaskData** prev;
    for (prev = &next; *prev != NULL; prev = &((*prev)->next)) {
	if ((*prev)->taskid == tid) {
	    TaskData* tmp;
	    tmp = *prev;
	    *prev = tmp->next;
	    tmp->next = NULL;
	    delete tmp;
	    pthread_mutex_unlock(&lock);
	    return OKAY;
	}
    }

    fprintf(stderr, "TaskData::remove: no such task (tid = %d)\n", tid);
    pthread_mutex_unlock(&lock);
    return FAIL;
}

struct timeval*
TaskData::get_start_time(int tid)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr, "TaskData::get_start_time: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return NULL;
    }

    return &p->start_time;
}

div_type
TaskData::get_in_divide_type(int tid, int i)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr,
		"TaskData::get_in_divide_type: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return dt_null;
    }
    if (i >= 0 && i < p->inimg_number) {
	return p->inimg_d_type[i];
    } else {
	fprintf(stderr, "TaskData::get_in_divide_type: i overflow\n");
	return dt_null;
    }
}

div_type
TaskData::get_out_divide_type(int tid, int i)
{
    TaskData* p = search(tid);
    if (p == NULL) {
	fprintf(stderr,
		"TaskData::get_out_divide_type: no such task (tid = %d)\n",
		tid);
	pthread_mutex_unlock(&lock);
	return dt_null;
    }
    if (i >= 0 && i < p->outimg_number) {
	return p->outimg_d_type[i];
    } else {
	fprintf(stderr, "TaskData::get_out_divide_type: i overflow\n");
	return dt_null;
    }
}
