/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  TaskData.h
    δ
*********************************************************************/

#ifndef	TASKDATA_H
#define	TASKDATA_H

#include <sys/time.h>
#include <pthread.h>
#include "div.h"

// ʬ֤η
enum split_stat_t {
    ss_null,
    ss_inimg_yet,  //  (ʬ䤹뤫ʤޤޤäƤʤ)
    ss_wait,       // Υ⥸塼βԤ (ʬ䤹뤫ϤϤޤäƤʤ)
    ss_need_join,  // 礬ɬ
    ss_joining,    // Υ⥸塼βԤ
    ss_need_split, // ʬ䤹ȷ᤿ɤޤʬ䤷Ƥʤ
    ss_splitting,  // ʬ
    ss_split_done  // ʬ佪λޤʬ䤷ʤ
};

// μ¹Ծ֤η
enum task_stat_t {
    ts_null,
    ts_not_ready,  // ޤ¹ԲǽǤʤ (ʬʤ)
    ts_executable, // ¹Բǽ
    ts_executing   // ¹
};

class TaskData {
  private:
    TaskData*		next;
    char*		module_name;
    int 		taskid;
    task_stat_t		task_state;
    int*		inimg_id;
    int*		outimg_id;
    int*		param_id;
    char*		string_param; // load, save ΤȤˤȤե̾
    int 		inimg_number;
    div_type*		inimg_d_type;
    split_stat_t* 	inimg_state;
    int 		outimg_number;
    div_type*		outimg_d_type;
    int 		param_number;
    int 		running_number; //  ip1 äƤ뤫
    struct timeval	start_time;
    pthread_mutex_t	lock;

    TaskData(TaskData* n, char* mod_name, int tid, \
	     int* in, int* out, int* prm, char* str_param);
    TaskData*		search(const int tid);
    int 		CheckDepend(TaskData* p, int img_id);
    int 		check_depend_param(TaskData* p, int param_id);
    split_stat_t	CheckPrevState(TaskData* p, int img_id, div_type dt);

  public:
    TaskData();
    ~TaskData();
    void		print(int tid);

    int 		add_entry(char* prog);
    char* 		get_module_name(int tid);
    int 		get_inimg_number(int tid);
    int 		get_outimg_number(int tid);
    int 		get_inimg_id(int tid, int n);
    int 		get_outimg_id(int tid, int n);
    int 		get_param_id(int tid, int n);
    split_stat_t	get_inimg_state(int tid, int n);
    void		set_inimg_state(int tid, int n, split_stat_t state);
    char*		get_string_param(int tid);
    void		set_task_state(int tid, task_stat_t state);
    task_stat_t		get_task_state(int tid);
    int 		set_running_number(int tid, int n);
    int 		get_running_number(int tid);
    int 		decr_running_number(int tid); // 1餹

    int 		remove(int tid);
    struct timeval*	get_start_time(int tid);

    div_type 		get_in_divide_type(int tid, int i);
    div_type 		get_out_divide_type(int tid, int i);
};

#endif /* TASKDATA_H */
