/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  VarList.cc
    ѿꥹȡѿ
*********************************************************************/

#include <stdio.h>
#include <pthread.h>
#include "VarList.h"

//######################################################################
//	ѿꥹȥ饹ʥץ饤١
//######################################################################

VarList::VarList(VarList* n, int id_, int ipu_no_)
{
    pthread_mutex_init(&lock, NULL);
    next = n;
    id = id_;
    ipu_no = ipu_no_;
}

//  ID Ǥõ
// Ĥäϥåݻޤ֤
VarList*
VarList::search(int id_)
{
    VarList* cur = next;

    while (cur != NULL) {
	pthread_mutex_lock(&cur->lock);
	if (cur->id == id_)
	    return cur;
	pthread_mutex_t* mp = &cur->lock;
	cur = cur->next;
	pthread_mutex_unlock(mp);
    }
    return NULL;
}

//######################################################################
//	ѿꥹȥ饹ʥѥ֥å
//######################################################################

VarList::VarList()
{
    pthread_mutex_init(&lock, NULL);
    next = NULL;
}

VarList::~VarList()
{
    delete next;
}

void
VarList::append(int id_, int ipu_no_)
{
    VarList* cur;

    if ((cur = search(id_)) != NULL) {
	cur->ipu_no = ipu_no_;
	pthread_mutex_unlock(&cur->lock);
#ifdef DEBUG
	fprintf(stderr, "VarList::append: ");
	fprintf(stderr, "ID:%d IPU-no:%d ǹϿޤ\n", id_,ipu_no_);
#endif
	return;
    }

    next = new VarList(next, id_, ipu_no_);
#ifdef DEBUG
    fprintf(stderr, "VarList::append: ");
    fprintf(stderr, "ID:%d IPU-no:%d ǿϿޤ\n", id_, ipu_no_);
#endif
}

int
VarList::get_ipu_no(int id_)
{
    VarList* p = search(id_);
    if (p == NULL) {
	return -1;
    }
    pthread_mutex_unlock(&p->lock);
    return p->ipu_no;
}
