/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  com.cc
    ̿
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#ifdef USE_POLL
#include <poll.h>
#else
#include <sys/time.h>
#endif
#include <netinet/in.h>
#include <sys/socket.h>
#include <errno.h>
#include "vios.h"
#include "msgqueue.h"
#include "com.h"
#include "comvpe.h"
#include "comipu.h"

int
wait_for_read(int fd)
{
#ifdef USE_POLL
    pollfd poll_fds;
    poll_fds.fd = fd;
    poll_fds.events = POLLIN;
    return poll(&poll_fds, 1, -1);
#else
    fd_set fds;
    FD_ZERO(&fds);
    FD_SET(fd, &fds);
    return select(fd+1, &fds, NULL, NULL, NULL);
#endif
}

// ͥåȥɤ߽񤭴ؿ

int
net_read(int fd, void* buf, int size)
{
    int 	wc;
    int 	rest = size;
    char*	rbuf = (char*)buf;

    while (rest > 0) {
	// ޤǡɤ褦ˤʤΤԤ
	// ʤȽ񤭥åɤ
	if (wait_for_read(fd) < 0) {
	    return FAIL;
	}
	// ǡɤ褦ˤʤäºݤɤ߹
	wc = read(fd, rbuf, rest);
	if (wc == -1) {
	    return FAIL;
	}
	rbuf  += wc;
	rest  -= wc;
    }
    return OKAY;
}

int
net_write(int fd, void* buf, int size)
{
    int 	wc;
    int 	rest = size;
    char*	wbuf = (char*)buf;

    while (rest > 0) {
	wc = write(fd, wbuf, rest);
	if (wc == -1) {
	    perror("net_write: write failed");
	    exit(1);
	    return FAIL;
	}
	wbuf  += wc;
	rest  -= wc;
    }

    return OKAY;
}

// 
// ̿ѤεһҤ򥪡ץ󤷡ɥ쥹ꤷơεһҤ֤
// ݡֹϤδؿƤӽФ¦ǻꤹ
// 顼 -1 ֤
static int
open_listen_fd(int port)
{
    int 		listen_fd = -1;
    sockaddr_in	 	addr;

    memset(&addr, 0, sizeof(addr));
    addr.sin_family	 = AF_INET;
    addr.sin_addr.s_addr = htonl(INADDR_ANY);
    addr.sin_port	 = htons(port);

    if ((listen_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	perror("open_listen_fd: socket failed");
	return -1;
    }

    if (bind(listen_fd, (struct sockaddr*)&addr, sizeof(addr)) < 0) {
	perror("open_listen_fd: bind failed");
	close(listen_fd);
	return -1;
    }

    if (listen(listen_fd, 5) < 0) {
	perror("open_listen_fd: listen failed");
	close(listen_fd);
	return -1;
    }

    int arg = 1;
    setsockopt(listen_fd, SOL_SOCKET, SO_REUSEADDR, (char*)&arg, sizeof(arg));
    struct linger lin;
    lin.l_onoff  = 1;
    lin.l_linger = 3;
    setsockopt(listen_fd, SOL_SOCKET, SO_LINGER, (char*)&lin, sizeof(lin));

    return listen_fd;
}

// ̿Хåɥȴؿ
static void comm_sub(int* fdp);
void
comm(int* port_p)
{
    int 	port = *port_p; delete port_p;
    int 	listen_fd = -1;
    int 	fd;

    if ((listen_fd = open_listen_fd(port)) < 0) {
	fprintf(stderr, "comm: open_listen_fd failed (port %d)\n", port);
	fprintf(stderr, "comm: faital error, cannot setup server\n");
	exit(1);
    }

    // ³Ԥ̵¥롼
    for (;;) {

	// ³դ
	for (;;) {
	    if ((fd = accept(listen_fd, NULL, NULL)) >= 0) {
		// ³줿
		break;
	    }
	    if (errno == EINTR) {
		// accept ˳ߤä
		// accept ľ
		continue;
	    }
	    // ¾Υ顼
	    perror("comm: accept failed");
	}

	// åɤƤΥåɤǤ³Ȥ̿Ԥ
	// ³μդϤΥåɤǰ³Ԥ

	int* fdp = new int;
	*fdp = fd;
	pthread_t tid;
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	pthread_create(&tid, &attr, (void* (*)(void*))comm_sub, fdp);
	pthread_attr_destroy(&attr);
    }
}

// ꤬̿ VPE  IPU ȽǤˤäؿƤ
static void
comm_sub(int* fdp)
{
    int fd = *fdp; delete fdp;
    char buf[4];
    if (net_read(fd, buf, 4) == FAIL) {
	fprintf(stderr, "comm_sub: cannot read data\n");
	close(fd);
	return;
    }
    if (strcmp(buf, "VPE") == 0) {
	comm_vpe(fd);
    } else if (strcmp(buf, "IPU") == 0) {
	comm_ipu(fd);
    } else {
	fprintf(stderr, "comm_sub: protocol error\n");
	return;
    }
}
