/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  comipu.cc
    OM <-> IPU ̿
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "com.h"
#include "comipu.h"
#include "msgqueue.h"
#include "ModuleList.h"
#include "IpuList.h"
#include "etc.h"

extern msgqueue   done_q, com_q, send_q[64], sche_q, vpe_send_q, dsync_q;
extern ModuleList mo;
extern IpuList    ip;

// ɤ߽񤭥åɤϤη
struct comipu_arg {
    int fd;
    int ipu_no;
};

static void	ipu2om(comipu_arg*);
static void	om2ipu(comipu_arg*);

// IPU  IPU ֹΤ餻
static int
send_ipu_no(int ipu_no)
{
    om_om msg;

    msg.to_ipu = new om_ipu;
    msg.to_ipu->type = p_oi_ipu_create;
    msg.to_ipu->size = ipu_no;
    send_q[ipu_no].putmsg(msg);

    int nipus = ip.get_ipu_num();
    int i, j;
    for (i = 0; i < nipus; i++) {
	for (j = 0; j < nipus; j++) {
	    char* hostname = ip.get_hostname(j);
	    int size = 4 + strlen(hostname)+1;
	    msg.to_ipu = new om_ipu;
	    msg.to_ipu->type = p_oi_ipu_no;
	    msg.to_ipu->size = size;
	    msg.buf = new char[size];
	    setint(msg.buf, j);
	    strcpy(msg.buf+4, hostname);
	    send_q[i].putmsg(msg);
	}
    }

    return 0;
}

// VPE  IPU ǤȤ
static int
send_vpe_ipu_create(int ipu_no, char* hostname)
{
    om_om msg;
    msg.to_vpe = new om_vpe;
    msg.to_vpe->type = p_ov_ipu_create;
    int len = strlen(hostname);
    msg.to_vpe->size = 4+len;
    msg.buf = new char[4+len];
    setint(msg.buf, ipu_no);
    strncpy(msg.buf+4, hostname, len);
    vpe_send_q.putmsg(msg);

    return 0;
}

// IPU ̿륹åɤ (IPU ³ƤȤ˸ƤФ)
void
comm_ipu(int fd)
{
    // إåɤ߹
    ipu_om from_ipu;
    char hostname[256];
    if (net_read(fd, &from_ipu, sizeof(from_ipu)) == FAIL ||
	from_ipu.type != p_io_ipu_create ||
	net_read(fd, hostname, from_ipu.size) == FAIL)
    {
	fprintf(stderr, "comm_ipu: header read error\n");
	close(fd);
	return;
    }
    hostname[from_ipu.size] = '\0';

    // IpuList Ͽ
    int ipu_no;
    int ip1_n = from_ipu.result;
    int rstat = from_ipu.r_stat;
    ipu_no = ip.append(hostname, ip1_n, rstat, 10.0 /* <- perform */);

    // VPE Τ餻
    send_vpe_ipu_create(ipu_no, hostname);

    // ɤ߽񤭥åɤ
    comipu_arg* arg1 = new comipu_arg;
    comipu_arg* arg2 = new comipu_arg;
    arg1->fd     = arg2->fd     = fd;
    arg1->ipu_no = arg2->ipu_no = ipu_no;

    pthread_t tid;
    pthread_attr_t attr;
    pthread_attr_init(&attr);
    pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
    pthread_create(&tid, &attr, (void* (*)(void*))ipu2om, arg1);
    pthread_create(&tid, &attr, (void* (*)(void*))om2ipu, arg2);
    pthread_attr_destroy(&attr);

    // IPU ˺ǽɬפå
    send_ipu_no(ipu_no);
    mo.ipu_dfdef_all(ipu_no);

    return;
}

#ifdef DEBUG
static char* omipu_type2string(p_oi_t type);
#endif

// OM  IPU إåؿ
// åɥȴؿ
// IPU 1ĤˤĤΥåɤ1ĺ
static void
om2ipu(comipu_arg* arg)
{
    om_om	msg;
    int 	fd  = arg->fd;
    int 	ipu = arg->ipu_no;
    delete arg;

#ifdef DEBUG
    fprintf(stderr, "### Thread for IPU transmitter\n");
#endif

    for (;;) {
	send_q[ipu].getmsg(msg);

#ifdef DEBUG
	char* type_name;
	type_name = omipu_type2string(msg.to_ipu->type);
	fprintf(stderr, "---- OM -> IPU[%d] message type = ", ipu);
	if (type_name != NULL) {
	    fprintf(stderr, "%s\n", type_name);
	} else {
	    fprintf(stderr, "unknown(%d)\n", msg.to_ipu->type);
	}
#endif

	net_write(fd, msg.to_ipu, sizeof(om_ipu));

	switch (msg.to_ipu->type) {
	  case p_oi_cxx_module:
	    net_write(fd, msg.p_info, sizeof(prog_info));
	    net_write(fd, msg.buf, msg.to_ipu->size);
#ifdef DEBUG2
	    fprintf(stderr, "**** to ipu (C++) begin ****\n");
	    fprintf(stderr, "%s", msg.buf);
	    fprintf(stderr, "**** to ipu (C++) end   ****\n");
#endif
	    delete msg.p_info;
	    delete msg.buf;
	    break;
	  case p_oi_ipu_p:
	    net_write(fd, msg.buf, msg.to_ipu->size);
#ifdef DEBUG
	    fprintf(stderr, "**** to ipu (IPU-p) begin ****\n");
	    fprintf(stderr, "host = %d, size = %d\n", ipu, msg.to_ipu->size);
	    fprintf(stderr, "%s", msg.buf);
	    fprintf(stderr, "**** to ipu (IPU-p) end   ****\n");
#endif
	    delete msg.buf;
	    break;
	  case p_oi_dfdef:
	    net_write(fd, msg.p_info, sizeof(prog_info));
	    delete msg.p_info;
	    break;
	  case p_oi_ipu_create:
	    break;
	  case p_oi_quit:
	    break;
	  case p_oi_array_id_return:
	    // array_id  size äƤ
	    break;
	  case p_oi_image_id_return:
	    // image_id  size äƤ
	    break;
	  case p_oi_signal_para:
	    net_write(fd, msg.para_info, sizeof(para_id_info));
	    delete msg.para_info;
	    break;
	  case p_oi_global_var_id:
	    net_write(fd, msg.a_info, sizeof(array_id_info));
	    delete msg.a_info;
	    break;
	  case p_oi_ipu_no:
	    net_write(fd, msg.buf, msg.to_ipu->size);
	    delete[] msg.buf;
	    break;
	  case p_oi_wait_array_done:
	    break;
	  case p_oi_sync:
	    net_write(fd, msg.s_info, sizeof(sync_info));
	    delete msg.s_info;
	    break;
	  case p_oi_image_request:
	    net_write(fd, msg.img_info, sizeof(image_info));
	    delete msg.img_info;
	    break;
	  case p_oi_image_return:
	    net_write(fd, msg.img_info, sizeof(image_info));
	    net_write(fd, msg.buf, msg.to_ipu->size);
	    delete[] msg.buf;
	    delete msg.img_info;
	    break;
	  case p_oi_usercom:
	    net_write(fd, msg.uc_info, sizeof(usercom_info));
	    net_write(fd, msg.buf, msg.to_ipu->size);
	    delete[] msg.buf;
	    delete msg.uc_info;
	    break;
	  case p_oi_trans_image:
	    net_write(fd, msg.img_info, sizeof(image_info));
	    delete msg.img_info;
	    break;
	  case p_oi_sync_cache_done:
	    net_write(fd, msg.sc_info, sizeof(sync_cache_info));
	    delete msg.sc_info;
	    break;

	  default:
	    fprintf(stderr, "om2ipu: protocol error (%d)\n", msg.to_ipu->type);
	    break;
	}
	delete msg.to_ipu;
    }
}

#ifdef DEBUG
static char*
omipu_type2string(p_oi_t type)
{
    switch (type) {
      case p_oi_quit:			return "quit";
      case p_oi_ipu_create:		return "ipu_create";
      case p_oi_sync:			return "sync";
      case p_oi_cxx_module:		return "cxx_module";
      case p_oi_ipu_p:			return "ipu_p";
      case p_oi_dfdef:			return "dfdef";
      case p_oi_array_id_return:	return "array_id_return";
      case p_oi_image_id_return:	return "image_id_return";
      case p_oi_signal_para:		return "signal_para";
      case p_oi_global_var_id:		return "global_var_id";
      case p_oi_ipu_no:			return "ipu_no";
      case p_oi_wait_array_done:	return "wait_array_done";
      case p_oi_image_request:		return "image_request";
      case p_oi_image_return:		return "image_return";
      case p_oi_usercom:		return "usercom";
      case p_oi_sync_cache_done:	return "sync_cache_done";
      case p_oi_trans_image:		return "trans_image";
      default:				return NULL;
    }
}
#endif

#ifdef DEBUG
static char* ipuom_type2string(p_io_t type);
#endif

// IPU åؿ
// åɥȴؿ
// IPU 1ĤˤĤΥåɤ1ĺ
static void
ipu2om(comipu_arg* arg)
{
    int 	fd  = arg->fd;
    int 	ipu = arg->ipu_no;
    delete arg;

    ipu_om* 	from_ipu;
    om_om	msg;

    /* message read */
#ifdef DEBUG
    fprintf(stderr, "### Thread for IPU receiver\n");
#endif

    for (;;) {
	from_ipu = new ipu_om;
	if (net_read(fd, from_ipu, sizeof(ipu_om)) == FAIL) {
	    fprintf(stderr, "ipu2om: net_read failed\n");
	    delete from_ipu;
	    pthread_exit(0);
	}

#ifdef DEBUG
	char* type_name = ipuom_type2string(from_ipu->type);
	fprintf(stderr, "---- IPU[%d] -> OM message type = ", ipu);
	if (type_name != NULL) {
	    fprintf(stderr, "%s\n", type_name);
	} else {
	    fprintf(stderr, "unknown(%d)\n", from_ipu->type);
	}
#endif

	msg.done = from_ipu;
	switch (from_ipu->type) {
	  case p_io_quit:
	    // IPU Ȥ³
	    close(fd);
	    delete from_ipu;
	    pthread_exit(0);
	    break;

	  case p_io_ipu_create:
	    // ipu_create Ϻǽ1ˤϤʤ
	    fprintf(stderr, "ipu2om: protocol error (ipu_create)\n");
	    continue;
	  case p_io_stat:
	    break;
	  case p_io_module:
	    // ⥸塼¹Է
	    msg.o_info = new out_info;
	    net_read(fd, msg.o_info, sizeof(out_info));
	    if (from_ipu->size != 0) {
		msg.img_info = new image_info[msg.o_info->out_num];
		net_read(fd, msg.img_info, from_ipu->size);
	    }
	    break;
	  case p_io_fdef:
	    // ⥸塼̾
	    msg.buf = new char[from_ipu->size + 1];
	    net_read(fd, msg.buf, from_ipu->size);
	    msg.buf[from_ipu->size] = '\0';
	    break;
	  case p_io_mod_exec:
	    msg.buf = new char[from_ipu->size + 1];
	    net_read(fd, msg.buf, from_ipu->size);
	    msg.buf[from_ipu->size] = '\0';
	    // msg.buf ˤϡ "A B C ADD" Τ褦ʤΤ
	    sche_q.putmsg(msg);
	    continue; // done_q ؤϤʤ
	  case p_io_mod_sync:
	    break;
	  case p_io_module_done:
	    msg.buf = new char[from_ipu->size];
	    net_read(fd, msg.buf, from_ipu->size);
	    break;
	  case p_io_image:
	    msg.buf = new char[from_ipu->size];
	    net_read(fd, msg.buf, from_ipu->size);
	    break;
	  case p_io_compile_stat:
	    msg.p_info = new prog_info;
	    net_read(fd, msg.p_info, sizeof(prog_info));
	    msg.buf = new char[from_ipu->size];
	    net_read(fd, msg.buf, from_ipu->size);
	    break;
	  case p_io_dsync:
	    dsync_q.putmsg(msg);
	    break;
	  case p_io_array_id_request:
	    break;
	  case p_io_image_id_request:
	    break;
	  case p_io_signal_para:
	    msg.para_info = new para_id_info;
	    net_read(fd, msg.para_info, sizeof(para_id_info));
	    break;
	  case p_io_create_global_var:
	    msg.a_info = new array_id_info;
	    net_read(fd, msg.a_info, sizeof(array_id_info));
	    break;

	  case p_io_wait_array:
	    msg.a_info = new array_id_info;
	    net_read(fd, msg.a_info, sizeof(array_id_info));
	    sche_q.putmsg(msg);
	    continue; // done_q ؤϤʤ

	    // ʬΰ賰β׵
	  case p_io_image_request:
	    msg.img_info = new image_info;
	    net_read(fd, msg.img_info, sizeof(image_info));
	    break;
	    // ʬΰ賰β׵α
	  case p_io_image_return:
	    msg.img_info = new image_info;
	    msg.buf = new char[from_ipu->size];
	    net_read(fd, msg.img_info, sizeof(image_info));
	    net_read(fd, msg.buf, from_ipu->size);
	    break;

	    // 桼̿
	  case p_io_usercom:
	    msg.uc_info = new usercom_info;
	    msg.buf = new char[from_ipu->size];
	    net_read(fd, msg.uc_info, sizeof(usercom_info));
	    net_read(fd, msg.buf, from_ipu->size);
	    break;

	    // sync_cache
	  case p_io_sync_cache:
	    msg.sc_info = new sync_cache_info;
	    net_read(fd, msg.sc_info, sizeof(sync_cache_info));
	    break;
	  case p_io_sync_cache_done:
	    msg.sc_info = new sync_cache_info;
	    net_read(fd, msg.sc_info, sizeof(sync_cache_info));
	    break;

	  default:
	    fprintf(stderr, "ipu2om: unknown type %d\n", from_ipu->type);
	    break;
	}

	done_q.putmsg(msg, ipu); 	// to th_done
    }
    close(fd);
    exit(0);
}

#ifdef DEBUG
static char*
ipuom_type2string(p_io_t type)
{
    switch (type) {
      case p_io_quit:			return "quit";
      case p_io_ipu_create:		return "ipu_create";
      case p_io_module:			return "module";
      case p_io_fdef:			return "fdef";
      case p_io_stat:			return "stat";
      case p_io_mod_sync:		return "mod_sync";
      case p_io_mod_exec:		return "mod_exec";
      case p_io_compile_stat:		return "compile_stat";
      case p_io_module_done:		return "module_done";
      case p_io_image:			return "image";
      case p_io_dsync:			return "dsync";
      case p_io_array_id_request:	return "array_id_request";
      case p_io_image_id_request:	return "image_id_request";
      case p_io_signal_para:		return "signal_para";
      case p_io_create_global_var:	return "create_global_var";
      case p_io_wait_array:		return "wait_array";
      case p_io_image_request:		return "image_request";
      case p_io_image_return:		return "image_return";
      case p_io_usercom:		return "usercom";
      case p_io_sync_cache:		return "sync_cache";
      default:				return NULL;
    }
}
#endif
