/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  msgqueue.h
    å塼饹
    msgqueue::putmsg(om_om msg)   塼
    msgqueue::getmsg(om_om &msg)  塼Ф
*********************************************************************/

#ifndef MSGQUEUE_H
#define MSGQUEUE_H

#include <string.h>
#include <pthread.h>
#include "protocol.h"

class msgbox
{
friend class msgqueue;
  private:
    msgbox*	next;
    om_om 	message;
    int 	ipu_no;

    msgbox(om_om msg, int ipu)
    {
	message = msg;
	ipu_no = ipu;
	next = NULL;
    };
};

class msgqueue
{
  private:
    msgbox*		head;
    msgbox*		tail;
    pthread_mutex_t	lock;
    pthread_cond_t	cond;

  public:
    msgqueue()
    {
	head = tail = NULL;
	pthread_mutex_init(&lock, NULL);
	pthread_cond_init(&cond, NULL);
    }
    void putmsg(om_om msg, int ipu)
    {
	pthread_mutex_lock(&lock);
	if (tail != NULL) {
	    tail = tail->next = new msgbox(msg, ipu);
	} else {
	    head = tail = new msgbox(msg, ipu);
	    pthread_cond_broadcast(&cond);
	}
	pthread_mutex_unlock(&lock);
    };
    void putmsg(om_om msg)
    {
	putmsg(msg, -1);
    }
    int	getmsg(om_om& msg)
    {
	int ipu;

	pthread_mutex_lock(&lock);
	while (head == NULL) {
	    pthread_cond_wait(&cond, &lock);
	}
	msg = head->message;
	ipu = head->ipu_no;
	if (head == tail) {
	    delete head;
	    head = NULL;
	    tail = NULL;
	} else {
	    msgbox* tmp = head;
	    head = head->next;
	    delete tmp;
	}
	pthread_mutex_unlock(&lock);
	return ipu;
    };
};

#endif /* MSGQUEUE_H */
