/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  schedule.cc
    塼
*********************************************************************/

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stream.h>
#include <math.h>
#include <sys/time.h>
#include "vios.h"
#include "schedule.h"
#include "msgqueue.h"
#include "etc.h"
#include "ObjectList.h"
#include "ModuleList.h"
#include "IpuList.h"
#include "VarList.h"
#include "TaskData.h"
#include "etc.h"

       msgqueue		dsync_q;

extern IpuList		ip;
extern ModuleList	mo;
extern ObjectList	ob;
extern TaskData		td;
extern VarList		va_array;

extern msgqueue		sche_q, send_q[64];

typedef struct task_list {
    task_list*	next;
    int		taskid;
} task_list;

static int outimg_create(int tid);

void
time_print(char* message)
{
#ifdef DEBUG
    timeval	t;
    int 	h,m,s,us;

    gettimeofday(&t, NULL);
    t.tv_sec += (9*3600); // JST-9, Ȥʤ٤Ĥ -9 ʤƤ⤤
                          //  -9 ȷᤦƤΤ⤪
                          // timezone Ĵ٤ΤɤΤ
    h  = (t.tv_sec % 86400)/3600;
    m  = (t.tv_sec % 3600) / 60;
    s  = t.tv_sec % 60;
    us = t.tv_usec;

    fprintf(stdout, "** %s at %02d:%02d.%02d %06d\n", message, h,m,s,us);
#else
    (void)message;
#endif
}

// ʬ̿ IPU 
// δؿ64ޤǤʬͤƤʤIPUդ䤻ʤ
static int
obj_split(int tid, int n)
// tid:  ID
// n:   Υ ID βֹ
{
    char*	mod_name = td.get_module_name(tid);
    div_type	d_type;
    int 	cache;
    int		rtype;
    int 	n_ip1s = ip.get_total_ip1_num();

    d_type = mo.get_in_divide_type(mod_name, n);
    cache  = mo.get_in_cache(mod_name, n);
    rtype  = mo.get_rtype(mod_name);

    if (d_type == dt_all && cache == 0) {
	td.set_inimg_state(tid, n, ss_split_done);
	return OKAY;
    }

    char prog[1024];
    int i;
    int imgid = td.get_inimg_id(tid, n);
    sprintf(prog, "%d %d idtoimage ", imgid, -1);
    for (i = 0; i < n_ip1s; i++) {
	sprintf(prog, "%s%d %d newidimage ", prog, imgid, i);
    }

    switch (d_type) {
      case dt_row:	// (row)
	sprintf(prog, "%s1 1 %d 1 %d %d split\n",
		prog, n_ip1s, cache, d_type);
	break;
      case dt_column:	//Ĺ (column)
	sprintf(prog, "%s%d 1 1 1 %d %d split\n",
		prog, n_ip1s, cache, dt_column);
	break;
      case dt_pixel:
      case dt_box:
	int bwidth, bheight, n_x, n_y;
	if (d_type == dt_box) {
	    if (mo.get_in_box_size(mod_name, n, &bwidth, &bheight) == FAIL) {
		fprintf(stderr, "obj_split: box error\n");
		return FAIL;
	    }
	} else {
	    bwidth = bheight = 1;
	}
	if (rtype == 1) { // Ĳʬ
	    if (n_ip1s < 4 || (n_ip1s % 2) != 0) {
		n_x = 1;
		n_y = n_ip1s;
	    } else if (n_ip1s < 16 || (n_ip1s % 4) != 0) {
		n_x = 2;
		n_y = n_ip1s / 2;
	    } else if (n_ip1s < 64 || (n_ip1s % 8) != 0) {
		n_x = 4;
		n_y = n_ip1s / 4;
	    } else {
		n_x = 8;
		n_y = n_ip1s / 8;
	    }
	} else if (rtype == 2) { // ʬ (row Ʊ)
	    n_x = 1;
	    n_y = n_ip1s;
	} else { // ʬ (column Ʊ)
	    n_x = n_ip1s;
	    n_y = 1;
	}

	sprintf(prog, "%s%d %d %d %d %d %d split\n",
		prog, n_x, bwidth, n_y, bheight, cache, d_type);
	break;
      default:
	fprintf(stderr, "obj_split: bad type %d\n", d_type);
	break;
    }

    om_om msg;
    msg.buf = strdup_new(prog);
    msg.to_ipu = new om_ipu;
    msg.to_ipu->type = p_oi_ipu_p;
    msg.to_ipu->size = strlen(prog);

#ifdef DEBUG
    fprintf(stderr, "split: %s", prog);
#endif

    // äƤ IPU ʬ̿
    int ipu_no;
    if (ob.get_part_image_host(imgid, -1, &ipu_no) != OKAY) {
	fprintf(stderr, "obj_split: get_part_image_host failed\n");
	return FAIL;
    }
    send_q[ipu_no].putmsg(msg);
    ip.add_ipu_load(ipu_no);

    ob.set_divide_type_exist(imgid, d_type, 1);

    return OKAY;
}

//  IPU ؼ¹̿
static int
outimg_create(int tid)
{
    char*	mod_name = td.get_module_name(tid);
    int 	in_num   = mo.get_in_num(mod_name);
    int 	out_num  = mo.get_out_num(mod_name);
    int 	prm_num  = mo.get_param_num(mod_name);
    int 	n_ip1s = ip.get_total_ip1_num();
    int 	ipu;
    int 	ip1;
    int 	i, j;
    int 	run_number;
    int 	div_flag;

#ifdef DEBUG
    fprintf(stderr, "********** outimg_create start **********\n");
#endif

    // ʬ¹Ԥ뤫ɤĴ٤

    div_flag = 0;
    for (i = 0; i < in_num; i++) {
	div_type d_type = td.get_in_divide_type(tid, i);
	if (d_type != dt_all) {
	    div_flag = 1;
	    break;
	}
    }
    for (i = 0; i < out_num; i++) {
	div_type d_type = td.get_out_divide_type(tid, i);
	if (d_type != dt_all) {
	    div_flag = 1;
	    break;
	}
    }

    if (div_flag == 0 || n_ip1s == 1) {
	// ʬ¹Ԥʤ
	run_number = 1;
	div_flag = 0;
    } else {
	// ʬ¹Ԥ
	run_number = n_ip1s;
    }

    // Ѱ

    ipu = 0;
    ip1 = 0;
    for (i = 0; i < run_number; i++) {
	char prog[1024];
	prog[0] = '\0';

	// ϲ

	for (j = 0; j < in_num; j++) {
	    int div_id;
	    int image_id = td.get_inimg_id(tid, j);
	    int image_ipu; // äƤ IPU ֹ
	    div_type d_type = td.get_in_divide_type(tid, j);

	    if (d_type != dt_all) {
		// ʬȤ
		div_id = i;
	    } else {
		// Ȥ
		div_id = -1;
	    }

	    // βäƤ IPU Ĵ٤
	    if (ob.get_part_image_host(image_id, div_id, &image_ipu) != OKAY) {
		return FAIL;
	    }
	    if (ipu == image_ipu) {
		// Τޤ
		sprintf(prog, "%s%d %d idtoimage ", prog, image_id, div_id);
	    } else {
		// ž
		sprintf(prog, "%s%d %d %d transimage ",
			prog, image_id, div_id, image_ipu);
	    }
	}

	// ϲ

	for (j = 0; j < out_num; j++) {
	    int image_id = td.get_outimg_id(tid, j);
	    div_type d_type = td.get_out_divide_type(tid, j);
	    int div_id;
	    if (d_type != dt_all) {
		// ʬȤ
		div_id = i;
	    } else {
		// Ȥ
		div_id = -1;
	    }
	    if (strcmp(mod_name, "load") == 0 ||
		strcmp(mod_name, "cload") == 0)
	    {
		sprintf(prog, "%s%d %d idtoimage ", prog, image_id, div_id);
	    } else {
		sprintf(prog, "%s%d %d newidimage ", prog, image_id, div_id);
	    }
	}

	// ѥ᡼

	for (j = 0; j < prm_num; j++) {
	    char* str_param = td.get_string_param(tid);
	    if (str_param != NULL) {
		// load  save
		sprintf(prog, "%s(%s) ", prog, str_param);
	    } else {
		// ǡäƤ IPU
		int param_id = td.get_param_id(tid, j);
		int param_ipu = va_array.get_ipu_no(param_id);
		if (ipu == param_ipu) {
		    // ǡäƤ IPU Ʊ IPU ξ
		    sprintf(prog, "%s%d -1 idtoarray %d %d subarray ", prog,
			    param_id, i, n_ip1s);
		} else {
		    // 㤦 IPU ξ硢ž̿
		    sprintf(prog, "%s%d %d %d transarray ", prog,
			    param_id, i, param_ipu);
		}
	    }
	}

	// taskid ip1ֹ̤ /⥸塼̾ dexec

	sprintf(prog, "%s%d %d /%s dexec\n", prog, tid, i, mod_name);

#ifdef DEBUG
	fprintf(stderr, "outimg_create: to IPU %d, %s", ipu, prog);
#endif

	om_om msg;
	msg.buf = strdup_new(prog);
	msg.to_ipu = new om_ipu;
	msg.to_ipu->size = strlen(prog);
	msg.to_ipu->type = p_oi_ipu_p;

	send_q[ipu].putmsg(msg);

	ip.add_ipu_load(ipu);

	ip1++;
	if (ip1 >= ip.get_ip1_num(ipu)) {
	    ip1 = 0;
	    ipu++;
	}
    }

    td.set_task_state(tid, ts_executing);
    td.set_running_number(tid, run_number);

    // ž ob Ͽ
    ipu = 0;
    ip1 = 0;
    for (i = 0; i < run_number; i++) {
	for (j = 0; j < in_num; j++) {
	    int div_id;
	    int image_id = td.get_inimg_id(tid, j);
	    int image_ipu; // äƤ IPU ֹ
	    div_type d_type = td.get_in_divide_type(tid, j);

	    if (div_flag && d_type != dt_all) {
		// ʬȤ
		div_id = i;
	    } else {
		// Ȥ
		div_id = -1;
	    }

	    // βäƤ IPU Ĵ٤
	    if (ob.get_part_image_host(image_id, div_id, &image_ipu) != OKAY) {
		return FAIL;
	    }
	    if (ipu != image_ipu) {
		// žΤɲ
		ob.append(image_id, div_id, ipu);
	    }
	}

	ip1++;
	if (ip1 >= ip.get_ip1_num(ipu)) {
	    ip1 = 0;
	    ipu++;
	}
    }

    return OKAY;
}

// image_id β1Ĥ礹
static int
obj_join(int image_id)
{
    div_type dt;
    int ip1n = ip.get_total_ip1_num();

    if (ob.get_divide_type_exist(image_id, dt_row) == 2) {
	dt = dt_row;
    } else if (ob.get_divide_type_exist(image_id, dt_column) == 2) {
	dt = dt_column;
    } else if (ob.get_divide_type_exist(image_id, dt_pixel) == 2) {
	dt = dt_pixel;
    } else if (ob.get_divide_type_exist(image_id, dt_box) == 2) {
	dt = dt_box;
    } else {
	//fprintf(stderr, "obj_join: no dt type exist\n");
	return FAIL;
    }

    int i;
    int ipu_no;
    char prog[1024];
    prog[0] = '\0';
    for (i = 0; i < ip1n; i++) {
	if (ob.get_part_image_host(image_id, dt, i, &ipu_no) == FAIL) {
	    fprintf(stderr, "obj_join: get_part_image_host failed\n");
	    return FAIL;
	}
	if (ipu_no == 0) {
	    sprintf(prog, "%s%d %d idtoimage ", prog, image_id, i);
	} else {
	    sprintf(prog, "%s%d %d %d transimage ", prog, image_id, i, ipu_no);
	}
    }
    sprintf(prog, "%s%d -1 newidimage %d join\n", prog, image_id, ip1n);

    om_om msg;
    msg.buf = strdup_new(prog);
    msg.to_ipu = new om_ipu;
    msg.to_ipu->size = strlen(prog);
    msg.to_ipu->type = p_oi_ipu_p;
    send_q[0].putmsg(msg);

#ifdef DEBUG
    fprintf(stderr, "obj_join: image_id %d  set_d_t_e  1 ˤޤ\n",
	    image_id);
#endif
    ob.set_divide_type_exist(image_id, dt_all, 1);

    return OKAY;
}

#define jobid_to_ip1no(j)		((j) / 10000)
#define jobid_to_taskid(j)		((j) % 10000)
#define taskid_ip1no_to_jobid(t,i)	\
	(((t >= 10000) && taskid_error()), (i)*10000 + (t))
#include <stdlib.h>
static int
taskid_error()
{
    (void)taskid_error;
    fprintf(stderr, "task id overflow\n");
    abort();
    return 0;
}

static void
report_time(int tid)
{
    time_print("task done");
    struct timeval* start_time;
    struct timeval  end_time;
    int sdif, udif;
    gettimeofday(&end_time, NULL);
    start_time = td.get_start_time(tid);
    udif = end_time.tv_usec - start_time->tv_usec;
    sdif = end_time.tv_sec  - start_time->tv_sec;
    if (udif < 0) {
	udif += 1000000;
	sdif--;
    }
#ifdef DEBUG
    fprintf(stderr, "task %d: %2d sec, %6d usec\n", tid, sdif, udif);
#endif

    om_om msg;
    msg.to_vpe = new om_vpe;
    msg.to_vpe->type = p_ov_module_done;
    msg.to_vpe->size = 16;
    msg.buf = new char[16];
    setint(msg.buf,    -1);
    setint(msg.buf+4,  tid);
    setint(msg.buf+8,  sdif);
    setint(msg.buf+12, udif);
    extern msgqueue vpe_send_q;
    vpe_send_q.putmsg(msg);
}

// 塼饹åɤΥȴؿ
void
scheduler()
{
#ifdef DEBUG
    fprintf(stderr, "### Thread for scheduler\n");
#endif

    task_list tl;
    tl.next = NULL;
    task_list* l;
    task_list* tl_bottom = &tl;
    task_list* prev;

    om_om	msg;

    int w_tmp = 0;
    int h_tmp = 0;
    int comq_flag = 1;

    for (;;) {
	sche_q.getmsg(msg);

	if (msg.done->type == p_io_quit) {
	    delete msg.done;
	    break;
	}

	if (msg.done->type == p_io_mod_exec ||
	    msg.done->type == p_io_wait_array)
	{
	    int tid;
	    if (msg.done->type == p_io_mod_exec) {
		// ip0 Υ⥸塼¹׵
		// ꥹȤɲä
		// mes.buf ˤϡ "0 1 2 Add" Τ褦ʤΤäƤ
		tid = td.add_entry(msg.buf);
		delete[] msg.buf;
	    } else {
		char buf[256];
		sprintf(buf, "%d waitarray", msg.a_info->array_id);
		delete msg.a_info;
		tid = td.add_entry(buf);
	    }
	    if (tid < 0) {
		fprintf(stderr, "scheduler: td.add_entry failed\n");
	    } else {
		// ɲ
		// ǽˤǤȤǤ
		// ʤ褦˥ꥹȤĤ
		// (μ¹Խ֤δطꥹΤΤ¹ԤƤ)
		task_list* new_task = new task_list;
		new_task->taskid = tid;
		new_task->next = tl_bottom->next;
		tl_bottom->next = new_task;
		tl_bottom = new_task;
#ifdef DEBUG
		td.print(tid);
#endif
	    }
	} else if (msg.done->type == p_io_module) {
	    // ¹Ԥä (1Ĥ ip1 )
	    int done_job_id = msg.o_info->job_id;
	    delete[] msg.o_info;

	    if (done_job_id >= 0) { // ꥹȤϿƤ륿
		int task_id = jobid_to_taskid(done_job_id);
		int out_n = td.get_outimg_number(task_id);
		int i, img_id;
		for (i = 0; i < out_n; i++) {
		    img_id = td.get_outimg_id(task_id, i);
		    ob.decr_wait_count(img_id);
		}
		td.decr_running_number(task_id);
		// ¹Ԥä ( ip1) 
		fprintf(stderr, "¹Ԥä衣\n");

		//
		for (prev = &tl, l = tl.next; l != NULL; prev = l, l=l->next) {
		    int tid = l->taskid;
		    if (td.get_task_state(tid) == ts_executing &&
			td.get_running_number(tid) == 0)
		    {
			// ¹Ԥä
			report_time(tid);
#ifdef DEBUG
			fprintf(stderr, "¹Ԥޤ! tid:%d\n", tid);
#endif
			// 񤤤Ƥ¸߾֤򥻥åȤ
			for (i = 0; i < out_n; i++) {
			    img_id = td.get_outimg_id(task_id, i);
			    div_type d_type;
			    d_type = td.get_out_divide_type(task_id, i);
			    ob.set_divide_type_exist(img_id, d_type, 2);
			}
			// 
			td.remove(tid);
			if (tl_bottom == l) {
			    tl_bottom = prev;
			}
			prev->next = l->next;
			l->next = NULL;
			delete l;
			l = prev;
		    }
		}
	    }
	}

	// ꥹȤå
	for (prev = &tl, l = tl.next; l != NULL; prev = l, l = l->next) {
	    int tid = l->taskid;

	    // ϲå

	    task_stat_t ts;
	    ts = td.get_task_state(tid);

	    if (ts != ts_executing) {
		  for (int i = 0; i < td.get_inimg_number(tid); i++) {
		    split_stat_t ss;
		    ss = td.get_inimg_state(tid, i);
		    if (ss == ss_need_join) {
			int img_id = td.get_inimg_id(tid, i);
			obj_join(img_id);
		    } else if (ss == ss_need_split) {
			if (obj_split(tid, i) == FAIL) {
			    fprintf(stderr, "scheduler: obj_split failed\n");
			}
		    }
		}
	    }

	    ts = td.get_task_state(tid);
	    if (ts == ts_executable) {
#ifdef DEBUG
		fprintf(stderr, "tid %d (%s) ϼ¹Բǽˤʤޤ!\n",
			tid, td.get_module_name(tid));
#endif
		// Ѱդ¹
		char* mod_name = td.get_module_name(tid);
		if (strcmp(mod_name, "waitarray") == 0) {
		    msg.to_ipu = new om_ipu;
		    msg.to_ipu->type = p_oi_wait_array_done;
		    msg.to_ipu->size = 0;
		    send_q[0].putmsg(msg);

		    // 
		    td.remove(tid);
		    if (tl_bottom == l) {
			tl_bottom = prev;
		    }
		    prev->next = l->next;
		    l->next = NULL;
		    delete l;
		    l = prev;

		} else {
		  outimg_create(tid);
		}
	      } else if (ts == ts_not_ready) {
#ifdef DEBUG
		fprintf(stderr, "tid %d (%s) ϼ¹ԲǽǤϤޤ\n",
			tid, td.get_module_name(tid));
#endif
	    } else if (ts == ts_executing) {
#ifdef DEBUG
		fprintf(stderr, "tid %d (%s) ϼ¹Ǥ\n",
			tid, td.get_module_name(tid));
#endif
	    }
	}

	delete msg.done;
    }

    // 塼齪λ
    // 򤹤

    task_list *l1, *l2;
    l1 = tl.next;
    while (l1 != NULL) {
	td.remove(l1->taskid);
	l2 = l1;
	l1 = l1->next;
	delete l2;
    }
}
