/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  sync_cache.cc
*********************************************************************/

#include <stdio.h>
#include "sync_cache.h"
#include "msgqueue.h"
#include "ObjectList.h"
#include "TaskData.h"
#include "IpuList.h"
#include "ModuleList.h"

extern msgqueue send_q[];
extern ObjectList ob;
extern TaskData   td;
extern IpuList    ip;
extern ModuleList mo;

static void sync_cache_done_send(int ipu_no, int task_id, int image_id);
static void trans_cache(int image_id, div_type dt, int div_id, int task_id,
			int to_ipu_no, int x, int y, int w, int h);

// sync_cache ΤԤäƤꥹ

class sync_cache_list {
  private:
    sync_cache_list* next;
    int task_id;
    int image_id;
    int ipu_no;   // sync_cache Ԥä IPU ( IPU  done ֤)
    int left;     // ȤĻĤäƤ뤫

    //  ID ΥΡɤ1ΥΡɤ֤ ()
    sync_cache_list* prev_search(int tid, int iid) {
	sync_cache_list* p;
	for (p = this; p->next != NULL; p = p->next) {
	    if (p->next->task_id == tid && p->next->image_id == iid) {
		return p;
	    }
	}
	return NULL;
    };
    //  ID ΥΡɤ֤
    sync_cache_list* search(int tid, int iid) {
	sync_cache_list* p = prev_search(tid, iid);
	if (p != NULL) return p->next;
	return NULL;
    };

    // ΥΡɤˤĤ sync_cache äĴ٤
    // äʤ IPU إå
    void check(sync_cache_list* p)
    {
	if (p->left > 0) {
	    // ޤäƤʤ
	    return;
	}
	// sync_cache ä

	sync_cache_done_send(p->ipu_no, p->task_id, p->image_id);

	// ꥹȤ
	sync_cache_list* prev = prev_search(p->task_id, p->image_id);
	if (prev == NULL) {
	    fprintf(stderr, "sync_cache_list::check: prev NULL\n");
	    return;
	}
	prev->next = p->next;
	p->next = NULL;
	delete p;
    };

  public:
    sync_cache_list() {
	next = NULL;
    };
    ~sync_cache_list() {
	delete next;
    };

    // ԤǤ򿷵
    void create(int tid, int iid, int i_no) {
	sync_cache_list* newnode = new sync_cache_list;
	newnode->task_id  = tid;
	newnode->image_id = iid;
	newnode->ipu_no   = i_no;
	newnode->left     = 0;
	newnode->next     = next;
	next = newnode;
    };

    // sync_cache ʤФʤʤ1䤹
    void inc(int tid, int iid) {
	sync_cache_list* p = search(tid, iid);
	if (p == NULL) {
	    fprintf(stderr, "sync_cache_list::inc: node not found\n");
	    return;
	}
	p->left++;
    };

    // sync_cache 1Ľä
    // äΥåԤ
    void dec(int tid, int iid) {
	sync_cache_list* p = search(tid, iid);
	if (p == NULL) {
	    fprintf(stderr, "sync_cache_list::dec: node not found\n");
	    return;
	}
	p->left--;
	check(p);
    };

    // dec ˥åԤ
    void check(int tid, int iid) {
	sync_cache_list* p = search(tid, iid);
	if (p == NULL) {
	    fprintf(stderr, "sync_cache_list::check: node not found\n");
	    return;
	}
	check(p);
    };
};

static sync_cache_list sc_list;

// IPU  cache () 򹹿褦׵᤬褿
// βΤ٤Ƥʬ cache ʬ򹹿褦 IPU 
// ž򤵤
void
sync_cache(int ipu_no, om_om& msg)
{
    int task_id  = msg.sc_info->task_id;
    int image_id = msg.sc_info->image_id;
    delete msg.sc_info;
    int n_ip1s = ip.get_total_ip1_num();

    // ꥹȤɲ
    sc_list.create(task_id, image_id, ipu_no);

    // ʬñ̤Ĵ٤
    int i;
    int in_n = td.get_inimg_number(task_id);
    int out_n = td.get_inimg_number(task_id);
    div_type dt;
    for (i = 0; i < in_n; i++) {
	if (td.get_inimg_id(task_id, i) == image_id) {
	    dt = td.get_in_divide_type(task_id, i);
	    break;
	}
    }
    if (i == in_n) {
	for (i = 0; i < out_n; i++) {
	    if (td.get_outimg_id(task_id, i) == image_id) {
		dt = td.get_out_divide_type(task_id, i);
		break;
	    }
	}
	if (i == out_n) {
	    fprintf(stderr, "sync_cache: image not found\n");
	    goto end;
	}
    }
    if (n_ip1s == 1) {
	dt = dt_all;
    }

    // cache 礭Ĵ٤
    int cache;
    int div_id;
    if (dt == dt_all) {
	div_id = -1;
    } else {
	div_id = 0;
    }
    if (ob.get_image_cache(image_id, dt, div_id, &cache) != OKAY) {
	fprintf(stderr, "sync_cache: get_image_cache failed\n");
	goto end;
    }

    if (n_ip1s == 1 || cache == 0) {
	// λ
	goto end;
    }

    // 礭Ĵ٤
    int org_w, org_h;
    if (ob.get_image_size(image_id, dt_all, -1, &org_w, &org_h) != OKAY) {
	fprintf(stderr, "sync_cache: get_image_size(org) failed\n");
	goto end;
    }

    // pixelbox ξʬˡĴ٤
    // 1:Ĳ2: (row Ʊ)3: (column Ʊ)
    int rtype;
    switch (dt) {
      case dt_row:
	rtype = 2; break;
      case dt_column:
	rtype = 3; break;
      case dt_pixel:
      case dt_box:
	char* module_name;
	module_name = td.get_module_name(task_id);
	rtype = mo.get_rtype(module_name);
      case dt_all:
	rtype = 1;
	break;
      default:
	fprintf(stderr, "sync_cache: bad d_type\n");
	goto end;
    }

    // ٤ƤʬˤĤƽԤ
    int w, h, hx, hy;

    for (i = 0; i < n_ip1s; i++) {
	div_id = i;
	int to_ipu;
	if (ob.get_image_size(image_id, dt, div_id, &w, &h) != OKAY) {
	    fprintf(stderr, "sync_cache: get_image_size failed\n");
	    return;
	}
	if (ob.get_image_hot(image_id, dt, div_id, &hx, &hy) != OKAY) {
	    fprintf(stderr, "sync_cache: get_image_hot failed\n");
	    return;
	}
	if (ob.get_part_image_host(image_id, dt, div_id, &to_ipu) != OKAY) {
	    fprintf(stderr, "sync_cache: get_part_image_host failed\n");
	    return;
	}
	int ca = cache;
	int i_id = image_id;
	int tid  = task_id;
	if (rtype == 1) {
	    // Ĳ

	    // 
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx-ca, hy-ca, ca, ca);
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx,    hy-ca, w,  ca);
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx+w,  hy-ca, ca, ca);

	    // 
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx-ca, hy,    ca, h );
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx+w,  hy,    ca, h );

	    // 
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx-ca, hy+h,  ca, ca);
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx,    hy+h,  w,  ca);
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx+w,  hy+h,  ca, ca);

	} else if (rtype == 2) {
	    // 
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx,    hy-ca, w,  ca);
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx,    hy+h,  w,  ca);
	} else {
	    // 
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx-ca, hy,    ca, w);
	    trans_cache(i_id, dt, div_id, tid, to_ipu, hx+w,  hy,    ca, w);
	}
    }

    // λ
  end:
    sc_list.check(task_id, image_id);
}

// åž
static void
trans_cache(int image_id, div_type dt, int to_div_id,
	    int task_id, int to_ipu_no, int x, int y, int w, int h)
// ɸкɸ
{
    int from_ipu_no;
    int from_div_id;

    if (ob.get_part_image_host(image_id, dt, x, y,
			       &from_ipu_no, &from_div_id) != OKAY)
    {
	// Υå¸ߤʤ (ϤߤƤ) Τǲ⤷ʤ
	return;
    }
    // åäƤ IPU ž̿
    om_om msg;
    msg.to_ipu = new om_ipu;
    msg.to_ipu->type = p_oi_trans_image;
    msg.img_info = new image_info;
    msg.img_info->width     = w;
    msg.img_info->height    = h;
    msg.img_info->hot_x     = x;
    msg.img_info->hot_y     = y;
    msg.img_info->image_id  = image_id;
    msg.img_info->div_id    = from_div_id;
    msg.img_info->div_type  = task_id;    // 
    msg.img_info->job_id    = to_ipu_no;  //
    msg.img_info->image_no  = to_div_id;  //
    send_q[from_ipu_no].putmsg(msg);
    sc_list.inc(task_id, image_id);
}

static void
sync_cache_done_send(int ipu_no, int task_id, int image_id)
{
    om_om msg;
    msg.to_ipu = new om_ipu;
    msg.to_ipu->type = p_oi_sync_cache_done;
    msg.sc_info = new sync_cache_info;
    msg.sc_info->task_id  = task_id;
    msg.sc_info->image_id = image_id;
    send_q[ipu_no].putmsg(msg);
}

// 1Ľä

void
sync_cache_done(int task_id, int image_id)
{
    sc_list.dec(task_id, image_id);
}
