/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  gencode.c
    
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "transdefs.h"
#include "tree.h"

static int global_var_count; /* ⥸塼ǤΥХѿο */
char *foreach_varname;
static int usercom_flag;

/** ץ **/

void
gen_programhead(void)
{
    gen_outf("/*\n"); /**/
    gen_outf("** generated by VPE-p Translator\n");
    gen_outf("*/\n\n");
    gen_outf("#include \"dmodinc.h\"\n\n");
}

/** module **/

void
gen_modulehead(char *name)
{
    gen_indent();
    gen_outf("int VIOS_module_%s_body(stack* pp, const int jobid)\n", name);
    gen_LC();

    global_var_count = 0;
    usercom_flag = 0;
}

char *
type2string(int type)
{
    switch (type) {
      case tp_void:		return "void";
      case tp_char:		return "char";
      case tp_int:		return "int";
      case tp_float:		return "float";
      case tp_complex:		return "complex";
    }
    return NULL;
}


static void
gen_paramdecl(Tree *tr, int mode) /* mode: 0 or 1 */
{
    if (tr->ch1 == NULL) {
	if (mode == 0)
	    gen_outf("(*%s)", tr->node.string);
	else
	    gen_outf("(*)");
    } else {
	gen_paramdecl(tr->ch1, mode);
	gen_outf("[");
	gen_exp(tr->ch2);
	gen_outf("]");
    }
}

static int gen_moduleparam2(Tree *param);

void
gen_moduleparam(Tree *param)
{
    Tree *list;
    int  list_num;
    Tree *list_top;
    Tree *type;
    char *name;
    char buf[256];
    int  i, j, k;
    int  input_num = 0; /* ϲο */
    char* paraname;
    char* paraname2;

    for (i = 2; i >= 0; i--) {
	list = (i == 0) ? param->ch1 : ((i == 1) ? param->ch2 : param->ch3);
	/* ꥹȤ餿ɤ ( IPU-p å˵սäƤ) */
	/* for (; list != NULL; list = list->ch1) εդΥ᡼ */
	list_top = list;
	for (list_num = 0; list != NULL; list = list->ch1, list_num++) ;
	if (i == 0) input_num = list_num;
	for (j = list_num-1; j >= 0; j--) {
	    for (k = 0, list = list_top; k < j; k++, list = list->ch1) ;
	    name = list->node.string;
	    if ((type = search_declarations(name)) == NULL) {
		sprintf(buf, "`%s' is not declared\n", name);
		continue;
	    }
	    if (type->node.type.isimage) {
		/* Imageʤ */
		gen_indent();
		gen_outf("Image* VIOS_image_%s;\n", name);
		gen_indent();
		gen_outf("pp->pop(VIOS_image_%s);\n", name);
	    } else {
		/* ѿʤ */
		gen_indent();
		gen_outf("array* VIOS_Global_%s;\n", name);
		gen_indent();
		gen_outf("pp->pop(VIOS_Global_%s);\n", name);
	    }
	}
    }

    /* ϲ礭 */
    for (list = param->ch2; list != NULL; list = list->ch1) {
	char *otypename;
	char *wname, *hname;
	name = list->node.string;
	if ((type = search_declarations(name)) == NULL) {
	    continue;
	}
	switch (type->node.type.primary) {
	  case tp_int:     otypename = "pt_int";     break;
	  case tp_float:   otypename = "pt_real";    break;
	  case tp_complex: otypename = "pt_complex"; break;
	  default:         otypename = "pt_int";
	    trans_internal_error("gen_moduleparam: unknown type");
	}
	gen_indent();
	gen_outf("VIOS_image_%s->setparam(", name);
	wname = get_input_image_name(0);
	hname = get_input_image_name(0);
	for (i = 0; i < input_num; i++) {
	    char *iname;
	    Tree *itype;
	    int  div_type;
	    iname = get_input_image_name(i);
	    if (iname == NULL) continue;
	    itype = search_declarations(iname);
	    if (itype == NULL) continue;
	    div_type = itype->ch2->ch1->node.ival;
	    if (div_type == dv_pixel || div_type == dv_box) {
		wname = hname = iname;
	    } else if (div_type == dv_column) {
		wname = iname;
	    } else if (div_type == dv_row) {
		hname = iname;
	    }
	}
	if (wname != NULL && hname != NULL) {
	    gen_outf("VIOS_image_%s->get_width(), ",  wname);
	    gen_outf("VIOS_image_%s->get_height(), ", hname);
	    gen_outf("VIOS_image_%s->get_hot_x(), ",  wname);
	    gen_outf("VIOS_image_%s->get_hot_y(), ",  hname);
	    gen_outf("%s, 0);\n", otypename);
	} else {
	    gen_outf("512, 512, 0, 0, %s, 0);\n", otypename);
	}
	/* ʬ礭 */
	gen_indent();
	gen_outf("VIOS_image_%s->setorgsize(", name);
	if (wname != NULL && hname != NULL) {
	    gen_outf("VIOS_image_%s->get_org_width(), ",  wname);
	    gen_outf("VIOS_image_%s->get_org_height());\n", hname);
	} else {
	    gen_outf("512, 512);\n");
	}
    }

    gen_outf("\n");
    gen_moduleparam2(param);

    paraname = get_output_image_name(0);
    if (paraname == NULL) paraname = get_input_image_name(0);
    if (paraname != NULL) {
	/* ϲϸ߻ȤʤΤϲȤ */
	paraname2 = get_input_image_name(0);
	if (paraname2 != NULL) {
	    gen_indent();
	    gen_outf("usercom com(jobid, ");
	    gen_outf("VIOS_image_%s->get_image_id(), ", paraname2);
	    gen_outf("VIOS_image_%s->get_hot_x(), ",    paraname);
	    gen_outf("VIOS_image_%s->get_hot_y(), ",    paraname);
	    gen_outf("VIOS_image_%s->get_width(), ",    paraname);
	    gen_outf("VIOS_image_%s->get_height());\n", paraname);
	    usercom_flag = 1;
	}
    }
}

static int
gen_moduleparam2(Tree *param)
{
    Tree *list;
    Tree *type;
    char *name;
    char *type_name;
    int  i;

    for (i = 0; i < 3; i++) {
	list = (i == 0) ? param->ch1 : ((i == 1) ? param->ch2 : param->ch3);
	for (; list != NULL; list = list->ch1) {
	    name = list->node.string;
	    if ((type = search_declarations(name)) == NULL) {
		continue;
	    }
	    type_name = type2string(type->node.type.primary);
	    if (type->node.type.isimage) {
		/* Image ʤ */
		gen_indent();
		gen_outf("%s* %s = (%s*)VIOS_image_%s->get_image();\n",
			 type_name, name, type_name, name);
	    } else {
		/* ѿʤ */
		/* ̾ (int ʤ) */
		gen_indent();
		gen_outf("%s ", type2string(type->node.type.primary));
		gen_paramdecl(type->ch1->ch1, 0);
		gen_outf(" = ");
		/* 㥹 (int (*)[]...ʤ) */
		gen_outf("(%s ", type2string(type->node.type.primary));
		gen_paramdecl(type->ch1->ch1, 1);
		gen_outf(")");
		gen_outf("VIOS_Global_%s->get_ptr();\n", name);
	    }
	}
    }
    gen_outf("\n");
    return 0;
}

static int gen_parallel_func(void);

void
gen_moduletail(char *name)
{
    gen_indent();
    gen_outf("return OKAY;\n");
    gen_RC();
    gen_outf("\n");

    gen_parallel_func();

    gen_indent();
    gen_outf("extern \"C\" {\n");

    gen_indent();
    gen_outf("int VIOS_module_%s(stack *pp, int jobid)\n", name);
    gen_LC();
    gen_indent();
    gen_outf("return VIOS_module_%s_body(pp, jobid);\n", name);
    gen_RC();

    gen_indent();
    gen_outf("}\n\n");
}

/**** global declarations ****/

/* ⥸塼äƤ餽1 */

static void gen_global_decl1_sub1(Tree *decls);
static Tree *global_decls = NULL;

int
gen_global_decl1(Tree *decls_top)
{
    Tree *p, *decls;
    int  decls_count = 0;
    for (p = decls_top; p != NULL; p = p->ch2) {
	if (decls_count == 0) {
	    gen_indent();
	    gen_outf("// global variables\n");
	}
	decls = p->ch1;
	gen_global_decl1_sub1(decls);
	decls_count++;
    }
    if (decls_count > 0) {
	gen_outf("\n");
    }

    global_decls = decls_top;

    return 0;
}

static void
gen_global_decl1_sub1(Tree *decls)
{
    Tree *p1, *p2;
    char *name, *typename;
    int  i;

    typename = type2string(decls->ch1->node.type.primary);

    for (i = 0; i < 2; i++) {
	/* i == 0: Global , */
	/* i == 1:  */
	gen_indent();
	if (i == 0) {
	    gen_outf("array ");
	} else {
	    gen_outf("%s ", typename);
	}
	for (p1 = decls->ch2; p1 != NULL; p1 = p1->ch2) {
	    for (p2 = p1->ch1->ch1; p2->nodetype != nt_string; p2 = p2->ch1) ;
	    name = p2->node.string;
	    if (i == 0) {
		gen_outf("*VIOS_Global_%s", name);
	    } else {
		gen_paramdecl(p1->ch1->ch1, 0);
	    }
	    if (p1->ch2 != NULL) {
		gen_outf(", ");
	    }
	}
	gen_outf(";\n");
    }
}

/* ⥸塼äƤ餽2 */

static void gen_global_decl2_sub1(Tree *decls);
static void gen_global_decl2_sub2(int type, Tree *decl);

void
gen_global_decl2(Tree *decls_top)
{
    Tree *p, *decls;
    int  decls_count = 0;
    for (p = decls_top; p != NULL; p = p->ch2) {
	if (decls_count == 0) {
	    gen_indent();
	    gen_outf("// global variables\n");
	}
	decls = p->ch1;
	gen_global_decl2_sub1(decls);
	decls_count++;
    }
    if (decls_count > 0) {
	gen_indent();
	gen_outf("VIOS_sync(jobid);\n");
	gen_outf("\n");
    }
}

static void
gen_global_decl2_sub1(Tree *decls)
{
    Tree *tmp;
    char *tpname;

    /* Global  */
    for (tmp = decls->ch2; tmp != NULL; tmp = tmp->ch2) {
	gen_indent();
	gen_global_decl2_sub2(decls->ch1->node.ival, tmp->ch1->ch1);
	gen_outf(");\n");
    }

    /*  */
    tpname = type2string(decls->ch1->node.type.primary);
    for (tmp = decls->ch2; tmp != NULL; tmp = tmp->ch2) {
	Tree *l2;
	char *name;

	gen_indent();
	for (l2 = tmp->ch1->ch1; l2->nodetype != nt_string; l2 = l2->ch1);
	name = l2->node.string;
	gen_outf("%s = ", name);
	gen_outf("(%s ", tpname);
	gen_paramdecl(tmp->ch1->ch1, 1);
	gen_outf(")VIOS_Global_%s->get_ptr()", name);
	if (tmp->ch1->ch2 != NULL) {
	    trans_error("no init expressions");
	}
	gen_outf(";\n");
    }
}

static void
gen_global_decl2_sub2(int type, Tree *decl)
{
    char *tp;

    if (decl->nodetype == nt_string) {
	switch (type) {
	  case tp_int:     tp = "at_int"; break;
	  case tp_float:   tp = "at_real"; break;
	  case tp_complex: tp = "at_complex"; break;
	  default:	   tp = "at_null";
	    trans_internal_error("gen_global_decl: type is unknown");
	}
	gen_outf("VIOS_Global_%s = new array(jobid, %d, %s, 1",
		 decl->node.string, global_var_count++, tp);
    } else {
	/* ξ硢string ǤޤǺƵ */
	/* ˡ1Ѵ */
	gen_global_decl2_sub2(type, decl->ch1);
	gen_outf("*");
	gen_exp(decl->ch2);
    }
}

/* ⥸塼κǸ () */

static void gen_global_decl3_sub1(Tree *decls);

void
gen_global_decl3(Tree *decls_top)
{
    Tree *p, *decls;
    int  decls_count = 0;
    for (p = decls_top; p != NULL; p = p->ch2) {
	if (decls_count == 0) {
	    gen_outf("\n");
	    gen_indent();
	    gen_outf("// global variables\n");
	}
	decls = p->ch1;
	gen_global_decl3_sub1(decls);
	decls_count++;
    }
}

static void
gen_global_decl3_sub1(Tree *decls)
{
#if 0
    /*  VIOS_Global_xxx  AL ϿƤ */
    /* ξ AL β VIOS_Global_xxx ϲ */
    /*  VIOS_Global_xxx  AL  */
    /* ɬפ뤬 AL 륳ɤ */
    /* ޤ񤤤ƤʤΤǤǤ VIOS_Global_xxx ʤ */
    /* AL 륳ɤϽ񤯤ʤ餪餯 */
    Tree *p1, *p2;
    char *name;

    for (p1 = decls->ch2; p1 != NULL; p1 = p1->ch2) {
	gen_indent();
	for (p2 = p1->ch1->ch1; p2->nodetype != nt_string; p2 = p2->ch1) ;
	name = p2->node.string;
	gen_outf("delete VIOS_Global_%s;\n", name);
    }
#else
    (void)decls;
#endif
}

/**** local declarations ****/

static void
gen_local_decl_sub(Tree *decl)
{
    if (decl->nodetype == nt_string) {
	gen_outf("%s", decl->node.string);
    } else {
	/* ξ */
	gen_local_decl_sub(decl->ch1);
	gen_outf("[");
	gen_exp(decl->ch2);
	gen_outf("]");
    }
}

void
gen_local_declare(Tree *decls)
{
    Tree *tmp;

    gen_indent();
    switch (decls->ch1->node.ival) {
      case tp_char:    gen_outf("char "); break;
      case tp_int:     gen_outf("int "); break;
      case tp_float:   gen_outf("float "); break;
      case tp_complex: gen_outf("complex "); break;
    }
    for (tmp = decls->ch2; tmp != NULL; tmp = tmp->ch2) {
	gen_local_decl_sub(tmp->ch1->ch1);
	if (tmp->ch1->ch2 != NULL) {
	    gen_outf("=");
	    gen_exp(tmp->ch1->ch2);
	}
	if (tmp->ch2 != NULL)
	    gen_outf(", ");
    }
    gen_outf(";\n");
}

/* parallel */

void
gen_begin_parallel(void)
{
    int  i, j;
    char *loopvar;
    char *name;
    Tree *type;
    int  div_type;
    int  bw, bh;

    cache_gen_read_global_variable();

    gen_LC();

    loopvar = get_output_image_name(0);
    if (loopvar == NULL) {
	loopvar = get_input_image_name(0);
	if (loopvar == NULL) {
	    trans_error("need image\n");
	}
    }

    for (i = 0; i < 2; i++) {
	for (j = 0; ; j++) {
	    if (i == 0) {
		name = get_input_image_name(j);
	    } else {
		name = get_output_image_name(j);
	    }
	    if (name == NULL) break;
	    gen_indent();
	    gen_outf("int VIOS_image_%s_cache = VIOS_image_%s->get_cache();\n",
		     name, name);
	    gen_indent();
	    gen_outf("int VIOS_image_%s_width = VIOS_image_%s->get_width();\n",
		     name, name);
	    gen_indent();
	    gen_outf("int VIOS_image_%s_cwidth = VIOS_image_%s_width + VIOS_image_%s_cache * 2;\n", name, name, name);
	    gen_indent();
	    gen_outf("int VIOS_image_%s_height = VIOS_image_%s->get_height();\n",
		     name, name);
	}
    }

    if (loopvar == NULL) return;

    type = search_declarations(loopvar);
    if (type == NULL) {
	return;
    }
    div_type = type->ch2->ch1->node.ival;
    if (div_type == dv_box) {
	bw = type->ch2->ch1->ch1->node.ival;
	bh = type->ch2->ch1->ch2->node.ival;
    }

    if (!(div_type != dv_column && div_type != dv_all)) {
	gen_indent();
	gen_outf("int VIOS_parallel_y = 0;\n");
    }
    if (!(div_type != dv_row && div_type != dv_all)) {
	gen_indent();
	gen_outf("int VIOS_parallel_x = 0;\n");
    }
    if (div_type != dv_column && div_type != dv_all) {
	gen_indent();
	gen_outf("for (int VIOS_parallel_y = 0; ");
	gen_outf("VIOS_parallel_y < VIOS_image_%s_height; ", loopvar);
	gen_outf("VIOS_parallel_y");
	if (div_type == dv_pixel || div_type == dv_row) {
	    gen_outf("++");
	} else if (div_type == dv_box) {
	    gen_outf(" += %d", bh);
	} else {
	    trans_internal_error("gen_begin_parallel: unknown div-type %d",
				 div_type);
	}
	gen_outf(")\n");
    }

    if (div_type != dv_row && div_type != dv_all) {
	gen_indent();
	gen_outf("for (int VIOS_parallel_x = 0; ");
	gen_outf("VIOS_parallel_x < VIOS_image_%s_width; ", loopvar);
	gen_outf("VIOS_parallel_x");
	if (div_type == dv_pixel || div_type == dv_column) {
	    gen_outf("++");
	} else if (div_type == dv_box) {
	    gen_outf(" += %d", bw);
	} else {
	    trans_internal_error("gen_begin_parallel: unknown div-type %d",
				 div_type);
	}
	gen_outf(")\n");
    }

    gen_LC();

    if (usercom_flag) {
	gen_indent();
	gen_outf("com.set_cur(VIOS_parallel_x + VIOS_image_%s->get_hot_x(), ",
		 loopvar);
	gen_outf("VIOS_parallel_y + VIOS_image_%s->get_hot_y());\n", loopvar);
    }
}

void
gen_end_parallel(void)
{
    gen_RC();
    gen_RC();
    gen_indent();
    gen_outf("VIOS_sync(jobid);\n\n");
    cache_gen_unify_global_variable();
}

void
gen_begin_sequential(void)
{
    gen_indent();
    gen_outf("if (VIOS_ismain(jobid))\n");
    gen_LC();
    cache_gen_read_global_variable();
}

void
gen_end_sequential(void)
{
    cache_gen_write_global_variable();
    gen_RC();
}

/* foreach */
static int
gen_foreach_image(Tree *type)
{
    char buf[256];

    switch (type->ch2->ch1->node.ival) {
      case dv_pixel:
	trans_warning("foreach on pixel");
	break;
      case dv_row:
	gen_indent();
	gen_outf("for (int VIOS_foreach_x = 0;\n");
	gen_indent();
	gen_outf("         VIOS_foreach_x < VIOS_image_%s->get_width();\n",
		 foreach_varname);
	gen_indent();
	gen_outf("         VIOS_foreach_x++)\n");
	break;
      case dv_column:
	gen_indent();
	gen_outf("for (int VIOS_foreach_y = 0;\n");
	gen_indent();
	gen_outf("         VIOS_foreach_y < VIOS_image_%s->get_height();\n",
		 foreach_varname);
	gen_indent();
	gen_outf("         VIOS_foreach_y++)\n");
	break;
      case dv_box:
	gen_indent();
	gen_outf("for (int VIOS_foreach_x = 0;\n");
	gen_indent();
	gen_outf("         VIOS_foreach_x < %d;\n",
		type->ch2->ch1->ch1->node.ival);
	gen_indent();
	gen_outf("         VIOS_foreach_x++)\n");
	gen_indent();
	gen_outf("for (int VIOS_foreach_y = 0;\n");
	gen_indent();
	gen_outf("         VIOS_foreach_y < %d;\n",
		type->ch2->ch1->ch2->node.ival);
	gen_indent();
	gen_outf("         VIOS_foreach_y++)\n");
	break;
      case dv_all:
	gen_indent();
	gen_outf("for (int VIOS_foreach_x = 0;\n");
	gen_indent();
	gen_outf("         VIOS_foreach_y < VIOS_image_%s->get_width();\n",
		 foreach_varname);
	gen_indent();
	gen_outf("         VIOS_foreach_x++)\n");
	gen_indent();
	gen_outf("for (int VIOS_foreach_y = 0;\n");
	gen_indent();
	gen_outf("         VIOS_foreach_y < VIOS_image_%s->get_height();\n",
		 foreach_varname);
	gen_indent();
	gen_outf("         VIOS_foreach_y++)\n");
	break;
      default:
	sprintf(buf, "internal error: foreach-image: unknown div-type %d",
		type->ch2->ch1->node.ival);
	trans_error(buf);
	return 1;
    }
    return 0;
}

static void
gen_foreach_array(Tree *tp, int lv)
{
    if (tp->nodetype == nt_string)
	return;
    gen_foreach_array(tp->ch1, lv+1);
    gen_indent();
    gen_outf("for (int VIOS_foreach_i%d = 0;\n", lv);
    gen_indent();
    gen_outf("         VIOS_foreach_i%d < ", lv);
    gen_exp(tp->ch2);
    gen_outf(";\n");
    gen_indent();
    gen_outf("         VIOS_foreach_i%d++)\n", lv);
}

int
gen_foreachhead(char *varname)
{
    Tree *type;
    int ret = 0;
    char buf[256];

    if ((type = search_declarations(varname)) == NULL) {
	sprintf(buf, "`%s' is not declared\n", varname);
	trans_error(buf);
	return 1;
    }
    if (type->nodetype != nt_type) {
	trans_error("internal error: type's node-type is not nt_type!");
	return 1;
    }
    foreach_varname = varname;
    if (type->node.type.isimage) {
	gen_foreach_image(type);
    } else {
	gen_foreach_array(type->ch1->ch1, 0);
    }
    return ret;
}

int
gen_foreachtail(void)
{
    foreach_varname = NULL;
    return 0;
}

/** misc functions **/

static int unique_number;

int
get_unique_number(void) /* Ƥ֤Ӥ˥ˡʿ֤ */
{
    return unique_number++;
}

/**  **/

int
gen_init(void)
{
    foreach_varname = NULL;
    unique_number = 0;
    return 0;
}


/**********************************************************************/
/***************** NEW VERSION ****************************************/
/**********************************************************************/

static int gen_statements(Tree *tr, int para_flag);
static int gen_statement(Tree *tr, int para_flag);
static int gen_comp_st(Tree *tr, int para_flag);
static int gen_local_declares(Tree *tr);
static int gen_exp_st(Tree *tr);
static int gen_sub_st(Tree *tr, int para_flag);
static int gen_if_st(Tree *tr, int para_flag);
static int gen_switch_st(Tree *tr, int para_flag);
static int gen_for_st(Tree *tr, int para_flag);
static int gen_while_st(Tree *tr, int para_flag);
static int gen_do_while_st(Tree *tr, int para_flag);
static int gen_foreach_st(Tree *tr, int para_flag);
static int gen_goto_st(Tree *tr);
static int gen_continue_st(void);
static int gen_break_st(void);
static int gen_labeled_st(Tree *tr, int para_flag);
static int gen_return_st(Tree *tr);
static int gen_default_st(Tree *tr, int para_flag);
static int gen_case_st(Tree *tr, int para_flag);
static int gen_parallel_st(Tree *tr, int para_flag);

static char *module_name;
static Tree *module_param;
static int  parallel_id;

/* statement ˤ parallel θĿ֤ */
static int
check_parallel(Tree *st)
{
    switch (st->node.st) {
      case st_default:
	return check_parallel(st->ch1);
      case st_switch:
      case st_while:
      case st_do_while:
      case st_foreach:
      case st_labeled:
      case st_case:
	return check_parallel(st->ch2);
      case st_for:
	return check_parallel(st->ch2->ch2->ch2);
      case st_comp:
	{
	    /* ʸ1ĤĴ٤ */
	    Tree *st2;
	    int ret = 0;
	    for (st2 = st->ch2; st2 != NULL; st2 = st2->ch2) {
		ret += check_parallel(st2->ch1);
	    }
	    return ret;
	}
      case st_if:
	{
	    int ret;
	    /* if  */
	    ret = check_parallel(st->ch2->ch1);
	    /* else  */
	    if (st->ch2->ch2 != NULL) ret += check_parallel(st->ch2->ch2);
	    return ret;
	}
      case st_exp:
      case st_continue:
      case st_break:
      case st_return:
      case st_goto:
	return 0;
      case st_parallel:
	return 1;
      default:
	trans_internal_error("check parallel: unknown type");
	return 0;
    }
}

static void
gen_enter_simple_seq(void)
{
    gen_indent();
    gen_outf("// sequential begin\n");
    gen_begin_sequential();
}
static void
gen_leave_simple_seq(void)
{
    gen_end_sequential();
    gen_indent();
    gen_outf("// sequential end\n");
    gen_indent();
    gen_outf("VIOS_sync(jobid);\n");
}

static int gen_parallel_in(Tree *st, int start, int n);

/* ⥸塼 */
int
gen_module(char *mod_name, Tree *param, Tree *tr)
    /* tr ˤ statement ΥꥹȤäƤ */
{
    Tree *st;
    int ret = 0;
    int in_simple_seq = 0; /* ñ༡ˤ뤫ɤ */
    int n_paras = 0;
    int n;

    module_name = mod_name;
    module_param = param;
    parallel_id = 0;

    for (; tr != NULL; tr = tr->ch2) {
	st = tr->ch1; /* 1Ĥ statement */
	if (st->node.st == st_parallel) {
	    /*  */
	    if (in_simple_seq) {
		gen_leave_simple_seq();
		in_simple_seq = 0;
	    }
	    gen_indent();
	    gen_outf("// top parallel begin\n");
	    gen_LC();
	    ret += gen_statement(st, 1);
	    gen_RC();
	    gen_indent();
	    gen_outf("// top parallel end\n");
	} else if ((n = check_parallel(st)) > 0) {
	    /* Τۤ */
	    if (in_simple_seq) {
		gen_leave_simple_seq();
		in_simple_seq = 0;
	    }
	    ret += gen_parallel_in(st, n_paras, n);
	    n_paras += n;
	} else {
	    /* ʤ -> ñ༡ξ */
	    if (!in_simple_seq) {
		gen_enter_simple_seq();
		in_simple_seq = 1;
	    }
	    ret += gen_statement(st, 0);
	    in_simple_seq = 1;
	}
    }

    if (in_simple_seq) {
	gen_leave_simple_seq();
    }

    return ret;
}

static int gen_para_decl(int para_id, int define_flag);
static int gen_para_call(int para_id);


static int
gen_parallel_in(Tree *st, int start, int n)
{
    int i, ret;

    gen_indent();
    gen_outf("// in parallel begin\n");
    for (i = 0; i < n; i++) {
	gen_para_decl(start + i, 0);
    }
    gen_indent();
    gen_outf("if (VIOS_ismain(jobid))\n");
    gen_LC();
    ret = gen_statement(st, 0);
    gen_indent();
    gen_outf("VIOS_signal_para(jobid, -1);\n");
    gen_RC();
    gen_indent();
    gen_outf("else\n");
    gen_LC();
    gen_indent();
    gen_outf("int para_id;\n");
    gen_indent();
    gen_outf("while ((para_id = VIOS_wait_para(jobid)) >= 0)\n");
    gen_LC();
    gen_indent();
    gen_outf("switch (para_id)\n");
    gen_LC();
    for (i = 0; i < n; i++) {
	gen_indent();
	gen_outf("case %d: ", start + i);
	gen_para_call(start + i);
	gen_outf("; break;\n");
    }
    gen_RC();
    gen_RC();
    gen_RC();
    gen_indent();
    gen_outf("// in parallel end\n");
    return ret;
}

static int
gen_statements(Tree *tr, int para_flag)
{
    int ret = 0;
    if (tr == NULL) return 0;
    ret  = gen_statement(tr->ch1, para_flag);
    ret += gen_statements(tr->ch2, para_flag);
    return ret;
}

static int
gen_statement(Tree *tr, int para_flag)
{
    trans_lineno = tr->line_no;
    switch (tr->node.st) {
      case st_comp:       return gen_comp_st(tr, para_flag);
      case st_exp:        return gen_exp_st(tr);
      case st_if:         return gen_if_st(tr, para_flag);
      case st_switch:     return gen_switch_st(tr, para_flag);
      case st_for:        return gen_for_st(tr, para_flag);
      case st_while:      return gen_while_st(tr, para_flag);
      case st_do_while:   return gen_do_while_st(tr, para_flag);
      case st_foreach:    return gen_foreach_st(tr, para_flag);
      case st_goto:       return gen_goto_st(tr);
      case st_continue:   return gen_continue_st();
      case st_break:      return gen_break_st();
      case st_return:     return gen_return_st(tr);
      case st_labeled:    return gen_labeled_st(tr, para_flag);
      case st_case:       return gen_case_st(tr, para_flag);
      case st_default:    return gen_default_st(tr, para_flag);
      case st_parallel:   return gen_parallel_st(tr, para_flag);
      default:
	trans_internal_error("unknown statement type");
	return -1;
    }
}

static int
gen_comp_st(Tree *tr, int para_flag)
{
    int ret = 0;

    gen_LC();
    decl_levelup();
    ret  = gen_local_declares(tr->ch1);
    ret += gen_statements(tr->ch2, para_flag);
    decl_leveldown();
    gen_RC();

    return ret;
}

static int
gen_local_declares(Tree *tr)
{
    int ret;
    if (tr == NULL) return 0;
    ret  = local_declare(tr->ch1);
       gen_local_declare(tr->ch1);
    ret += gen_local_declares(tr->ch2);
    return ret;
}

static int
gen_exp_st(Tree *tr)
{
    int ret = 0;
    Tree *ex = tr->ch1;

    /* åɤ߹ߥɤ */
    if (ex != NULL) gen_read(ex);

    /* ʸ */
    gen_indent();
    if (ex != NULL) ret = gen_exp(ex);
    gen_outf(";\n");

    /* å񤭹ߥɤ */
    if (ex != NULL) gen_write(ex);

    return ret;
}

/* if  while ΤȤˤĤʸ */
/* ɬ { } ۤΤǤʤФǤĤ */
static int
gen_sub_st(Tree *tr, int para_flag)
{
    int ret;
    if (tr->node.st == st_comp) {
	ret = gen_statement(tr, para_flag);
    } else {
	gen_LC();
	ret = gen_statement(tr, para_flag);
	gen_RC();
    }
    return ret;
}

static int
gen_if_st(Tree *tr, int para_flag)
{
    int ret = 0;
    Tree *ex = tr->ch1;
    gen_indent();
    gen_outf("if (");
    if(ex != NULL) gen_read2(ex);
    if(ex != NULL) ret = gen_exp(tr->ch1);
    if(ex != NULL) gen_write2(ex);
    gen_outf(")\n");
    ret += gen_sub_st(tr->ch2->ch1, para_flag);
    if (tr->ch2->ch2 != NULL) {
	/* else  */
	gen_indent();
	gen_outf("else\n");
	ret += gen_sub_st(tr->ch2->ch2, para_flag);
    }
    return ret;
}

static int
gen_switch_st(Tree *tr, int para_flag)
{
    int ret = 0;
    gen_indent();
    gen_outf("switch (");
    gen_read2(tr->ch1);
    ret = gen_exp(tr->ch1);
    gen_write2(tr->ch1);
    gen_outf(")\n");
    ret += gen_sub_st(tr->ch2, para_flag);
    return ret;
}

static int
gen_for_st(Tree *tr, int para_flag)
{
    int ret = 0;
    gen_indent();
    gen_outf("for (");
    if (tr->ch1 != NULL) {
	gen_read2(tr->ch1);
	ret += gen_exp(tr->ch1);
	gen_write2(tr->ch1);
    }
    gen_outf("; ");
    if (tr->ch2->ch1 != NULL) {
	gen_read2(tr->ch2->ch1);
	ret += gen_exp(tr->ch2->ch1);
	gen_write2(tr->ch2->ch1);
    }
    gen_outf("; ");
    if (tr->ch2->ch2->ch1 != NULL) {
	gen_read2(tr->ch2->ch2->ch1);
	ret += gen_exp(tr->ch2->ch2->ch1);
	gen_write2(tr->ch2->ch2->ch1);
    }
    gen_outf(")\n");
    ret += gen_sub_st(tr->ch2->ch2->ch2, para_flag);
    return ret;
}

static int
gen_while_st(Tree *tr, int para_flag)
{
    int ret = 0;
    gen_indent();
    gen_outf("while (");
    gen_read2(tr->ch1);
    ret = gen_exp(tr->ch1);
    gen_write2(tr->ch1);
    gen_outf(")\n");
    ret += gen_sub_st(tr->ch2, para_flag);
    return ret;
}

static int
gen_do_while_st(Tree *tr, int para_flag)
{
    int ret = 0;
    gen_indent();
    gen_outf("do\n");
    ret += gen_sub_st(tr->ch2, para_flag);
    gen_indent();
    gen_outf("while (");
    gen_read2(tr->ch1);
    ret += gen_exp(tr->ch1);
    gen_write2(tr->ch1);
    gen_outf(");\n");
    return ret;
}

static int
gen_foreach_st(Tree *tr, int para_flag)
{
    int ret;
    gen_foreachhead(tr->ch1->node.string);
    ret = gen_sub_st(tr->ch2, para_flag);
    gen_foreachtail();
    return ret;
}

static int
gen_goto_st(Tree *tr)
{
    gen_indent();
    gen_outf("goto %s;\n", tr->ch1->node.string);
    return 0;
}

static int
gen_continue_st(void)
{
    gen_indent();
    gen_outf("continue;\n");
    return 0;
}

static int
gen_break_st(void)
{
    gen_indent();
    gen_outf("break;\n");
    return 0;
}

static int
gen_labeled_st(Tree *tr, int para_flag)
{
    gen_indent();
    gen_outf("%s:\n", tr->ch1->node.string);
    return gen_sub_st(tr->ch2, para_flag);
}

static int
gen_return_st(Tree *tr)
{
    int ret;
    gen_indent();
    if (tr->ch1 == NULL) {
	gen_outf("return;\n");
	ret = 0;
    } else {
	gen_outf("return ");
	gen_read2(tr->ch1);
	ret = gen_exp(tr->ch1);
	gen_write2(tr->ch1);
	gen_outf(";\n");
    }
    return ret;
}

static int
gen_default_st(Tree *tr, int para_flag)
{
    gen_indent();
    gen_outf("default:\n");
    return gen_sub_st(tr->ch1, para_flag);
}

static int
gen_case_st(Tree *tr, int para_flag)
{
    int ret;
    gen_indent();
    gen_outf("case ");
    gen_read2(tr->ch1);
    ret = gen_exp(tr->ch1);
    gen_write2(tr->ch1);
    gen_outf(":\n");
    ret += gen_sub_st(tr->ch2, para_flag);
    return ret;
}

static int add_parallel(Tree *st, int para_id);

static int
gen_parallel_st(Tree *tr, int para_flag)
{
    int ret;

    if (para_flag) {
	/* 򤹤 */
	gen_begin_parallel();
	ret = gen_sub_st(tr->ch1, para_flag);
	gen_end_parallel();
    } else {
	/* 򤢤Ȥ */
	gen_indent();
	gen_outf("// parallel here\n");
	cache_gen_write_global_variable();
	gen_indent();
	gen_outf("VIOS_signal_para(jobid, %d);\n", parallel_id);
	gen_indent();
	gen_para_call(parallel_id);
	gen_outf(";\n");
	cache_gen_read_global_variable();
	add_parallel(tr->ch1, parallel_id);
	parallel_id++;
	ret = 0;
    }
    return ret;
}

/* ؿ */

static int gen_global_param(Tree *decls_top);

static int
gen_para_decl(int para_id, int define_flag)
    /* define_flag: ؿ 0: , 1:  */
{
    Tree *list;
    Tree *type;
    char *name;
    int  i;
    Tree *param = module_param;

    gen_indent();
    gen_outf("void VIOS_module_%s_para%d(int jobid, usercom& com",
	     module_name, para_id);

    for (i = 0; i < 3; i++) {
	list = (i == 0) ? param->ch1 : ((i == 1) ? param->ch2 : param->ch3);
	for (; list != NULL; list = list->ch1) {
	    name = list->node.string;
	    if ((type = search_declarations(name)) == NULL) {
		continue;
	    }

	    gen_outf(", ");
	    if (type->node.type.isimage) {
		/* Imageʤ */
		gen_outf("Image*");
		if (define_flag) {
		    gen_outf(" VIOS_image_%s", name);
		}
	    } else {
		/* ѥ᡼ʤ */
		gen_outf("array*");
		if (define_flag) {
		    gen_outf(" VIOS_Global_%s", name);
		}
	    }
	}
    }

    gen_global_param(global_decls);

    if (define_flag) {
	gen_outf(")\n");
    } else {
	gen_outf(");\n");
    }

    return 0;
}

static void gen_global_param_sub1(Tree *decls);

static int
gen_global_param(Tree *decls_top)
{
    Tree *p, *decls;
    for (p = decls_top; p != NULL; p = p->ch2) {
	decls = p->ch1;
	gen_global_param_sub1(decls);
    }
    return 0;
}

static void
gen_global_param_sub1(Tree *decls)
{
    Tree *p1, *p2;
    char *name, *typename;
    int  i;

    typename = type2string(decls->ch1->node.type.primary);

    for (i = 0; i < 2; i++) {
	/* i == 0: Global , */
	/* i == 1:  */
	for (p1 = decls->ch2; p1 != NULL; p1 = p1->ch2) {

	    gen_outf(", ");
	    if (i == 0) {
		gen_outf("array* ");
	    } else {
		gen_outf("%s ", typename);
	    }

	    for (p2 = p1->ch1->ch1; p2->nodetype != nt_string; p2 = p2->ch1) ;
	    name = p2->node.string;
	    if (i == 0) {
		gen_outf("VIOS_Global_%s", name);
	    } else {
		gen_paramdecl(p1->ch1->ch1, 0);
	    }
	}
    }
}

/* ؿƤӽФ */

static int gen_global_param_call(Tree *decls_top);

static int
gen_para_call(int para_id)
{
    Tree *list;
    Tree *type;
    char *name;
    int  i;
    int  need_comma = 0;
    Tree *param = module_param;

    gen_outf("VIOS_module_%s_para%d(jobid, com, ", module_name, para_id);
    for (i = 0; i < 3; i++) {
	list = (i == 0) ? param->ch1 : ((i == 1) ? param->ch2 : param->ch3);
	for (; list != NULL; list = list->ch1) {
	    name = list->node.string;
	    if ((type = search_declarations(name)) == NULL) {
		continue;
	    }
	    if (need_comma) {
		gen_outf(", ");
	    }
	    if (type->node.type.isimage) {
		gen_outf("VIOS_image_%s", name);
	    } else {
		gen_outf("VIOS_Global_%s", name);
	    }
	    need_comma = 1;
	}
    }

    gen_global_param_call(global_decls);

    gen_outf(")");

    return 0;
}

static void gen_global_param_call_sub1(Tree *decls);

static int
gen_global_param_call(Tree *decls_top)
{
    Tree *p, *decls;
    for (p = decls_top; p != NULL; p = p->ch2) {
	decls = p->ch1;
	gen_global_param_call_sub1(decls);
    }
    return 0;
}

static void
gen_global_param_call_sub1(Tree *decls)
{
    Tree *p1, *p2;
    char *name, *typename;
    int  i;

    typename = type2string(decls->ch1->node.type.primary);

    for (i = 0; i < 2; i++) {
	/* i == 0: Global , */
	/* i == 1:  */
	for (p1 = decls->ch2; p1 != NULL; p1 = p1->ch2) {

	    gen_outf(", ");

	    for (p2 = p1->ch1->ch1; p2->nodetype != nt_string; p2 = p2->ch1) ;
	    name = p2->node.string;
	    if (i == 0) {
		gen_outf("VIOS_Global_%s", name);
	    } else {
		gen_outf("%s", name);
	    }
	}
    }
}


static Tree *parallel_sts = NULL;

static int
add_parallel(Tree *st, int para_id)
{
    Tree **p;
    /* ָɲ */
    for (p = &parallel_sts; *p != NULL; p = &((*p)->ch2)) ;
    (*p) = newnodei(para_id);
    (*p)->ch1 = treedup(st);
    (*p)->ch2 = NULL;
    return 0;
}

static int gen_parallel_func_sub(Tree *sts);

static int
gen_parallel_func(void)
{
    if (parallel_sts != NULL) {
	gen_parallel_func_sub(parallel_sts);
	free_tree(parallel_sts);
	parallel_sts = NULL;
    }
    return 0;
}

static int gen_begin_parallel_func(void);

static int gen_end_parallel_func(void);

static int
gen_parallel_func_sub(Tree *sts)
{
    if (sts == NULL) return 0;

    gen_para_decl(sts->node.ival, 1); /* ؿ̾ */
    gen_LC(); /* ؿ */
    gen_begin_parallel_func();
    gen_sub_st(sts->ch1, 1);
    gen_end_parallel_func();
    gen_RC(); /* ؿλ */
    gen_outf("\n");

    gen_parallel_func_sub(sts->ch2);
    return 0;
}

static int
gen_begin_parallel_func(void)
{
    gen_moduleparam2(module_param);
    gen_begin_parallel();
    return 0;
}
static int
gen_end_parallel_func(void)
{
    gen_RC();
    gen_RC();
    gen_indent();
    gen_outf("VIOS_sync(jobid);\n");
    cache_gen_unify_global_variable();
    return 0;
}

/* c function */

static void
gen_c_arg(Tree *decl)
{
    if (decl->nodetype == nt_string) {
	gen_outf("%s", decl->node.string);
    } else {
	gen_c_arg(decl->ch1);
	gen_outf("[");
	gen_exp(decl->ch2);
	gen_outf("]");
    }
}


static void
declare_c_arg(Tree *decl)
{
    if (decl->nodetype == nt_string) {
	Tree c_variable_type;
	memset(&c_variable_type, 0, sizeof(Tree)); /* ϲ */
	regist_declaration(decl->node.string, &c_variable_type);
    } else {
	declare_c_arg(decl->ch1);
    }
}

int
gen_c_function(int type, char *func_name, Tree *args_param, Tree *comp_st)
{
    char *type_name;
    Tree *args;
    Tree *arg;
    Tree c_function_type;

    memset(&c_function_type, 0, sizeof(Tree)); /* ϲ */
    regist_declaration(func_name, &c_function_type);

    type_name = type2string(type);
    gen_indent();
    gen_outf("static %s %s(", type_name, func_name);
    for (args = args_param; args != NULL; args = args->ch2) {
	arg = args->ch1;
	type_name = type2string(arg->node.ival);
	gen_outf("%s ", type_name);
	gen_c_arg(arg->ch1);
	if (args->ch2 != NULL) {
	    gen_outf(", ");
	}
    }
    gen_outf("");
    gen_outf(")\n");

    if (check_parallel(comp_st) > 0) {
	trans_error("no parallel allowed in C function");
	return -1;
    }

    gen_LC();
    decl_levelup();
    for (args = args_param; args != NULL; args = args->ch2) {
	arg = args->ch1;
	declare_c_arg(arg->ch1);
    }
    gen_local_declares(comp_st->ch1);
    gen_statements(comp_st->ch2, 0);
    decl_leveldown();
    gen_RC();

    gen_outf("\n");

    return 0;
}
