%{
/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  transparse.y
    VPE-p parse analyzer
*********************************************************************/

/* contains 2 shift/reduce conflicts Ȥʤޤ*/
/* main  module  if-else Ǥ          */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "transdefs.h"
#include "tree.h"
#include "trans.h"
#include "macro.h"
#include "pragma.h"

int		trans_nerrors = 0;
int		trans_nwarnings = 0;

static int	yyerror(char *s);

%}

%union {
    Tree	*tree;
    char	*string;
    int 	ival;
    double	fval;
}

%token	IF
%token	ELSE
%token	WHILE
%token	DO
%token	FOR
%token	BREAK
%token	CONTINUE
%token	SWITCH
%token	CASE
%token	DEFAULT
%token	RETURN
%token	GOTO

%token	MAIN

%token	NEW
%token	LOAD
%token	SAVE
%token	DISP

%token	MODULE
%token	INPUT
%token	OUTPUT
%token	PARAMETER
%token	VAR
%token	ON
%token	CACHE
%token	PIXEL ROW COLUMN BOX ALL
%token	PARALLEL
%token	FOREACH

%token	LP	/* ( */
%token	RP	/* ) */
%token	LC	/* { */
%token	RC	/* } */
%token	LB	/* [ */
%token	RB	/* ] */
%token	SM	/* ; */
%token	CM	/* , */
%token	COLON	/* : */
%token	ARROW	/* -> */
%token	DOT	/* . */

%token	<ival>		TYPE
%token	<string>	IDENTIFIER
%token	<string>	STRING
%token	<ival>		CHARACTER
%token	<string>	INTEGER
%token	<string>	FLOATING

%token	<ival>		UNOP ADDOP EQOP COMPOP INCOP ASSIGNOP SHIFTOP

%token	EXTERN

/* 黻Ҥͥ */
%left		CM
%right		ASSIGN ASSIGNOP
%left		QUEST COLON
%left		OROR
%left		ANDAND
%left		OROP
%left		XOROP
%left		ANDOP
%left		EQOP
%left		COMPOP
%left		SHIFTOP
%left		ADDOP
%left		MULOP DIVOP MODOP
%right		UNOP
%nonassoc	INCOP

/* main() */
/*%type	<tree>		main_identifier_declarator_list*/

/* ؿ */
%type	<tree>		declaration declarator init_declarator
%type	<tree>		init_declarator_list

/* ⥸塼 */
%type	<tree>		module_global_declarations
%type	<tree>		compound_statement declaration_list_opt
%type	<tree>		statement_list_opt statement
%type	<tree>		non_compound_statement expression_statement
%type	<tree>		selection_statement else_opt iteration_statement
%type	<tree>		jump_statement labeled_statement parallel_statement

/*  */
%type	<tree>		parameter_list
%type	<tree>		parameter_input_list parameter_output_list
%type	<tree>		parameter_parameter_list
%type	<tree>		parameter_identifier_list
%type	<tree>		parallel_declaration parallel_specifier
%type	<tree>		parallel_division parallel_cache
%type	<tree>		parallel_declaration_list
%type	<tree>		parallel_direct_declarator

/*  */
%type	<ival>		constant
%type	<tree>		expression nc_expression primary_expression
%type	<tree>		expression_list_opt expression_list expression_opt

/* C ؿ */
%type	<tree>		c_args c_arg

%%
/**
 **	all of program
 **/
program		/* ץΤι¤ */
	: { gen_programhead(); } module_declaration_list
	| main_declaration
	;
/*	: module_declaration_list
	| module_declaration_list main_declaration
	;*/
/**
 **	main program define
 **/
main_declaration	/* ᥤʬι¤ */
	: MAIN LP RP LC
		{ genmain_begin(); } main_statement_list RC { genmain_end(); }
	| error
	;

main_statement_list	/* ᥤѤιʸ */
	: /* empty */
	| main_statement main_statement_list
	;
main_statement		/* ᥤѤιʸ */
	: main_declarator
	| main_expression_statement
	| main_selection_statement
	| main_iteration_statement
	| main_compound_statement
	| error
	;

/* ѿʬ */
main_declarator
	: declaration
	    { genmain_declare($1); free_tree($1); }
/* ʸ */
main_expression_statement
	: SM			/* ʸ */
	| expression SM 	/* ʸ */
	    { genmain_exp_stmt($1); free_tree($1); }
	;

main_selection_statement	/* if ʸ */
	: IF LP expression RP { genmain_ifhead($3); free($3); }
	    main_statement main_else_opt
	;
main_else_opt
	: /* empty */ { genmain_iftail(); }
	| ELSE { genmain_ifelse(); } main_statement { genmain_ifelsetail(); }
	;

main_iteration_statement	/* for ʸ */
	: FOR LP expression_opt SM expression_opt SM expression_opt RP
	    { genmain_forhead($3, $5, $7);
	      if ($3 != NULL) free_tree($3);
	      if ($5 != NULL) free_tree($5);
	      if ($7 != NULL) free_tree($7); }
	    main_statement { genmain_fortail(); }
	/*| WHILE LP expression RP
	    { genmain_forhead(NULL, $3, NULL); free($3); }
	    main_statement { genmain_fortail(); }*/
	;

main_compound_statement
	: LC main_statement_list RC
	;

/**
 **	Module definition
 **/
module_declaration_list	/* ⥸塼ʬ */
	: /* empty */
	| module_declaration module_declaration_list
	| c_function module_declaration_list
	;
module_declaration	/* ⥸塼ʬȤ */
	: MODULE IDENTIFIER LP parameter_list RP
	  parallel_declaration_list
	  LC module_global_declarations statement_list_opt RC
	    {
		regist_module($2, $4);
		decl_levelup();
		regist_parameter($2, $4, $6);
		global_declare($8);
		gen_modulehead($2);
		gen_moduleparam($4);
		gen_global_decl1($8);   /* $8 Ϥ static  */
		gen_global_decl2($8);   /*                  */
		gen_module($2, $4, $9); /*                  */
		gen_global_decl3($8);   /* ޤǻȤ */
		gen_moduletail($2);
		decl_leveldown();
		free_tree($9);free_tree($8); free_tree($6); free_tree($4);
		free($2);
	    }
	;
module_global_declarations
	: /* empty */ { $$ = NULL; }
	| declaration module_global_declarations
	    {
		$$ = newnode();
		$$->ch1 = $1;
		$$->ch2 = $2;
	    }
	;
/**
 **		Declarations
 **/
declaration		/* ѿ */
	: TYPE SM {(void)$1;}
	| TYPE init_declarator_list SM
	    {
		$$ = newnodest(st_decl);
		$$->ch1 = newnode();
		$$->ch1->nodetype = nt_type;
		$$->ch1->node.type.primary = $1;
		$$->ch1->node.type.isimage = 0;
		$$->ch2 = $2;
	    }
	;
init_declarator_list	/* ѿʬ */
	: init_declarator
	    {
		$$ = newnode();
		$$->ch1 = $1;
	    }
	| init_declarator CM init_declarator_list
	    {
		$$ = newnode();
		$$->ch1 = $1;
		$$->ch2 = $3;
	    }
	;
init_declarator
	: declarator
	    {
		$$ = newnode();
		$$->ch1 = $1;
	    }
	| declarator ASSIGN expression
	    {
		$$ = newnode();
		$$->ch1 = $1;
		$$->ch2 = $3;
	    }
	;
declarator
	: IDENTIFIER
	    {
		$$ = newnodes($1);
	    }
	| declarator LB expression RB
	    {
		$$ = newnode();
		$$->ch1 = $1;
		$$->ch2 = $3;
	    }
	;
/*
 * ⥸塼 () Υѥ᡼
 */
parameter_list
	: parameter_input_list CM parameter_output_list
	    {
		$$ = newnode();
		$$->ch1 = $1;
		$$->ch2 = $3;
	    }
	| parameter_input_list
	    {
		$$ = newnode();
		$$->ch1 = $1;
	    }
	| parameter_output_list
	    {
		$$ = newnode();
		$$->ch2 = $1;
	    }
	| /* empty */
	    {
		$$ = newnode();
	    }
	| parameter_input_list CM parameter_output_list CM
						       parameter_parameter_list
	    {
		$$ = newnode();
		$$->ch1 = $1;
		$$->ch2 = $3;
		$$->ch3 = $5;
	    }
	| parameter_input_list CM parameter_parameter_list
	    {
		$$ = newnode();
		$$->ch1 = $1;
		$$->ch3 = $3;
	    }
	| parameter_output_list CM parameter_parameter_list
	    {
		$$ = newnode();
		$$->ch2 = $1;
		$$->ch3 = $3;
	    }
	| parameter_parameter_list
	    {
		$$ = newnode();
		$$->ch3 = $1;
	    }
	;
parameter_input_list
	: parameter_identifier_list COLON INPUT
	    { $$ = $1; }
	;
parameter_output_list
	: parameter_identifier_list COLON OUTPUT
	    { $$ = $1; }
	;
parameter_parameter_list
	: parameter_identifier_list COLON PARAMETER
	    { $$ = $1; }
	;
parameter_identifier_list
	: IDENTIFIER
	    {
		$$ = newnodes($1);
	    }
	| IDENTIFIER CM parameter_identifier_list 
	    {
		$$ = newnodes($1);
		$$->ch1 = $3;
	    }
	;
/*
 * ʬ
 */
parallel_declaration_list
	: /* empty */
	    {
		$$ = NULL;
	    }
	| parallel_declaration parallel_declaration_list
	    {
		$$ = newnode();
		$$->ch1 = $1;
		$$->ch2 = $2;
	    }
	;
parallel_declaration
	: TYPE parallel_direct_declarator parallel_specifier SM
	    {
		$$ = newnode();
		$$->nodetype = nt_type;
		$$->node.type.primary = $1;
		$$->node.type.isglobal = 1;
		$$->node.type.isparam = 1;
		$$->ch1 = $2;
		$$->ch2 = $3;
	    }
	;
parallel_direct_declarator
	: IDENTIFIER { $$ = newnodes($1); }
	| parallel_direct_declarator LB expression RB
	    { $$ = newnode(); $$->ch1 = $1; $$->ch2 = $3; }
	| parallel_direct_declarator LB RB
	    { $$ = newnode(); $$->ch1 = $1; $$->ch2 = NULL; }
	;
parallel_specifier
	: /* empty */
	    {
		$$ = NULL;
	    }
	| ON parallel_division parallel_cache
	    {
		$$ = newnode();
		$$->ch1 = $2;
		$$->ch2 = $3;
	    }
	;
parallel_division
	: PIXEL
	    { $$ = newnodei(dv_pixel); }
	| ROW
	    { $$ = newnodei(dv_row); }
	| COLUMN
	    { $$ = newnodei(dv_column); }
	| BOX LB constant RB LB constant RB
	    {
		$$ = newnodei(dv_box);
		$$->ch1 = newnodei($3);
		$$->ch2 = newnodei($6);
	    }
	| ALL
	    { $$ = newnodei(dv_all); }
	;
parallel_cache
	: /* empty */ { $$ = NULL; }
	| CACHE constant
	    { $$ = newnodei($2); }
	;

/**
 **		Statements
 **/
statement		/* ʸȤ */
	: non_compound_statement { $$ = $1; }
	| compound_statement { $$ = $1; }
	| error { $$ = newnodest(st_exp); $$->ch1 = NULL; }
	;
non_compound_statement		/* compound_statement ʳμ */
	: expression_statement { $$ = $1; }
	| selection_statement { $$ = $1; }
	| iteration_statement { $$ = $1; }
	| jump_statement { $$ = $1; }
	| labeled_statement { $$ = $1; }
	| parallel_statement { $$ = $1; }
	;
compound_statement
	: LC declaration_list_opt statement_list_opt RC
	{
	    $$ = newnodest(st_comp);
	    $$->ch1 = $2;
	    $$->ch2 = $3;
	}
	;
declaration_list_opt
	: /* empty */ { $$ = NULL; }
	| declaration declaration_list_opt
	    {
		$$ = newnodest(st_decl_list);
		$$->ch1 = $1;
		$$->ch2 = $2;
	    }
	;
statement_list_opt
	: /* empty */ { $$ = NULL; }
	| statement statement_list_opt
	    {
		$$ = newnodest(st_stat_list);
		$$->ch1 = $1;
		$$->ch2 = $2;
	    }
	;
expression_statement
	: expression_opt SM
	    {
		$$ = newnodest(st_exp);
		$$->ch1 = $1;
	    }
	;

selection_statement	/* if ʸswitch ʸ */
	: IF LP expression RP statement else_opt
	    {
		$$ = newnodest(st_if);
		$$->ch1 = $3;
		$$->ch2 = newnode();
		$$->ch2->ch1 = $5;
		$$->ch2->ch2 = $6;
	    }
	| SWITCH LP expression RP compound_statement
	    {
		$$ = newnodest(st_switch);
		$$->ch1 = $3;
		$$->ch2 = $5;
	    }
	;
else_opt
	: /* empty */ { $$ = NULL; }
	| ELSE statement { $$ = $2; }
	;
iteration_statement	/* for, while, do  */
	: FOR LP expression_opt SM expression_opt SM expression_opt RP
	    statement
	    {
		$$ = newnodest(st_for);
		$$->ch1 = $3;
		$$->ch2 = newnode();
		$$->ch2->ch1 = $5;
		$$->ch2->ch2 = newnode();
		$$->ch2->ch2->ch1 = $7;
		$$->ch2->ch2->ch2 = $9;
	    }
	| WHILE LP expression RP statement
	    {
		$$ = newnodest(st_while);
		$$->ch1 = $3;
		$$->ch2 = $5;
	    }
	| DO statement WHILE LP expression RP SM
	    {
		$$ = newnodest(st_do_while);
		$$->ch1 = $5;
		$$->ch2 = $2;
	    }
	| FOREACH IDENTIFIER { gen_foreachhead($2); } statement
	    { gen_foreachtail(); /*free($2);*/
		$$ = newnodest(st_foreach);
		$$->ch1 = newnodes($2);
		$$->ch2 = $4;
	    }
	;
expression_opt
	: /* empty */ { $$ = NULL; }
	| expression  { $$ = $1; }
	;

jump_statement		/* return or break */
	: GOTO IDENTIFIER SM
	    { $$ = newnodest(st_goto); $$->ch1 = newnodes($2); }
	| CONTINUE SM { $$ = newnodest(st_continue); }
	| BREAK SM { $$ = newnodest(st_break); }
	| RETURN expression_opt SM
	    { $$ = newnodest(st_return); $$->ch1 = $2; }
	;

labeled_statement
	: IDENTIFIER COLON statement
	    {
		$$ = newnodest(st_labeled);
		$$->ch1 = newnodes($1);
		$$->ch2 = $3;
	    }
	| CASE expression COLON statement
	    {
		$$ = newnodest(st_case);
		$$->ch1 = $2;
		$$->ch2 = $4;
	    }
	| DEFAULT COLON statement
	    {
		$$ = newnodest(st_default);
		$$->ch1 = $3;
	    }
	;

parallel_statement
	: PARALLEL statement
	    {
		$$ = newnodest(st_parallel);
		$$->ch1 = $2;
	    }
	;

/**
 **		Expressions
 **/
nc_expression	/* ްʳμ */
	: primary_expression
	    { $$ = $1; }
	| ADDOP nc_expression %prec UNOP
	    { $$ = newnodeo(op_unop, $1); $$->ch1 = $2; }
	| MULOP nc_expression %prec UNOP
	    { $$ = newnodeo(op_unop, '*'); $$->ch1 = $2; }
	| ANDOP nc_expression %prec UNOP
	    { $$ = newnodeo(op_unop, '&'); $$->ch1 = $2; }
	| UNOP nc_expression
	    { $$ = newnodeo(op_unop, $1); $$->ch1 = $2; }
	| INCOP nc_expression
	    { $$ = newnodeo(op_incop, $1); $$->ch1 = $2;}
	| nc_expression INCOP
	    { $$ = newnodeo(op_incop, $2); $$->ch2 = $1;}
	| nc_expression MULOP nc_expression
	    { $$ = newnodeo(op_mul, 0); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression DIVOP nc_expression
	    { $$ = newnodeo(op_div, 0); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression MODOP nc_expression
	    { $$ = newnodeo(op_mod, 0); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression ADDOP nc_expression
	    { $$ = newnodeo(op_addop, $2); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression COMPOP nc_expression
	    { $$ = newnodeo(op_compop, $2); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression EQOP nc_expression
	    { $$ = newnodeo(op_eqop, $2); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression ANDAND nc_expression
	    { $$ = newnodeo(op_andand, 0); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression OROR nc_expression
	    { $$ = newnodeo(op_oror, 0); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression ASSIGN nc_expression
	    { $$ = newnodeo(op_assign, 0); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression ASSIGNOP nc_expression
	    { $$ = newnodeo(op_assignop, $2); $$->ch1 = $1; $$->ch2 = $3;}
	| LP TYPE RP nc_expression %prec UNOP
	    { $$ = newnodeo(op_cast, 0); $$->ch1 = newnodei($2); $$->ch2 = $4;}
	| nc_expression QUEST expression COLON nc_expression
	    { $$ = newnodeo(op_quest, 0);
	      $$->ch1 = $1; $$->ch2 = $3; $$->ch3 = $5;}
	| nc_expression SHIFTOP nc_expression
	    { $$ = newnodeo(op_shift, $2); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression ANDOP nc_expression
	    { $$ = newnodeo(op_and, 0); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression XOROP nc_expression
	    { $$ = newnodeo(op_xor, 0); $$->ch1 = $1; $$->ch2 = $3;}
	| nc_expression OROP nc_expression
	    { $$ = newnodeo(op_or, 0); $$->ch1 = $1; $$->ch2 = $3;}
	;
expression
	: nc_expression
	    { $$ = $1; }
	| expression CM nc_expression
	    {
		Tree *tr;
		tr = newnodeo(op_comma, 0);
		tr->ch1 = $1;
		tr->ch2 = $3;
		$$ = tr;
	    }
	;
primary_expression
	: IDENTIFIER
	    { $$ = newnodeo(op_id, 0);
	      $$->ch1 = newnodes($1);}
	| INTEGER
	    { $$ = newnodeo(op_constant, 0);
	      $$->ch1 = newnodei(atoi($1));
	      $$->ch2 = newnodes($1);}
	| FLOATING
	    { $$ = newnodeo(op_fconstant, 0);
	      $$->ch1 = newnode();
	      $$->ch1->nodetype = nt_float;
	      $$->ch1->node.fval = atof($1);
	      $$->ch2 = newnodes($1);
	    }
	| STRING
	    { $$ = newnodeo(op_string, 0);
	      $$->ch1 = newnodes($1);}
	| CHARACTER
	    { $$ = newnodeo(op_charcter, 0);
	      $$->ch1 = newnodei($1);}
	| LP expression RP
	    { $$ = newnodeo(op_parent, 0);
	      $$->ch1 = $2;}
	| primary_expression LP expression_list_opt RP
	    { $$ = newnodeo(op_func, 0);
	      $$->ch1 = $1; $$->ch2 = $3;
	    }
	| primary_expression LB RB
	    { $$ = newnodeo(op_array, 0);
	      $$->ch1 = $1; $$->ch2 = NULL;
	    }
	| primary_expression LB expression RB
	    { $$ = newnodeo(op_array, 0);
	      $$->ch1 = $1; $$->ch2 = $3;
	    }
	| primary_expression LB LB expression RB RB
	    { $$ = newnodeo(op_array, 1);
	      $$->ch1 = $1; $$->ch2 = $4;
	    }
/*	| primary_expression ARROW expression
	    { $$ = newnodeo(op_arrow, 0);
	      $$->ch1 = $1; $$->ch2 = $3;
	    }
	| primary_expression DOT expression
	    { $$ = newnodeo(op_dot, 0);
	      $$->ch1 = $1; $$->ch2 = $3;
	    }*/
	;
/* ؿ */
expression_list_opt
	: /* empty */ { $$ = NULL; }
	| expression_list { $$ = $1; }
	;
expression_list
	: nc_expression
	    {
		$$ = newnode();
		$$->ch1 = $1;
		$$->ch2 = NULL;
	    }
	| nc_expression CM expression_list
	    {
		$$ = newnode();
		$$->ch1 = $1;
		$$->ch2 = $3;
	    }
	;
constant
	: INTEGER
	    { $$ = (int)strtol($1, NULL, 0); }
	    /* strtol()  atoi() Ȱ㤤 0x, 0 򸫤ѴƤ */
	;
/* C */
c_function
	: TYPE IDENTIFIER LP c_args RP compound_statement
	    { gen_c_function($1, $2, $4, $6); }
	;
c_args
	: { $$ = NULL; } /* empty */
	| c_arg           { $$ = newnode(); $$->ch1 = $1; }
	| c_arg CM c_args { $$ = newnode(); $$->ch1 = $1; $$->ch2 = $3; }
	;
c_arg
	: TYPE declarator { $$ = newnodei($1); $$->ch1 = $2; }
	;

%%

/** ȤΥ󥿡ե **/
int
translate(char *prog_buf)
    /* prg_buf: (Ѵץ) */
    /* ϤϸƤӽФ¦Ѱդؿ int translator_output(char *)  */
    /* int translator_error(char *) ǹԤ                             */
{
    int ret;

    /*  */
    translex_init(prog_buf);
    declare_init();
    gen_init();
    gbuf_init();
    genmain_init();
    pragma_init();
    macro_init();

    trans_nerrors = trans_nwarnings = 0;

    /* ȥ󥹥졼 */
    ret = yyparse();

    /*  */
    macro_term();
    pragma_term();
    genmain_term();
    gbuf_term();
    declare_term();

    return (trans_nerrors > 0) ? 1 : ret;
}

/** 顼åɽؿ **/

static int
yyerror(char *s) /* yacc (bison) ƤФؿ */
{
    trans_error("%s", s);
    return 0;
}

static void
trans_error_sub(char *header, char *form, va_list vp)
{
    char buf[4096];

    sprintf(buf, "%s: %d: %s", trans_inputfile, trans_lineno, header);
    translator_error(buf);
    vsprintf(buf, form, vp);
    translator_error(buf);
    translator_error("\n");

    trans_nerrors++;
}

void
trans_error(char *form, ...)
{
    va_list vp;

    va_start(vp, form);
    trans_error_sub("", form, vp);
    va_end(vp);
}

void
trans_internal_error(char *form, ...)
{
    va_list vp;

    va_start(vp, form);
    trans_error_sub("internal error: ", form, vp);
    va_end(vp);
}

void
trans_warning(char *form, ...)
{
    char buf[4096];
    va_list vp;

    sprintf(buf, "%s: %d: warning: ", trans_inputfile, trans_lineno);
    translator_error(buf);
    va_start(vp, form);
    vsprintf(buf, form, vp);
    va_end(vp);
    translator_error(buf);
    translator_error("\n");

    trans_nwarnings++;
}
