/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  tree.h
*********************************************************************/

#ifndef TREE_H
#define TREE_H

typedef enum {
    n_none,
    /* node for declare */
    n_st_class, n_type_sp, n_type_qu,
    n_init_decl_list,
    n_id, n_pointer, n_array, n_func
} node_t;

typedef enum {
    st_parallel,
    st_sequential,
    st_comp, st_decl_list, st_decl, st_stat_list,
    st_if, st_switch,
    st_for, st_while, st_do_while, st_foreach,
    st_goto, st_continue, st_break, st_return,
    st_labeled, st_case, st_default,
    st_exp
} statement_t;

typedef struct tree {
    union {
	int ival;
	char *string;
	double fval;
	struct {
	    int primary;
	    int isimage;
	    int isglobal;
	    int isparam;
	    int isinparam;
	    int isoutparam;
	    int ismodule;
	} type;
	struct {
	    int op1;
	    int op2;
	} op;
	statement_t st;
    } node;
    int line_no;
    enum {
	nt_null, nt_int, nt_string, nt_float, nt_type, nt_op, nt_statement
    } nodetype;
    struct tree	*ch1;
    struct tree	*ch2;
    struct tree	*ch3;
} Tree;


void free_tree(Tree *);
void print_tree(Tree *);

Tree *newnode(void);
Tree *newnodest(statement_t);
Tree *newnodes(char *);
Tree *newnodei(int);
Tree *newnodeo(int, int);
Tree *treedup(Tree *);

#endif /* TREE_H */
