/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  vpe_p.cc
    VPE-p Ѵ
    VPE-p  C++  VPE-p  IPU-p
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "trans.h"
#include "vios.h"
#include "msgqueue.h"
#include "protocol.h"
#include "etc.h"
#include "vpe_p.h"
#include "vbuf.h"
#include "ModuleList.h"
#include "IpuList.h"

extern	ModuleList mo;
extern	IpuList ip;

extern 	msgqueue com_q, done_q, send_q[64], vpe_send_q;

static char* get_cur_module_name();

static vbuf* trans_buf; // ȥ󥹥졼ν
static vbuf* error_buf; // ȥ󥹥졼Υ顼å

// ѥ饹åɤΥȴؿ
void*
vpe_p(void* param)
{
    (void)param;

    int 	result;		    // ȥ󥹥졼Ȥη, 0:OK, other:NG
    char*	prg_buf;            // ȥ󥹥졼ؤ (VPE-p)
    char*	translated_program; // ȥ󥹥졼ν (C++ or IPU-p)

    om_om	vpe_p_msg;
    om_om	msg;

#ifdef DEBUG
    fprintf(stderr, "### Thread for compiler\n");
#endif

    for (;;) {
	com_q.getmsg(vpe_p_msg);               // VPE-p 
	p_vo_t type = vpe_p_msg.from_vpe->type;// Ѵ西 (main or module)
	prg_buf = vpe_p_msg.buf;               // VPE-p ץ
	delete vpe_p_msg.from_vpe;

	if (type == p_vo_quit) {
#ifdef DEBUG
	    fprintf(stderr, "### Thread for compiler end\n");
#endif
	    break;
	}

	trans_buf = new vbuf;
	error_buf = new vbuf;
	switch (type) {
	  case p_vo_vpe_p_main:
	  case p_vo_vpe_p_module:
	  case p_vo_vpe_p_debug:
	    result = translate(prg_buf);
	    break;
	  default:
	    fprintf(stderr, "vpe_p: bad type %d\n", type);
	    break;
	}
	trans_buf->append("\0", 1);
	delete[] prg_buf;
	translated_program = (char*)trans_buf->getbuf();

	    
	// -------- VPE ˷̤𤹤 --------
	{
	    //om_om	msg;
	    unsigned int errlen = 0;
	    msg.to_vpe = new om_vpe;
	    switch (type) {
	      case p_vo_vpe_p_main:
		msg.to_vpe->type = p_ov_main_translate_stat;
		break;
	      case p_vo_vpe_p_module:
		msg.to_vpe->type = p_ov_module_translate_stat;
		break;
	      case p_vo_vpe_p_debug:
		msg.to_vpe->type = p_ov_module_translate_stat;
	    }		  
	    errlen = error_buf->getsize();
	    if (errlen > 0) errlen++; // '\0' 
	    msg.buf = new char[4+errlen];
	    msg.to_vpe->size = 4+errlen;
	    setint(msg.buf, result);
	    if (errlen > 0) {
		memcpy(msg.buf+4, error_buf->getbuf(), errlen-1);
		msg.buf[errlen-1] = '\0';
	    }
	    vpe_send_q.putmsg(msg);
	}
	// -------- VPE ˷̤λ --------

	if (result == 0 && type == p_vo_vpe_p_module) {
	    // C++ ˤ⥸塼


	    // ץ IPU 0 

	    char* module_name = get_cur_module_name();

	    msg.to_ipu = new om_ipu;
	    msg.to_ipu->type = p_oi_cxx_module;
	    msg.to_ipu->size = strlen(translated_program);
	    msg.buf = strdup_new(translated_program);
	    msg.p_info = new prog_info;
	    msg.p_info->in_num    = mo.get_in_num(module_name);
	    msg.p_info->out_num   = mo.get_out_num(module_name);
	    msg.p_info->param_num = mo.get_param_num(module_name);
	    strcpy(msg.p_info->name, module_name);
	    send_q[0].putmsg(msg);

	} else if (result == 0 && type == p_vo_vpe_p_main) {
	    // main 

	    msg.buf = strdup_new(translated_program);
	    msg.to_ipu = new om_ipu;
	    msg.to_ipu->type = p_oi_ipu_p;
	    msg.to_ipu->size = strlen(msg.buf);

	    //int ipu = ip.get_light_weight_ipu_no();
	    // Ѵ줿 main Υץ IPU ֹ0֤ IPU 
	    send_q[0].putmsg(msg);
	} else if (result == 0 && type == p_vo_vpe_p_debug) {
	    //  mainΥǥХå

	    msg.buf = strdup_new(translated_program);
	    msg.to_vpe = new om_vpe;
	    msg.to_vpe->type = p_ov_debug_translate;
	    msg.to_vpe->size = strlen(msg.buf);

	    vpe_send_q.putmsg(msg);
	}
	delete error_buf;
	delete trans_buf;
    }

    return 0;
}

// ȥ󥹥졼ȤΥ󥿡ե

static char prev_module_name[256]; // ߥȥ󥹥졼Υ⥸塼̾

static char*
get_cur_module_name()
{
    return prev_module_name;
}

extern "C" {

int
module_set_param(char* name, int in_num, int out_num, int param_num,
	div_type divtype[], int boxsize[], int cache[], int rtype, int etime)
{
    mo.append(name, in_num, out_num, param_num, divtype, boxsize, cache, rtype,
	      etime, 0);

    // ⥸塼̾ФƤ
    strcpy(prev_module_name, name);

    return 0;
}

int
translator_output(char* data)
{
    trans_buf->append(data, strlen(data));
    return 0;
}

int
translator_error(char* msg)
{
    fprintf(stderr, "%s", msg);
    error_buf->append(msg, strlen(msg));
    return 0;
}

} /* end of extern "C" */
