// dct.v $B2hA|$N%V%m%C%/J,3dN%;6%3%5%$%sJQ49(B

#define BOXSIZE 8   // 1$B$D$N%V%m%C%/$NBg$-$5$N@_Dj(B

module DCT(in:input,out:output)
int in on box[BOXSIZE][BOXSIZE];
int out on box[BOXSIZE][BOXSIZE];
{
    parallel{
	int x,y,u,v;
	float sum[BOXSIZE];
	float c_u,c_v;
	float cos_table[BOXSIZE][BOXSIZE];
	float n_ber=1.,n2_ber=1.;

	// $B=|;;$K;H$&?tCM$N5U?t$r@h9T$7$F7W;;(B
	n_ber /= BOXSIZE;
	n2_ber /= (2.*BOXSIZE);
	
	// $B%5%$%s!"%3%5%$%s$NCM$r%F!<%V%k2=(B
	for(x=0; x < BOXSIZE; x++){
	    for(y=0; y < BOXSIZE; y++){
		cos_table[x][y] = cos((float)((2.*x+1.)*y*M_PI)*n2_ber);
	    }
	}
	
	// $BF~NO2hA|$r%V%m%C%/$4$H$KN%;6%3%5%$%sJQ49(B
	for(v=0; v < BOXSIZE; v++){
	    sum[v] = 0;
	    for(x=0; x < BOXSIZE; x++){
		for(y=0; y < BOXSIZE; y++){
		    sum[v] += (float)(in[x][y])*cos_table[y][v];
		}
	    }
	}
	for(u=0; u < BOXSIZE; u++){
	    for(v=0; v < BOXSIZE; v++){
		for(x=0; x < BOXSIZE; x++){
		    sum[v] *= cos_table[x][u];
		}
		if(u == 0) c_u = 1./sqrt(2.);
		else c_u = 1.;
		if(v == 0) c_v = 1./sqrt(2.);
		else c_v = 1.;
		out[u][v] = ((2.*c_u*c_v)*n_ber) * sum[v];
	    }
	}
    }
}


     








