/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  ipustat.c
    IPU ֥ɥ
*********************************************************************/

#include <stdio.h>
#include <string.h>
#include "ipustat.h"


#define MAX_IPUS     256
#define MAX_HOSTNAME 128

static char   ipu_hostnames[MAX_IPUS][MAX_HOSTNAME];
static double ipu_loads[MAX_IPUS];

static void popup_ipustat(Tcl_Interp* interp,\
			  int ipu_no, char *ipu_hostname);

/* IPUνե饰 */
int no_ipu_flag = 1;

/*  IPU ǤȤ˸ƤФ */
int
ipu_create(Tcl_Interp* interp,\
	   int ipu_no, char *ipu_host, int ipu_host_len)
{
    if (ipu_no < MAX_IPUS) {
	if (ipu_host_len > MAX_HOSTNAME-1) {
	    ipu_host_len = MAX_HOSTNAME-1;
	}
	strncpy(ipu_hostnames[ipu_no], ipu_host, ipu_host_len);
	ipu_hostnames[ipu_no][ipu_host_len] = '\0';
    } else {
	fprintf(stderr, "IPU created, but too many ipus\n");
	return -1;
    }
    ipu_loads[ipu_no] = 0.0;
    popup_ipustat(interp, ipu_no, ipu_hostnames[ipu_no]);
    return 0;
}

/* IPU پƤȤ˸ƤФ */
int
ipu_load(int ipu_no, double load)
{
  if (ipu_no >= 0 && ipu_no < MAX_IPUS) {
	ipu_loads[ipu_no] = load;
    } else {
	printf("load: ipu_id=%d %3.2f\n", ipu_no, load);
	return -1;
    }
    return 0;
}

/* IPU_STATιԤʬ */
static void
timerHandler(ClientData clientdata)
{
  char command[256];
  char* p;
  int  ipu_no,i;

  Tcl_Interp* interp = (Tcl_Interp*)clientdata;
  
  if((p = Tcl_GetVar(interp, "w(real_ipu_no)",TCL_GLOBAL_ONLY))!=NULL){
    ipu_no = atoi(p);
  } else {
    Tcl_CreateTimerHandler(2500,timerHandler,clientdata);
    return;
  }
  
  for(i=0;i<ipu_no;i++){
    sprintf(command,\
	    "$w(stat).$ipu2id(%d).stat configure -text %5.3f",i,ipu_loads[i]);
    if(Tcl_Eval(interp, command) == TCL_ERROR) {
      /* ¿Υ顼äƤ⤽Τޤ޼¹ */
      Tcl_CreateTimerHandler(2500,timerHandler,clientdata);	
      return;
    }
  }
  Tcl_CreateTimerHandler(2500,timerHandler,clientdata);
}

void
popup_ipustat(Tcl_Interp* interp, int ipu_no, char *ipu_hostname)
{
  static char buf[64];

  /* TclǤɽ򥪥ˤ롣*/

  sprintf(buf,"IpuStat %d %s",ipu_no,ipu_hostnames[ipu_no]);
  if(Tcl_Eval(interp, buf) == TCL_ERROR){
          fprintf(stderr,"Interp error: %s\n",Tcl_GetStringResult(interp));
  }

  /* ޡȤä2.5äȤIPU_STAT񤭴 */

  if(no_ipu_flag) {
    Tcl_CreateTimerHandler(1500, timerHandler, (ClientData)interp);
    no_ipu_flag = 0;
  }
}

/* ⥸塼뤬äȤ˸ƤФ */
int
module_done_time(int ipu_no, int jobid, int sec, int usec, \
		 Tcl_Interp* interp)
/*ARGSUSED*/
{
  char cmd[256];

  if (ipu_no >= 0) {
    sprintf(cmd, "$w(txt2) insert end \"module done at ipu %d: %-8s %2d(sec) %06d(usec)\"", ipu_no, ipu_hostnames[ipu_no], sec, usec);
  } else {
    sprintf(cmd,"$w(txt2) insert end \"module done at om  %d: %2d(sec) %06d(usec)\"", jobid, sec, usec);
  }
  if(Tcl_Eval(interp, cmd) == TCL_ERROR) {
    fprintf(stderr,"done report print error: %s\n",\
	    Tcl_GetVar(interp, "errorInfo", TCL_GLOBAL_ONLY));
    return 1;
  }
  return 0;
}
