#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <unistd.h>
#include "tcl.h"
#include "msgpopup.h"
#include "vpedefs.h"
#include "image.h"
#include "compile.h"
#include "com.h"
#include "protocol.h"
#include "port.h"

/**** OM 򒵯ư ****/
int
om_exec(ClientData clientdata, Tcl_Interp* interp,
	 int argc, char* argv[])
{
  int pid, flag;
  char om_host[64];
  char buf[64];

  /* ֒뒤⒤Βϒƒ */
  sprintf(om_host,"%s",argv[1]);
  flag = strcmp(om_host, "localhost");
  sprintf(buf,"%s/om",VIOSBINDIR);
  
  if ((pid = fork()) == 0) { /* Ғג풥Β */
    if (flag==0) {
      if((execl(buf,"om",(char*)0)) == -1) {
	perror("om execute false\n");
	exit(1);
      }
    } else {
      if((execl("/usr/bin/rsh","rsh","-n",om_host,"om",(char*)0)) == -1) {
	perror("om execute false\n");
	exit(1);
      }
    }
  } else if(pid >= 1) {      /* ƒג풥()Β */
    sleep(1);                /* ޒ̒咤ƒ */
                             /* OMȒܒ³ */
    if((om_fd = connect_om(om_host, get_om_port())) >= 0) {
      msgpopup("ok", "Connect OM Successful!!");
      strcpy(buf, "MenuChange");     /* Ԓђ뒤ȒђĒǽ */
      if(Tcl_Eval(interp, buf) == TCL_ERROR) {
	fprintf(stderr, "Interp error: %s\n",Tcl_GetStringResult(interp));
	return TCL_ERROR;
      }	
      Tcl_CreateFileHandler(om_fd, TCL_READABLE,om_read,(ClientData)interp);
    } else {                	                  /*  */
      msgpopup("ok", "Can't Connect OM!!");
    }
    return TCL_OK;
  } else {        	     /*  */
      msgpopup("ok", "om execute false");
      return TCL_ERROR;
  }
  return TCL_OK;
}

/**** IPU 򒵯ư ****/
int
ipu_exec(ClientData clientdata, Tcl_Interp* interp,
	 int argc, char* argv[])
{
  int pid, flag;
  char ipu_host[64];
  char buf[64];
  char buf2[64];

  sprintf(ipu_host,"%s",argv[2]);
  sprintf(buf,"ipu -host %s -ip1 %s",argv[1],argv[3]);

  /* ֒Β뒤⒤Βϒ */
  flag = strcmp(ipu_host,"localhost");
  sprintf(buf2,"%s/ipu",VIOSBINDIR);
  
  if ((pid = fork()) == 0) { /* Ғג풥Β */
    if (flag == 0) {
      if((execl(buf2,buf,(char*)0)) == -1) {
	perror("om execute false\n");
	exit(1);
      }
    } else {
      if((execl("/usr/bin/rsh","rsh","-n",ipu_host,buf,(char*)0)) == -1) {
	perror("ipu execute false\n");
	exit(1);
      }
    }
  } else if(pid >= 1) {      /* ƒג풥()Β */
    return TCL_OK;
  } else {        	     /*  */
      msgpopup("ok", "ipu execute false");
      return TCL_ERROR;
  }
  return TCL_OK;
}

/** ᒥ˒咡 OM В쒤Ȓ˒ƒВ쒤 **/

/**** OM Ȓܒ³ ****/

int
om_connect(ClientData clientdata, Tcl_Interp* interp,
	   int argc, char* argv[])
{
  char *host_ptr;
  int       port;
  char   buf[64];
  
  if (strlen(argv[1]) == 0){
    host_ptr = "localhost";
  } else {
    host_ptr = argv[1];
  }
  if (strlen(argv[2]) == 0) {
    port = get_om_port();
  } else {
    port = atoi(argv[2]);
  }

  if ((om_fd = connect_om(host_ptr, port)) >= 0) { /*  */
    msgpopup("ok", "Connect OM Successful!!");
    strcpy(buf, "MenuChange");     /* Ԓђ뒤ȒђĒǽ */
    if(Tcl_Eval(interp, buf) == TCL_ERROR) {
	fprintf(stderr, "Interp error: %s\n",Tcl_GetStringResult(interp));
	return TCL_ERROR;
    }
    Tcl_CreateFileHandler(om_fd, TCL_READABLE,om_read,(ClientData)interp);
  } else {                	                  /*  */
      msgpopup("ok", "Can't Connect OM!!");
  }
  return TCL_OK;
  }

int
om_disconnect(ClientData clientdata,Tcl_Interp* interp,
		 int argc, char* argv[])
{
  char buf[64];

  if (om_fd >= 0) {
    close_om(om_fd);
    om_fd = -1;
    msgpopup("ok", "Disconnect Successful!!");
    strcpy(buf, "MenuChange");    /* Ԓђ뒤ȒђԒĒ */
    if(Tcl_Eval(interp, buf) == TCL_ERROR){
      fprintf(stderr, "Interp error: %s\n",Tcl_GetStringResult(interp));
      return TCL_ERROR;
    };
  } else {
    msgpopup("ok", "Not Connecting!!");
  }
  return TCL_OK;
}

int
om_cancel()
{
  return TCL_OK;
}
