/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  compile.c
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "vpedefs.h"
#include "compile.h"
#include "protocol.h"
#include "com.h"

static int send_program(char *program, int type);

/** compile_module: OM ˥ѥꤹ **/
int
compile_module(char *program)
{
    return send_program(program, p_vo_vpe_p_module);
}

/** run_module: OM ˼¹Ԥꤹ **/
int
run_module(char *program)
{
    return send_program(program, p_vo_vpe_p_main);
}

/** send_program: OM ˥ץ **/
static int
send_program(char *program, int type)
{
    vpe_om		msg;
    int			body_size = strlen(program);
    unsigned char	buf[8];
    char		*filename, *filename_out;

    if (om_fd <= 0) {
	return -1;
    }

    if (current_filename == NULL) {
	filename = "(no_name)";
    } else {
	filename = current_filename;
    }

    /* "# line 1 \"filename\"\n" */
    filename_out = malloc(strlen(filename) + 13);
    if (filename_out == NULL) {
	fprintf(stderr, "send_program: malloc failed\n");
	exit(1);
    }
    sprintf(filename_out, "# line 1 \"%s\"\n", filename);

    msg.type = type;
    msg.size = body_size + strlen(filename_out);

    buf[0] = (unsigned char)((msg.type >> 24) & 0xff);
    buf[1] = (unsigned char)((msg.type >> 16) & 0xff);
    buf[2] = (unsigned char)((msg.type >>  8) & 0xff);
    buf[3] = (unsigned char)((msg.type      ) & 0xff);
    buf[4] = (unsigned char)((msg.size >> 24) & 0xff);
    buf[5] = (unsigned char)((msg.size >> 16) & 0xff);
    buf[6] = (unsigned char)((msg.size >>  8) & 0xff);
    buf[7] = (unsigned char)((msg.size      ) & 0xff);
    net_write(om_fd, buf, 8);

    net_write(om_fd, filename_out, strlen(filename_out));
    net_write(om_fd, program, body_size);

    free(filename_out);

    return 0;
}
