/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  ipustat.c
    IPU ֥ɥ
*********************************************************************/

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/StripChart.h>
#include "ipustat.h"

extern Widget toplevel;

#define MAX_IPUS     256
#define MAX_HOSTNAME 128

static char   ipu_hostnames[MAX_IPUS][MAX_HOSTNAME];
static double ipu_loads[MAX_IPUS];

static void get_load(Widget w, XtPointer closure, XtPointer call_data);
static void popup_ipustat(int ipu_no, char *ipu_hostname);

/*  IPU ǤȤ˸ƤФ */
int
ipu_create(int ipu_no, char *ipu_host, int ipu_host_len)
{
    if (ipu_no < MAX_IPUS) {
	if (ipu_host_len > MAX_HOSTNAME-1) {
	    ipu_host_len = MAX_HOSTNAME-1;
	}
	strncpy(ipu_hostnames[ipu_no], ipu_host, ipu_host_len);
	ipu_hostnames[ipu_no][ipu_host_len] = '\0';
    } else {
	fprintf(stderr, "IPU created, but too many ipus\n");
	return -1;
    }
    ipu_loads[ipu_no] = 0.0;
    popup_ipustat(ipu_no, ipu_hostnames[ipu_no]);
    return 0;
}

/* IPU پƤȤ˸ƤФ */
int
ipu_load(int ipu_no, double load)
{
    if (ipu_no >= 0 && ipu_no < MAX_IPUS) {
	ipu_loads[ipu_no] = load;
    } else {
	printf("load: ipu_id=%d %3.2f\n", ipu_no, load);
	return -1;
    }
    return 0;
}

static void
popup_ipustat(int ipu_no, char *ipu_hostname)
{
    Widget popup;
    Widget frame;
    Widget frame2;
    Widget load;

    popup = XtVaCreatePopupShell("ipustat", topLevelShellWidgetClass, toplevel,
				 NULL);
    frame = XtVaCreateManagedWidget("frame", boxWidgetClass, popup, NULL);
    frame2 = XtVaCreateManagedWidget("frame2", boxWidgetClass, frame, NULL);
    XtVaCreateManagedWidget("hostlabel", labelWidgetClass, frame2, NULL);
    XtVaCreateManagedWidget("hostname", labelWidgetClass, frame2,
			    XtNlabel, ipu_hostname,
			    NULL);
    XtVaCreateManagedWidget("loadlabel", labelWidgetClass, frame,
			    NULL);
    load = XtVaCreateManagedWidget("load", stripChartWidgetClass, frame,
				   NULL);
    XtAddCallback(load, XtNgetValue, get_load, (XtPointer)ipu_no);
    XtPopup(popup, XtGrabNone);
}

/* strip chart ΥХå */
static void
get_load(Widget w, XtPointer closure, XtPointer call_data)
/*ARGSUSED*/
{
    double *loadavg = (double *)call_data;
    int ipu_no = (int)closure;

    *loadavg = ipu_loads[ipu_no];
}

/* ⥸塼뤬äȤ˸ƤФ */
int
module_done_time(int ipu_no, int jobid, int sec, int usec)
/*ARGSUSED*/
{
#ifdef DEBUG
    if (ipu_no >= 0) {
	printf("module done at ipu %d: %-8s %2d[sec] %06d[usec]\n",
	       ipu_no, ipu_hostnames[ipu_no], sec, usec);
    } else {
	printf("module done at om: id = %d,     %2d[sec] %06d[usec]\n",
	       jobid, sec, usec);
    }
#endif
    return 0;
}
